/* backend.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_backend
#endif
#define MODULE module_backend
#define LOAD() module_cenv(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_cenv(void); /* cenv.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_ce_2Dadd_2Dconst; /* ce-add-const */
extern obj cx_ce_2Dadd_2Dtype; /* ce-add-type */
extern obj cx_ce_2Dbind_2Dx; /* ce-bind-x */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_lookup_2Dfmap; /* lookup-fmap */
obj cx_C_2Dcollect_2Dargs; /* C-collect-args */
obj cx_be_2Dload_2Dtype; /* be-load-type */
obj cx_be_2Dout_2Dtype_2A; /* be-out-type* */
obj cx_complex_2D_3Eback_2Dend; /* complex->back-end */
obj cx_emit_2Dback_2Dend; /* emit-back-end */
obj cx_machine_2D_2A_2D_2A; /* machine-*-* */
static obj cx__2312; /* constant #12 */
static obj cx__2320; /* constant #20 */
static obj cx__233; /* constant #3 */
static obj cx__2333; /* constant #33 */
static obj cx__2362; /* constant #62 */
static obj cx__2366; /* constant #66 */
static obj cx__2369; /* constant #69 */
static obj cx__2372; /* constant #72 */
static obj cx__2375; /* constant #75 */
static obj cx__2378; /* constant #78 */
static obj cx__2381; /* constant #81 */
static obj cx__2384; /* constant #84 */

/* gc roots */
static obj *globv[] = {
  &cx__2312,
  &cx__2320,
  &cx__233,
  &cx__2333,
  &cx__2362,
  &cx__2366,
  &cx__2369,
  &cx__2372,
  &cx__2375,
  &cx__2378,
  &cx__2381,
  &cx__2384,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[35] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 16
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__233 = (hpushstr(0, newstring("Back end transformer not found")));
    cx__2312 = (hpushstr(0, newstring("Code emitter not found")));
    cx__2320 = (hpushstr(0, newstring("Unknown operation ~a in be-op-type*")));
    cx__2333 = (hpushstr(0, newstring("Unknown load operation ~a in be-load-type")));
    cx__2362 = (hpushstr(0, newstring("int")));
    cx__2366 = (hpushstr(0, newstring("unsigned char *")));
    cx__2369 = (hpushstr(0, newstring("float")));
    cx__2372 = (hpushstr(0, newstring("double")));
    cx__2375 = (hpushstr(0, newstring("vector float")));
    cx__2378 = (hpushstr(0, newstring("vector double")));
    cx__2381 = (hpushstr(0, newstring("float _Complex")));
    cx__2384 = (hpushstr(0, newstring("double _Complex")));
    { static obj c[] = { obj_from_case(1) }; cx_complex_2D_3Eback_2Dend = (obj)c; }
    { static obj c[] = { obj_from_case(5) }; cx_emit_2Dback_2Dend = (obj)c; }
    { static obj c[] = { obj_from_case(9) }; cx_be_2Dout_2Dtype_2A = (obj)c; }
    { static obj c[] = { obj_from_case(12) }; cx_be_2Dload_2Dtype = (obj)c; }
    { static obj c[] = { obj_from_case(15) }; cx_C_2Dcollect_2Dargs = (obj)c; }
    { static obj c[] = { obj_from_case(18) }; cx_machine_2D_2A_2D_2A = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* complex->back-end k ast env */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k ast env */
    hreserve(hbsz(3+1), 3); /* 3 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(2);
    r[3] = (hendblk(3+1));
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(3);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(0+1), 5); /* 5 live regs */
    *--hp = obj_from_case(4);
    r[5] = (hendblk(0+1));
    r[6+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = r[2];  
    r[6+3] = (mksymbol(internsym("back-end")));
    r[6+4] = (r[4]);
    r[6+5] = (r[5]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 2: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r env ast k */
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[3];  
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 3: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 4: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__233);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 5: /* emit-back-end k ast env */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k ast env */
    hreserve(hbsz(3+1), 3); /* 3 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(6);
    r[3] = (hendblk(3+1));
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(7);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(0+1), 5); /* 5 live regs */
    *--hp = obj_from_case(8);
    r[5] = (hendblk(0+1));
    r[6+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = r[2];  
    r[6+3] = (mksymbol(internsym("be-emit")));
    r[6+4] = (r[4]);
    r[6+5] = (r[5]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 6: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r env ast k */
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[3];  
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 7: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 8: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__2312);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 9: /* be-out-type* k env name */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k env name */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("be-op-type*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(10);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(11);
    r[5] = (hendblk(1+1));
    r[6+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[1];  
    r[6+3] = r[3];  
    r[6+4] = r[4];  
    r[6+5] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 10: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 11: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k name */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__2320);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 12: /* be-load-type k env load-op */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k env load-op */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("be-load-type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(13);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(14);
    r[5] = (hendblk(1+1));
    r[6+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[1];  
    r[6+3] = r[3];  
    r[6+4] = r[4];  
    r[6+5] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 13: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 14: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k load-op */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__2333);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 15: /* C-collect-args k arg-name* arg-type* new-var env */
    assert(rc == 6);
    r += 1; /* shift reg. wnd */
gs_C_2Dcollect_2Dargs: /* k arg-name* arg-type* new-var env */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(5+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = obj_from_case(16);
    r[5] = (hendblk(5+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  }

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r env new-var arg-name* k arg-type* */
    r[7] = (car((r[6])));
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(17);
    r[8] = (hendblk(4+1));
    r[0] = (cx_ce_2Dbind_2Dx);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    /* r[2] */    
    r[3] = (mksymbol(internsym("back-end")));
    r[4] = (car((r[4])));
    r[5] = (r[7]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 17: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-var arg-type* arg-name* k */
    r[6+0] = r[5];  
    r[6+1] = (cdr((r[4])));
    r[6+2] = (cdr((r[3])));
    r[6+3] = r[2];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_C_2Dcollect_2Dargs;

case 18: /* machine-*-* k pointer-size pointer-align env op* load* */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k pointer-size pointer-align env op* load* */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(19);
    r[6] = (hendblk(5+1));
    r[7+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[3];  
    r[7+3] = (mksymbol(internsym("int")));
    r[7+4] = (cx__2362);
    r[7+5] = obj_from_fixnum(4);
    r[7+6] = obj_from_fixnum(4);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 19: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r pointer-align pointer-size load* op* k */
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(20);
    r[7] = (hendblk(3+1));
    r[8+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[1];  
    r[8+3] = (mksymbol(internsym("pointer")));
    r[8+4] = (cx__2366);
    r[8+5] = (r[3]);
    r[8+6] = (r[2]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(21);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("float")));
    r[6+4] = (cx__2369);
    r[6+5] = obj_from_fixnum(4);
    r[6+6] = obj_from_fixnum(4);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 21: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(22);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("double")));
    r[6+4] = (cx__2372);
    r[6+5] = obj_from_fixnum(8);
    r[6+6] = obj_from_fixnum(8);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 22: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(23);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("vector-float")));
    r[6+4] = (cx__2375);
    r[6+5] = obj_from_fixnum(8);
    r[6+6] = obj_from_fixnum(8);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 23: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(24);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("vector-double")));
    r[6+4] = (cx__2378);
    r[6+5] = obj_from_fixnum(16);
    r[6+6] = obj_from_fixnum(16);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 24: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(25);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("complex-float")));
    r[6+4] = (cx__2381);
    r[6+5] = obj_from_fixnum(8);
    r[6+6] = obj_from_fixnum(8);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 25: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(26);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dtype);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("complex-double")));
    r[6+4] = (cx__2384);
    r[6+5] = obj_from_fixnum(16);
    r[6+6] = obj_from_fixnum(16);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 26: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(27);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dconst);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("*colors*")));
    r[6+4] = obj_from_fixnum(3);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 27: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(28);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dconst);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("*dim*")));
    r[6+4] = obj_from_fixnum(4);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 28: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(29);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dconst);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("*fermion-dim*")));
    r[6+4] = obj_from_fixnum(4);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 29: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(30);
    r[5] = (hendblk(3+1));
    r[6+0] = (cx_ce_2Dadd_2Dconst);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[6+4] = obj_from_fixnum(2);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 30: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r load* op* k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = r[3];  
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;

case 31: /* clo k env op* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k env op* load* */
  if ((isnull((r[2])))) {
    /* r[0] */    
    /* r[1] */    
    r[2] = r[3];  
    goto s_loop_v326;
  } else {
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(31);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(34);
    r[4] = (hendblk(3+1));
    r[5] = (car((r[2])));
    r[5] = (car((r[5])));
    r[6] = (car((r[2])));
    r[6] = (cdr((r[6])));
    r[7+0] = (cx_ce_2Dbind_2Dx);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[4];  
    r[7+2] = r[1];  
    r[7+3] = (mksymbol(internsym("be-op-type*")));
    r[7+4] = (r[5]);
    r[7+5] = (r[6]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 32: /* clo k env load* */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
s_loop_v326: /* k env load* */
  if ((isnull((r[2])))) {
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[1];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(0+1), 3); /* 3 live regs */
    *--hp = obj_from_case(32);
    r[3] = (hendblk(0+1));
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(33);
    r[3] = (hendblk(3+1));
    r[4] = (car((r[2])));
    r[4] = (car((r[4])));
    r[5] = (car((r[2])));
    r[5] = (cdr((r[5])));
    r[5] = (car((r[5])));
    r[6+0] = (cx_ce_2Dbind_2Dx);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("be-load-type")));
    r[6+4] = (r[4]);
    r[6+5] = (r[5]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 33: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop load* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = (cdr((r[3])));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 34: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop op* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = (cdr((r[3])));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
