/* cenv.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_cenv
#endif
#define MODULE module_cenv
#define LOAD() module_fmap(); module_ast(); module_basis(); module_format(); module_print(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_print(void); /* print.ss */
extern void module_format(void); /* format.ss */
extern void module_basis(void); /* basis.ss */
extern void module_ast(void); /* ast.ss */
extern void module_fmap(void); /* fmap.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_extend_2Dfmap; /* extend-fmap */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_lookup_2Dfmap; /* lookup-fmap */
extern obj cx_s_2Derror_2A; /* s-error* */
obj cx_ce_2Dadd_2Dalias; /* ce-add-alias */
obj cx_ce_2Dadd_2Darray; /* ce-add-array */
obj cx_ce_2Dadd_2Dconst; /* ce-add-const */
obj cx_ce_2Dadd_2Dmacro; /* ce-add-macro */
obj cx_ce_2Dadd_2Dparam; /* ce-add-param */
obj cx_ce_2Dadd_2Dparam_2A; /* ce-add-param* */
obj cx_ce_2Dadd_2Dqcd_2Dtype; /* ce-add-qcd-type */
obj cx_ce_2Dadd_2Dstruct; /* ce-add-struct */
obj cx_ce_2Dadd_2Dtype; /* ce-add-type */
obj cx_ce_2Dbgl; /* ce-bgl */
obj cx_ce_2Dbind; /* ce-bind */
obj cx_ce_2Dbind_2Dx; /* ce-bind-x */
obj cx_ce_2Dsearch_2Dx; /* ce-search-x */
static obj cx__23101; /* constant #101 */
static obj cx__23111; /* constant #111 */
static obj cx__23130; /* constant #130 */
static obj cx__23156; /* constant #156 */
static obj cx__23167; /* constant #167 */
static obj cx__23204; /* constant #204 */
static obj cx__23211; /* constant #211 */
static obj cx__23221; /* constant #221 */
static obj cx__23224; /* constant #224 */
static obj cx__23233; /* constant #233 */
static obj cx__23242; /* constant #242 */
static obj cx__23251; /* constant #251 */
static obj cx__23260; /* constant #260 */
static obj cx__23281; /* constant #281 */
static obj cx__23327; /* constant #327 */
static obj cx__23358; /* constant #358 */
static obj cx__23379; /* constant #379 */
static obj cx__23386; /* constant #386 */
static obj cx__23398; /* constant #398 */
static obj cx__23401; /* constant #401 */
static obj cx__23404; /* constant #404 */
static obj cx__23407; /* constant #407 */
static obj cx__23410; /* constant #410 */
static obj cx__23413; /* constant #413 */
static obj cx__23416; /* constant #416 */
static obj cx__23419; /* constant #419 */
static obj cx__2361; /* constant #61 */
static obj cx__2388; /* constant #88 */

/* gc roots */
static obj *globv[] = {
  &cx__23101,
  &cx__23111,
  &cx__23130,
  &cx__23156,
  &cx__23167,
  &cx__23204,
  &cx__23211,
  &cx__23221,
  &cx__23224,
  &cx__23233,
  &cx__23242,
  &cx__23251,
  &cx__23260,
  &cx__23281,
  &cx__23327,
  &cx__23358,
  &cx__23379,
  &cx__23386,
  &cx__23398,
  &cx__23401,
  &cx__23404,
  &cx__23407,
  &cx__23410,
  &cx__23413,
  &cx__23416,
  &cx__23419,
  &cx__2361,
  &cx__2388,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[111] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 24
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__2361 = (hpushstr(0, newstring("Rebinding ~a to ~a is not allowed, old binding ~a")));
    cx__2388 = (hpushstr(0, newstring("Redefining type ~a is not allowed")));
    cx__23101 = (hpushstr(0, newstring("Alignment of array base ~a")));
    cx__23111 = (hpushstr(0, newstring("Size of array base ~a")));
    cx__23130 = (hpushstr(0, newstring("Redefining array ~a is not allowed")));
    cx__23156 = (hpushstr(0, newstring("Alignment of ~a.~a")));
    cx__23167 = (hpushstr(0, newstring("Size of field ~a.~a")));
    cx__23204 = (hpushstr(0, newstring("Redefining structure ~a is not allowed")));
    cx__23211 = (hpushstr(0, newstring("type of ~a")));
    cx__23221 = (hpushstr(0, newstring("Unexpected type for aliasing: ~a")));
    cx__23224 = (hpushstr(0, newstring("components of ~a")));
    cx__23233 = (hpushstr(0, newstring("size of ~a")));
    cx__23242 = (hpushstr(0, newstring("align of ~a")));
    cx__23251 = (hpushstr(0, newstring("C name of ~a")));
    cx__23260 = (hpushstr(0, newstring("True name of ~a")));
    cx__23281 = (hpushstr(0, newstring("offset of ~a in ~a")));
    cx__23327 = (hpushstr(0, newstring("value of ~a")));
    cx__23358 = (hpushstr(0, newstring("(const ~a)")));
    cx__23379 = (hpushstr(0, newstring("(align-of COMPLEX)")));
    cx__23386 = (hpushstr(0, newstring("(size-of COMPLEX)")));
    cx__23398 = (hpushstr(0, newstring("int")));
    cx__23401 = (hpushstr(0, newstring("void *")));
    cx__23404 = (hpushstr(0, newstring("float")));
    cx__23407 = (hpushstr(0, newstring("double")));
    cx__23410 = (hpushstr(0, newstring("vector float")));
    cx__23413 = (hpushstr(0, newstring("vector double")));
    cx__23416 = (hpushstr(0, newstring("float _Complex")));
    cx__23419 = (hpushstr(0, newstring("double _Complex")));
    { static obj c[] = { obj_from_case(1) }; cx_ce_2Dsearch_2Dx = (obj)c; }
    { static obj c[] = { obj_from_case(2) }; cx_ce_2Dbind = (obj)c; }
    { static obj c[] = { obj_from_case(3) }; cx_ce_2Dbind_2Dx = (obj)c; }
    { static obj c[] = { obj_from_case(4) }; cx_ce_2Dadd_2Dparam = (obj)c; }
    { static obj c[] = { obj_from_case(6) }; cx_ce_2Dadd_2Dparam_2A = (obj)c; }
    { static obj c[] = { obj_from_case(8) }; cx_ce_2Dadd_2Dconst = (obj)c; }
    { static obj c[] = { obj_from_case(12) }; cx_ce_2Dadd_2Dtype = (obj)c; }
    { static obj c[] = { obj_from_case(20) }; cx_ce_2Dadd_2Darray = (obj)c; }
    { static obj c[] = { obj_from_case(34) }; cx_ce_2Dadd_2Dstruct = (obj)c; }
    { static obj c[] = { obj_from_case(50) }; cx_ce_2Dadd_2Dalias = (obj)c; }
    { static obj c[] = { obj_from_case(84) }; cx_ce_2Dadd_2Dmacro = (obj)c; }
    { static obj c[] = { obj_from_case(86) }; cx_ce_2Dadd_2Dqcd_2Dtype = (obj)c; }
    { static obj c[] = { obj_from_case(99) }; cx_ce_2Dbgl = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* ce-search-x k env type key k-found k-missed */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k env type key k-found k-missed */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[6];  
    r[7+4] = r[4];  
    r[7+5] = r[5];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 2: /* ce-bind k env k v */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_ce_2Dbind: /* k env k v */
    r[4+0] = (cx_extend_2Dfmap);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = r[1];  
    r[4+3] = r[2];  
    r[4+4] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 3: /* ce-bind-x k env t k v */
    assert(rc == 6);
    r += 1; /* shift reg. wnd */
gs_ce_2Dbind_2Dx: /* k env t k v */
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_extend_2Dfmap);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[1];  
    r[6+3] = r[5];  
    r[6+4] = r[4];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 4: /* ce-add-param k env name value */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_ce_2Dadd_2Dparam: /* k env name value */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(5);
    r[4] = (hendblk(3+1));
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("type")));
    r[5+3] = (r[2]);
    r[5+4] = (mksymbol(internsym("param")));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 5: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r value name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("param")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 6: /* ce-add-param* k env name* value* */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_ce_2Dadd_2Dparam_2A: /* k env name* value* */
  if ((isnull((r[2])))) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(7);
    r[4] = (hendblk(3+1));
    r[0] = r[4];  
    /* r[1] */    
    r[2] = (car((r[2])));
    r[3] = (car((r[3])));
    goto gs_ce_2Dadd_2Dparam;
  }

case 7: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r value* name* k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (cdr((r[3])));
    r[5+3] = (cdr((r[2])));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dparam_2A;

case 8: /* ce-add-const k env name value */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_ce_2Dadd_2Dconst: /* k env name value */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(9);
    r[5] = (hendblk(2+1));
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(10);
    r[6] = (hendblk(4+1));
    r[7+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[4];  
    r[7+4] = r[5];  
    r[7+5] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 9: /* clo k v */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k v name value */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (cx__2361);
    r[5+3] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 10: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3];
    r[1+4] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k t env value name */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(11);
    r[5] = (hendblk(3+1));
    r[6+0] = r[5];  
    r[6+1] = r[2];  
    r[6+2] = r[1];  
    r[6+3] = (mksymbol(internsym("const")));
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind;

case 11: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r value name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("const")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 12: /* ce-add-type k env name c-name size align */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
gs_ce_2Dadd_2Dtype: /* k env name c-name size align */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(13);
    r[7] = (hendblk(1+1));
    hreserve(hbsz(6+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = obj_from_case(14);
    r[8] = (hendblk(6+1));
    r[9+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[6];  
    r[9+4] = r[7];  
    r[9+5] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 13: /* clo k ignore */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k ignore name */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (cx__2388);
    r[4+3] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 14: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3];
    r[1+4] = p[4];
    r[1+5] = p[5];
    r[1+6] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k t env size align c-name name */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(15);
    r[7] = (hendblk(5+1));
    r[8+0] = r[7];  
    r[8+1] = r[2];  
    r[8+2] = r[1];  
    r[8+3] = (mksymbol(internsym("type")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind;

case 15: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r size align c-name name k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(16);
    r[7] = (hendblk(4+1));
    r[8+0] = r[7];  
    r[8+1] = r[1];  
    r[8+2] = (mksymbol(internsym("size-of")));
    r[8+3] = (r[5]);
    r[8+4] = (r[2]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r align c-name name k */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(17);
    r[6] = (hendblk(3+1));
    r[7+0] = r[6];  
    r[7+1] = r[1];  
    r[7+2] = (mksymbol(internsym("align-of")));
    r[7+3] = (r[4]);
    r[7+4] = (r[2]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 17: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(18);
    r[5] = (hendblk(3+1));
    r[0] = r[5];  
    /* r[1] */    
    r[2] = (mksymbol(internsym("components")));
    r[3] = (r[3]);
    r[4] = (mknull());
    goto gs_ce_2Dbind_2Dx;

case 18: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(19);
    r[5] = (hendblk(3+1));
    r[6+0] = r[5];  
    r[6+1] = r[1];  
    r[6+2] = (mksymbol(internsym("aliased-to")));
    r[6+3] = (r[3]);
    r[6+4] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 19: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("name-of")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 20: /* ce-add-array k env name c-name base size */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k env name c-name base size */
    hreserve(hbsz(6+1), 6); /* 6 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(21);
    r[6] = (hendblk(6+1));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("align-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(32);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(33);
    r[9] = (hendblk(1+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[1];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 21: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r base size c-name env k name */
    hreserve(hbsz(6+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_case(22);
    r[8] = (hendblk(6+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(30);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(31);
    r[11] = (hendblk(1+1));
    r[12+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[8];  
    r[12+2] = r[5];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 22: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r size r c-name env k name */
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(23);
    r[9] = (hendblk(1+1));
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = obj_from_case(24);
    r[10] = (hendblk(7+1));
    r[11+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[6];  
    r[11+2] = r[5];  
    r[11+3] = r[8];  
    r[11+4] = r[9];  
    r[11+5] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 23: /* clo k ignore */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k ignore name */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (cx__23130);
    r[4+3] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 24: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3];
    r[1+4] = p[4];
    r[1+5] = p[5];
    r[1+6] = p[6];
    r[1+7] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k t env size r r c-name name */
    hreserve(hbsz(6+1), 8); /* 8 live regs */
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(25);
    r[8] = (hendblk(6+1));
    r[9+0] = r[8];  
    r[9+1] = r[2];  
    r[9+2] = r[1];  
    r[9+3] = (mksymbol(internsym("array")));
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind;

case 25: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r size r r c-name name k */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(26);
    r[8] = (hendblk(4+1));
    r[9+0] = r[8];  
    r[9+1] = r[1];  
    r[9+2] = (mksymbol(internsym("size-of")));
    r[9+3] = (r[6]);
    r[9+4] = obj_from_fixnum(fixnum_from_obj(r[2]) * fixnum_from_obj(r[3]));
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 26: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r r c-name name k */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(27);
    r[6] = (hendblk(3+1));
    r[7+0] = r[6];  
    r[7+1] = r[1];  
    r[7+2] = (mksymbol(internsym("align-of")));
    r[7+3] = (r[4]);
    r[7+4] = (r[2]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 27: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(28);
    r[5] = (hendblk(3+1));
    r[0] = r[5];  
    /* r[1] */    
    r[2] = (mksymbol(internsym("components")));
    r[3] = (r[3]);
    r[4] = (mknull());
    goto gs_ce_2Dbind_2Dx;

case 28: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(29);
    r[5] = (hendblk(3+1));
    r[6+0] = r[5];  
    r[6+1] = r[1];  
    r[6+2] = (mksymbol(internsym("aliased-to")));
    r[6+3] = (r[3]);
    r[6+4] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 29: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("name-of")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 30: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 31: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k base */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23111);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 32: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 33: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k base */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23101);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 34: /* ce-add-struct k env name c-name field* type* */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k env name c-name field* type* */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(35);
    r[7] = (hendblk(1+1));
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(36);
    r[8] = (hendblk(5+1));
    r[9+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[6];  
    r[9+4] = r[7];  
    r[9+5] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 35: /* clo k ignore */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k ignore name */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (cx__23204);
    r[4+3] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 36: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3];
    r[1+4] = p[4];
    r[1+5] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k c-name name type* field* env */
    r[6+0] = r[0];  
    r[6+1] = r[5];  
    r[6+2] = r[4];  
    r[6+3] = r[3];  
    r[6+4] = obj_from_fixnum(0);
    r[6+5] = obj_from_fixnum(1);
    r[6+6] = r[4];  
    r[6+7] = r[1];  
    r[6+8] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;

case 37: /* clo k env f* t* size align */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k env f* t* size align field* c-name name */
  if ((isnull((r[2])))) {
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(38);
    r[9] = (hendblk(6+1));
    r[0] = r[9];  
    /* r[1] */    
    r[2] = (mksymbol(internsym("type")));
    r[3] = (r[8]);
    r[4] = (mksymbol(internsym("struct")));
    goto gs_ce_2Dbind_2Dx;
  } else {
    r[9] = (car((r[2])));
    r[10] = (car((r[3])));
    hreserve(hbsz(3+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(37);
    r[11] = (hendblk(3+1));
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[10]);
    *--hp = obj_from_case(43);
    r[11] = (hendblk(10+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("align-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(48);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = obj_from_case(49);
    r[14] = (hendblk(2+1));
    r[15+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[11]);
    r[15+2] = r[1];  
    r[15+3] = (r[12]);
    r[15+4] = (r[13]);
    r[15+5] = (r[14]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 38: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r size align field* c-name name k */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(39);
    r[8] = (hendblk(5+1));
    r[9+0] = r[8];  
    r[9+1] = r[1];  
    r[9+2] = (mksymbol(internsym("size-of")));
    r[9+3] = (r[6]);
    r[9+4] = (r[2]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 39: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r align field* c-name name k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(40);
    r[7] = (hendblk(4+1));
    r[8+0] = r[7];  
    r[8+1] = r[1];  
    r[8+2] = (mksymbol(internsym("align-of")));
    r[8+3] = (r[5]);
    r[8+4] = (r[2]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 40: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r field* c-name name k */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(41);
    r[6] = (hendblk(3+1));
    r[7+0] = r[6];  
    r[7+1] = r[1];  
    r[7+2] = (mksymbol(internsym("components")));
    r[7+3] = (r[4]);
    r[7+4] = (r[2]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 41: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(42);
    r[5] = (hendblk(3+1));
    r[6+0] = r[5];  
    r[6+1] = r[1];  
    r[6+2] = (mksymbol(internsym("aliased-to")));
    r[6+3] = (r[3]);
    r[6+4] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 42: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r c-name name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("name-of")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 43: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r t name f env loop align t* f* k size */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(44);
    r[12] = (hendblk(10+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(46);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(47);
    r[15] = (hendblk(2+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[5];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 44: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r name f env loop align t* f* k size r */
    r[12] = obj_from_fixnum(fixnum_from_obj(r[11]) * ((fixnum_from_obj(r[10]) + (fixnum_from_obj(r[11]) + (-1))) / fixnum_from_obj(r[11])));
    hreserve(hbsz(8+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[5];  
    *--hp = obj_from_case(45);
    r[13] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("offset-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    r[0] = (r[13]);
    r[1] = r[4];  
    r[2] = (r[14]);
    r[3] = (r[12]);
    goto gs_ce_2Dbind;

case 45: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop r align start r t* f* k */
    r[10+0] = r[2];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = r[1];  
    r[10+3] = (cdr((r[8])));
    r[10+4] = (cdr((r[7])));
    r[10+5] = obj_from_fixnum(fixnum_from_obj(r[5]) + fixnum_from_obj(r[6]));
    r[10+6] = ((fixnum_from_obj(r[3]) > fixnum_from_obj(r[4])) ? (r[3]) : (r[4]));
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 46: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 47: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k name f */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (mksymbol(internsym("ce-lookup-x")));
    r[4+3] = (cx__23167);
    r[4+4] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 48: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 49: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k name f */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (mksymbol(internsym("ce-lookup-x")));
    r[4+3] = (cx__23156);
    r[4+4] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 50: /* ce-add-alias k env new old */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k env new old */
    hreserve(hbsz(4+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_case(51);
    r[4] = (hendblk(4+1));
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("type")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    hreserve(hbsz(0+1), 6); /* 6 live regs */
    *--hp = obj_from_case(82);
    r[6] = (hendblk(0+1));
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(83);
    r[7] = (hendblk(1+1));
    r[8+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[4];  
    r[8+2] = r[1];  
    r[8+3] = r[5];  
    r[8+4] = r[6];  
    r[8+5] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 51: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r old env new k */
  if (((((r[1]) == (mksymbol(internsym("const")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("const")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("const"))))))) && (1))) {
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(52);
    r[6] = (hendblk(4+1));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(54);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(55);
    r[9] = (hendblk(1+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[3];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  } else {
  if (((((r[1]) == (mksymbol(internsym("type")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("type")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("type"))))))) ? (1) : ((((r[1]) == (mksymbol(internsym("array")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("array")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("array"))))))) ? (1) : ((((r[1]) == (mksymbol(internsym("struct")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("struct")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("struct"))))))) && (1))))) {
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(56);
    r[6] = (hendblk(5+1));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("components")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(80);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(81);
    r[9] = (hendblk(1+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[3];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[5];  
    r[7+2] = (cx__23221);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }

case 52: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env new k */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = obj_from_case(53);
    r[6] = (hendblk(3+1));
    r[7+0] = r[6];  
    r[7+1] = r[3];  
    r[7+2] = (mksymbol(internsym("type")));
    r[7+3] = (r[4]);
    r[7+4] = (r[2]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 53: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r r new k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("const")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 54: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 55: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23327);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 56: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env old new k */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(57);
    r[7] = (hendblk(6+1));
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(78);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(1+1), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(79);
    r[10] = (hendblk(1+1));
    r[11+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[7];  
    r[11+2] = r[3];  
    r[11+3] = r[8];  
    r[11+4] = r[9];  
    r[11+5] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 57: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env old new r k */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(58);
    r[8] = (hendblk(7+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("align-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(76);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(77);
    r[11] = (hendblk(1+1));
    r[12+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[8];  
    r[12+2] = r[3];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 58: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env r old new r k */
    hreserve(hbsz(8+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(59);
    r[9] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("name-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(74);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(75);
    r[12] = (hendblk(1+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[3];  
    r[3] = (r[10]);
    r[4] = (r[11]);
    r[5] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 59: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env r r old new r k */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(60);
    r[10] = (hendblk(9+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("aliased-to")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(72);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = obj_from_case(73);
    r[13] = (hendblk(1+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[3];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 60: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r r env r r r old new r k */
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(61);
    r[11] = (hendblk(8+1));
    r[12+0] = (r[11]);
    r[12+1] = r[3];  
    r[12+2] = (mksymbol(internsym("type")));
    r[12+3] = (r[8]);
    r[12+4] = (r[2]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 61: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r r r old new r k */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(62);
    r[10] = (hendblk(7+1));
    r[11+0] = (r[10]);
    r[11+1] = r[1];  
    r[11+2] = (mksymbol(internsym("size-of")));
    r[11+3] = (r[7]);
    r[11+4] = (r[2]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 62: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r r old new r k */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(63);
    r[9] = (hendblk(6+1));
    r[10+0] = r[9];  
    r[10+1] = r[1];  
    r[10+2] = (mksymbol(internsym("align-of")));
    r[10+3] = (r[6]);
    r[10+4] = (r[2]);
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 63: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r old new r k */
    hreserve(hbsz(6+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(64);
    r[8] = (hendblk(6+1));
    r[0] = r[8];  
    /* r[1] */    
    r[2] = (mksymbol(internsym("components")));
    r[3] = (r[5]);
    r[4] = (r[6]);
    goto gs_ce_2Dbind_2Dx;

case 64: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r old new r k */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(65);
    r[8] = (hendblk(5+1));
    r[9+0] = r[8];  
    r[9+1] = r[1];  
    r[9+2] = (mksymbol(internsym("aliased-to")));
    r[9+3] = (r[5]);
    r[9+4] = (r[2]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 65: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r r old new r k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(66);
    r[7] = (hendblk(4+1));
    r[8+0] = r[7];  
    r[8+1] = r[1];  
    r[8+2] = (mksymbol(internsym("name-of")));
    r[8+3] = (r[4]);
    r[8+4] = (r[2]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 66: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r old new r k */
    r[6+0] = r[5];  
    r[6+1] = r[4];  
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v1165;

case 67: /* clo k c env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v1165: /* k c env old new */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(67);
    r[5] = (hendblk(2+1));
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(68);
    r[5] = (hendblk(5+1));
    r[6] = (car((r[1])));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("offset-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    hreserve(hbsz(0+1), 7); /* 7 live regs */
    *--hp = obj_from_case(70);
    r[7] = (hendblk(0+1));
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(71);
    r[8] = (hendblk(2+1));
    r[9+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[5];  
    r[9+2] = r[2];  
    r[9+3] = r[6];  
    r[9+4] = r[7];  
    r[9+5] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 68: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r new env loop c k */
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(69);
    r[7] = (hendblk(3+1));
    r[8] = (car((r[5])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("offset-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[9+0] = r[7];  
    r[9+1] = r[3];  
    r[9+2] = r[8];  
    r[9+3] = r[1];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind;

case 69: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop c k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = (cdr((r[3])));
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 70: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 71: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c old */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4] = (car((r[1])));
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (mksymbol(internsym("ce-lookup")));
    r[4+3] = (cx__23281);
    r[4+4] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 72: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 73: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23260);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 74: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 75: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23251);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 76: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 77: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23242);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 78: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 79: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23233);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 80: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 81: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23224);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 82: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 83: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k old */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23211);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 84: /* ce-add-macro k env name value */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k env name value */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(85);
    r[4] = (hendblk(3+1));
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("type")));
    r[5+3] = (r[2]);
    r[5+4] = (mksymbol(internsym("macro")));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 85: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r value name k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = (mksymbol(internsym("macro")));
    r[5+3] = (r[3]);
    r[5+4] = (r[2]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dbind_2Dx;

case 86: /* ce-add-qcd-type k env name c-name a-dim b-dim */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k env name c-name a-dim b-dim */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = obj_from_case(87);
    r[6] = (hendblk(5+1));
  if (((is_fixnum_obj(r[5])) || (is_flonum_obj(r[5])))) {
    r[7+0] = obj_from_ktrap();
    r[7+1] = r[5];  
    r[7+2] = r[4];  
    r[7+3] = r[3];  
    r[7+4] = r[2];  
    r[7+5] = r[1];  
    r[7+6] = r[0];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v998;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(97);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(98);
    r[9] = (hendblk(1+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[1];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 87: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
s_l_v998: /* ek r a-dim c-name name env k */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(88);
    r[7] = (hendblk(5+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[8+0] = obj_from_ktrap();
    r[8+1] = r[2];  
    r[8+2] = r[1];  
    r[8+3] = r[3];  
    r[8+4] = r[4];  
    r[8+5] = r[5];  
    r[8+6] = r[6];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v1010;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(95);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(1+1), 10); /* 10 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(96);
    r[10] = (hendblk(1+1));
    r[11+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[7];  
    r[11+2] = r[5];  
    r[11+3] = r[8];  
    r[11+4] = r[9];  
    r[11+5] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 88: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
s_l_v1010: /* ek r r c-name name env k */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_case(89);
    r[7] = (hendblk(6+1));
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(93);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(94);
    r[10] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[5];  
    r[3] = r[8];  
    r[4] = r[9];  
    r[5] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 89: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r c-name name env k */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(90);
    r[8] = (hendblk(7+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("align-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(91);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(92);
    r[11] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[6];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 90: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r r c-name name env k */
    r[9+0] = r[8];  
    r[9+1] = r[7];  
    r[9+2] = r[6];  
    r[9+3] = r[5];  
    r[9+4] = obj_from_fixnum(fixnum_from_obj(r[2]) * (fixnum_from_obj(r[3]) * fixnum_from_obj(r[4])));
    r[9+5] = r[1];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 91: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 92: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23379);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 93: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 94: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23386);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 95: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 96: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k a-dim */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23358);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 97: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 98: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k b-dim */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23358);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 99: /* ce-bgl k env */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k env */
    hreserve(hbsz(1+1), 2); /* 2 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(100);
    r[2] = (hendblk(1+1));
    r[3+0] = r[2];  
    r[3+1] = r[1];  
    r[3+2] = (mksymbol(internsym("int")));
    r[3+3] = (cx__23398);
    r[3+4] = obj_from_fixnum(4);
    r[3+5] = obj_from_fixnum(4);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 100: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(101);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("pointer")));
    r[4+3] = (cx__23401);
    r[4+4] = obj_from_fixnum(4);
    r[4+5] = obj_from_fixnum(4);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 101: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(102);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("float")));
    r[4+3] = (cx__23404);
    r[4+4] = obj_from_fixnum(4);
    r[4+5] = obj_from_fixnum(4);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 102: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(103);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("double")));
    r[4+3] = (cx__23407);
    r[4+4] = obj_from_fixnum(8);
    r[4+5] = obj_from_fixnum(8);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 103: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(104);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("vector-float")));
    r[4+3] = (cx__23410);
    r[4+4] = obj_from_fixnum(8);
    r[4+5] = obj_from_fixnum(8);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 104: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(105);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("vector-double")));
    r[4+3] = (cx__23413);
    r[4+4] = obj_from_fixnum(16);
    r[4+5] = obj_from_fixnum(16);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 105: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(106);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("complex-float")));
    r[4+3] = (cx__23416);
    r[4+4] = obj_from_fixnum(8);
    r[4+5] = obj_from_fixnum(8);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 106: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(107);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("complex-double")));
    r[4+3] = (cx__23419);
    r[4+4] = obj_from_fixnum(16);
    r[4+5] = obj_from_fixnum(16);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dtype;

case 107: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(108);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("*colors*")));
    r[4+3] = obj_from_fixnum(3);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dconst;

case 108: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(109);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("*dim*")));
    r[4+3] = obj_from_fixnum(4);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dconst;

case 109: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(110);
    r[3] = (hendblk(1+1));
    r[4+0] = r[3];  
    r[4+1] = r[1];  
    r[4+2] = (mksymbol(internsym("*fermion-dim*")));
    r[4+3] = obj_from_fixnum(4);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dconst;

case 110: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    r[3+0] = r[2];  
    r[3+1] = r[1];  
    r[3+2] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[3+3] = obj_from_fixnum(2);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_ce_2Dadd_2Dconst;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
