/* cheader.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_cheader
#endif
#define MODULE module_cheader
#define LOAD() module_verbose(); module_attr(); module_cenv(); module_ast(); module_format(); module_print(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_print(void); /* print.ss */
extern void module_format(void); /* format.ss */
extern void module_ast(void); /* ast.ss */
extern void module_cenv(void); /* cenv.ss */
extern void module_attr(void); /* attr.ss */
extern void module_verbose(void); /* verbose.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx__2Acurrent_2Doutput_2Dport_2A; /* *current-output-port* */
extern obj cx_attr_2Dsearch; /* attr-search */
extern obj cx_emit_2Dverbose; /* emit-verbose */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_lookup_2Dfmap; /* lookup-fmap */
extern obj cx_q_2Dfmt_2A; /* q-fmt* */
extern obj cx_q_2Dfprint_2A; /* q-fprint* */
extern obj cx_s_2Derror_2A; /* s-error* */
obj cx_build_2Dproc_2Dname; /* build-proc-name */
obj cx_build_2Dproc_2Dtype; /* build-proc-type */
obj cx_c_2Dheader; /* c-header */
static obj cx__23100; /* constant #100 */
static obj cx__2311; /* constant #11 */
static obj cx__23120; /* constant #120 */
static obj cx__23128; /* constant #128 */
static obj cx__23263; /* constant #263 */
static obj cx__2327; /* constant #27 */
static obj cx__23272; /* constant #272 */
static obj cx__23273; /* constant #273 */
static obj cx__23276; /* constant #276 */
static obj cx__2328; /* constant #28 */
static obj cx__23284; /* constant #284 */
static obj cx__23288; /* constant #288 */
static obj cx__23292; /* constant #292 */
static obj cx__23295; /* constant #295 */
static obj cx__23298; /* constant #298 */
static obj cx__23306; /* constant #306 */
static obj cx__23320; /* constant #320 */
static obj cx__2333; /* constant #33 */
static obj cx__23330; /* constant #330 */
static obj cx__23340; /* constant #340 */
static obj cx__2338; /* constant #38 */
static obj cx__2341; /* constant #41 */
static obj cx__2349; /* constant #49 */
static obj cx__2355; /* constant #55 */
static obj cx__2369; /* constant #69 */
static obj cx__2381; /* constant #81 */
static obj cx__2391; /* constant #91 */

/* gc roots */
static obj *globv[] = {
  &cx__23100,
  &cx__2311,
  &cx__23120,
  &cx__23128,
  &cx__23263,
  &cx__2327,
  &cx__23272,
  &cx__23273,
  &cx__23276,
  &cx__2328,
  &cx__23284,
  &cx__23288,
  &cx__23292,
  &cx__23295,
  &cx__23298,
  &cx__23306,
  &cx__23320,
  &cx__2333,
  &cx__23330,
  &cx__23340,
  &cx__2338,
  &cx__2341,
  &cx__2349,
  &cx__2355,
  &cx__2369,
  &cx__2381,
  &cx__2391,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[54] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 18
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__2311 = (hpushstr(0, newstring(");~%")));
    cx__2327 = (hpushstr(0, newstring(", ")));
    cx__2328 = (hpushstr(0, newstring("")));
    cx__2333 = (hpushstr(0, newstring("~a~a ~a")));
    cx__2338 = (hpushstr(0, newstring("(")));
    cx__2341 = (hpushstr(0, newstring("(void);~%")));
    cx__2349 = (hpushstr(0, newstring("~a ~a")));
    cx__2355 = (hpushstr(0, newstring("};~%~%")));
    cx__2369 = (hpushstr(0, newstring("Missing name for type ~a")));
    cx__2381 = (hpushstr(0, newstring("  ~a ~a;~%")));
    cx__2391 = (hpushstr(0, newstring("struct ~a {~%")));
    cx__23100 = (hpushstr(0, newstring("no clause matches ~s")));
    cx__23120 = (hpushstr(0, newstring("make-c-header: Internal error: no name for ~a")));
    cx__23128 = (hpushstr(0, newstring("typedef ~a ~a[~a];~%~%")));
    cx__23263 = (hpushstr(0, newstring("short attribute ~a")));
    cx__23272 = (hpushstr(0, newstring("void")));
    cx__23273 = (hpushstr(0, newstring("unsigned int")));
    cx__23276 = (hpushstr(0, newstring("Both count-flops and return specified for ~a")));
    cx__23284 = (hpushstr(0, newstring("missing stem for ~a")));
    cx__23288 = (hpushstr(0, newstring("missing proc-suffix in CE")));
    cx__23292 = (hpushstr(0, newstring("missing proc-infix in CE")));
    cx__23295 = (hpushstr(0, newstring("missing prec-letter in CE")));
    cx__23298 = (hpushstr(0, newstring("missing *colors* in CE")));
    cx__23306 = (hpushstr(0, newstring("missing proc-prefix in CE")));
    cx__23320 = (hpushstr(0, newstring("~a_~a_")));
    cx__23330 = (hpushstr(0, newstring("~a_~a~a_~a_")));
    cx__23340 = (hpushstr(0, newstring("~a~a")));
    { static obj c[] = { obj_from_case(1) }; cx_c_2Dheader = (obj)c; }
    { static obj c[] = { obj_from_case(22) }; cx_build_2Dproc_2Dtype = (obj)c; }
    { static obj c[] = { obj_from_case(29) }; cx_build_2Dproc_2Dname = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* c-header k ast env */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k ast env */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (2))) {
    r[3] = (vectorref((r[1]), (0)));
    r[3] = obj_from_bool((r[3]) == (mksymbol(internsym("qa0-top"))));
  } else {
    r[3] = obj_from_bool(0);
  }
  } else {
    r[3] = obj_from_bool(0);
  }
  if (bool_from_obj(r[3])) {
    r[3] = (vectorref((r[1]), (1)));
    /* r[0] */    
    r[1] = r[3];  
    /* r[2] */    
    goto s_loop;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (mksymbol(internsym("variant-case")));
    r[4+3] = (cx__23100);
    r[4+4] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 2: /* clo k in* */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k in* env */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(1);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[3] = (car((r[1])));
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(2);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(3);
    r[4] = (hendblk(3+1));
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (5))) {
    r[5] = (vectorref((r[3]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("qa0-array"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[3]), (4)));
    r[6] = (vectorref((r[3]), (3)));
    r[7] = (vectorref((r[3]), (2)));
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(4);
    r[8] = (hendblk(4+1));
  if ((isvector((r[5])))) {
  if (((vectorlen((r[5]))) == (2))) {
    r[9] = (vectorref((r[5]), (0)));
    r[9] = obj_from_bool((r[9]) == (mksymbol(internsym("c-expr-number"))));
  } else {
    r[9] = obj_from_bool(0);
  }
  } else {
    r[9] = obj_from_bool(0);
  }
  if (bool_from_obj(r[9])) {
    r[9] = (vectorref((r[5]), (1)));
    r[10+0] = obj_from_ktrap();
    r[10+1] = r[9];  
    r[10+2] = r[6];  
    r[10+3] = r[2];  
    r[10+4] = r[4];  
    r[10+5] = r[7];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v943;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = (mksymbol(internsym("variant-case")));
    r[3] = (cx__23100);
    r[4] = (r[9]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  } else {
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (6))) {
    r[5] = (vectorref((r[3]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("qa0-struct"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[3]), (5)));
    r[6] = (vectorref((r[3]), (4)));
    r[7] = (vectorref((r[3]), (2)));
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = obj_from_case(8);
    r[8] = (hendblk(4+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__2391);
    r[4] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (8))) {
    r[5] = (vectorref((r[3]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("qa0-proc"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[3]), (6)));
    r[6] = (vectorref((r[3]), (5)));
    r[7] = (vectorref((r[3]), (2)));
    r[8] = (vectorref((r[3]), (1)));
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[6];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = obj_from_case(15);
    r[9] = (hendblk(6+1));
    r[10+0] = r[9];  
    r[10+1] = r[7];  
    r[10+2] = r[8];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_build_2Dproc_2Dname;
  } else {
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (3))) {
    r[5] = (vectorref((r[3]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("qa0-verbose"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[3]), (2)));
    r[6] = (vectorref((r[3]), (1)));
    r[0] = (cx_emit_2Dverbose);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (mksymbol(internsym("c-header")));
    r[3] = (r[6]);
    r[4] = (r[5]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(2);
    r[5] = (hendblk(1+1));
    r[6+0] = obj_from_ktrap();
    r[6+1] = obj_from_bool(0);
    r[6+2] = r[5];  
    r[6+3] = r[1];  
    r[6+4] = r[0];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v965;
  }
  }
  }
  }
  }

case 3: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_l_v965: /* ek  loop in* k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 4: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
s_l_v943: /* ek r base env k c-name */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = obj_from_case(5);
    r[8] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("name-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(6);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(7);
    r[11] = (hendblk(1+1));
    r[12+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[8];  
    r[12+2] = r[3];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 5: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[2];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__23128);
    /* r[4] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 6: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 7: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k base */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__23120);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 8: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  env field-c-name* field-type* k */
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(14);
    r[6] = (hendblk(1+1));
    r[7+0] = r[6];  
    r[7+1] = r[4];  
    r[7+2] = r[3];  
    r[7+3] = r[2];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v909;

case 9: /* clo k id id */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v909: /* k id id env */
  if (((isnull((r[1]))) || (isnull((r[2]))))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[4] = (car((r[1])));
    r[5] = (car((r[2])));
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(9);
    r[6] = (hendblk(1+1));
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(10);
    r[6] = (hendblk(5+1));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("name-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(12);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(13);
    r[9] = (hendblk(1+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[3];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 10: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop id id k t */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(11);
    r[8] = (hendblk(4+1));
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__2381);
    r[4] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 11: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop id id k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cdr((r[4])));
    r[3] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 12: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k n */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup-x")));
    r[3+3] = (cx__2369);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 14: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek  k */
    r[3+0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[2];  
    r[3+2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3+3] = (cx__2355);
    r[3+4] = (mknull());
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 15: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r env attr* name arg-c-type* k arg-c-name* */
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(4+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(16);
    r[9] = (hendblk(4+1));
    r[10+0] = r[9];  
    r[10+1] = r[4];  
    r[10+2] = r[3];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_build_2Dproc_2Dtype;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r arg-c-type* k arg-c-name* r */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(17);
    r[7] = (hendblk(3+1));
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__2349);
    r[4] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 17: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  arg-c-type* k arg-c-name* */
  if ((isnull((r[4])))) {
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[3];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__2341);
    r[4] = (mknull());
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = obj_from_case(18);
    r[5] = (hendblk(3+1));
    r[0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3] = (cx__2338);
    r[4] = (mknull());
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 18: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  arg-c-type* arg-c-name* k */
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(21);
    r[5] = (hendblk(1+1));
    r[0] = r[5];  
    r[1] = r[3];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v872;

case 19: /* clo k name* type* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v872: /* k name* type* arg-c-name* */
  if ((isnull((r[1])))) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_bool(isnull((r[1])));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(19);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(4+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(20);
    r[4] = (hendblk(4+1));
    r[5] = (car((r[1])));
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6] = (car((r[2])));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = (((r[1]) == (r[3])) ? (cx__2328) : (cx__2327));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[6+3] = (cx__2333);
    r[6+4] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 20: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop type* name* k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cdr((r[4])));
    r[3] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 21: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek  k */
    r[3+0] = (cx_q_2Dfprint_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[2];  
    r[3+2] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[3+3] = (cx__2311);
    r[3+4] = (mknull());
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 22: /* build-proc-type k name attr* env */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_build_2Dproc_2Dtype: /* k name attr* env */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(23);
    r[4] = (hendblk(3+1));
    hreserve(hbsz(0+1), 5); /* 5 live regs */
    *--hp = obj_from_case(27);
    r[5] = (hendblk(0+1));
    hreserve(hbsz(0+1), 6); /* 6 live regs */
    *--hp = obj_from_case(28);
    r[6] = (hendblk(0+1));
    r[7+0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[4];  
    r[7+2] = r[2];  
    r[7+3] = (mksymbol(internsym("return")));
    r[7+4] = (r[5]);
    r[7+5] = (r[6]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 23: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r attr* name k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(24);
    r[5] = (hendblk(3+1));
    hreserve(hbsz(0+1), 6); /* 6 live regs */
    *--hp = obj_from_case(25);
    r[6] = (hendblk(0+1));
    hreserve(hbsz(0+1), 7); /* 7 live regs */
    *--hp = obj_from_case(26);
    r[7] = (hendblk(0+1));
    r[8+0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[5];  
    r[8+2] = r[2];  
    r[8+3] = (mksymbol(internsym("count-flops")));
    r[8+4] = (r[6]);
    r[8+5] = (r[7]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 24: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r name k r */
  if (bool_from_obj(bool_from_obj(r[1]) ? (r[4]) : obj_from_bool(0))) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = (cx__23276);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = (bool_from_obj(r[1]) ? (cx__23273) : (bool_from_obj(r[4]) ? (r[4]) : (cx__23272)));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 25: /* clo k v* */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k v* */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = obj_from_bool(1);
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 26: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = r[0];  
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = obj_from_ktrap();
    r[1+2] = obj_from_bool(0);
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 27: /* clo k v* */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k v* */
    { fixnum_t v980_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v980_tmp = (n); }
    r[2] = obj_from_bool((v980_tmp) < (3)); }
  if (bool_from_obj(r[2])) {
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (cx__23263);
    r[3+3] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[2] = (cdr((r[1])));
    r[2] = (cdr((r[2])));
    r[2] = (car((r[2])));
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 28: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = r[0];  
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = obj_from_ktrap();
    r[1+2] = obj_from_bool(0);
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 29: /* build-proc-name k name attr* env */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_build_2Dproc_2Dname: /* k name attr* env */
    hreserve(hbsz(4+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_case(30);
    r[4] = (hendblk(4+1));
    hreserve(hbsz(0+1), 5); /* 5 live regs */
    *--hp = obj_from_case(52);
    r[5] = (hendblk(0+1));
    hreserve(hbsz(0+1), 6); /* 6 live regs */
    *--hp = obj_from_case(53);
    r[6] = (hendblk(0+1));
    r[7+0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[4];  
    r[7+2] = r[2];  
    r[7+3] = (mksymbol(internsym("prec&color")));
    r[7+4] = (r[5]);
    r[7+5] = (r[6]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 30: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r name attr* env k */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(31);
    r[6] = (hendblk(3+1));
    hreserve(hbsz(0+1), 7); /* 7 live regs */
    *--hp = obj_from_case(50);
    r[7] = (hendblk(0+1));
    hreserve(hbsz(1+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(51);
    r[8] = (hendblk(1+1));
    r[9+0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[6];  
    r[9+2] = r[3];  
    r[9+3] = (mksymbol(internsym("stem")));
    r[9+4] = (r[7]);
    r[9+5] = (r[8]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 31: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r env r k */
    hreserve(hbsz(4+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(32);
    r[5] = (hendblk(4+1));
    hreserve(hbsz(0+1), 6); /* 6 live regs */
    *--hp = obj_from_case(48);
    r[6] = (hendblk(0+1));
    hreserve(hbsz(0+1), 7); /* 7 live regs */
    *--hp = obj_from_case(49);
    r[7] = (hendblk(0+1));
    r[8+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[5];  
    r[8+2] = r[2];  
    r[8+3] = (mksymbol(internsym("proc-suffix")));
    r[8+4] = (r[6]);
    r[8+5] = (r[7]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 32: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r env r r k */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(33);
    r[6] = (hendblk(5+1));
    hreserve(hbsz(0+1), 7); /* 7 live regs */
    *--hp = obj_from_case(46);
    r[7] = (hendblk(0+1));
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(47);
    r[8] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    /* r[2] */    
    r[3] = (mksymbol(internsym("proc-infix")));
    r[4] = (r[7]);
    r[5] = (r[8]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 33: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r env r r r k */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(34);
    r[7] = (hendblk(6+1));
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(44);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(45);
    r[9] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    /* r[2] */    
    r[3] = (mksymbol(internsym("prec-letter")));
    r[4] = (r[8]);
    r[5] = (r[9]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 34: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r env r r r r k */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(35);
    r[8] = (hendblk(7+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(42);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(43);
    r[11] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    /* r[2] */    
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 35: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r env r r r r r k */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_case(36);
    r[9] = (hendblk(7+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(40);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(41);
    r[11] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (mksymbol(internsym("proc-prefix")));
    r[4] = (r[10]);
    r[5] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 36: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r r r r r k */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(37);
    r[9] = (hendblk(3+1));
  if (bool_from_obj(r[5])) {
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    r[11+0] = (cx_q_2Dfmt_2A);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[9];  
    r[11+2] = (cx__23330);
    r[11+3] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    r[11+0] = (cx_q_2Dfmt_2A);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[9];  
    r[11+2] = (cx__23320);
    r[11+3] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 37: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r r r k */
    r[5+0] = r[4];  
    r[5+1] = r[1];  
    r[5+2] = r[3];  
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v760;

case 38: /* clo k r stem* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v760: /* k r stem* r */
  if ((isnull((r[2])))) {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_q_2Dfmt_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (cx__23340);
    r[5+3] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(38);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(39);
    r[4] = (hendblk(3+1));
    r[5] = (car((r[2])));
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_q_2Dfmt_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (cx__23340);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 39: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop stem* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = (cdr((r[3])));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 40: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 41: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__23306);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 42: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 43: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23298);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 44: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 45: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__23295);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 46: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 47: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__23292);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 48: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 49: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup")));
    r[1+3] = (cx__23288);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 50: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 51: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k name */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("attr-lookup")));
    r[3+3] = (cx__23284);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 52: /* clo k v* */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k v* */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = obj_from_bool(1);
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 53: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = r[0];  
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = obj_from_ktrap();
    r[1+2] = obj_from_bool(0);
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
