/* cx2dh.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_cx2dh
#endif
#define MODULE module_cx2dh
#define LOAD() module_ast(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_ast(void); /* ast.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_gen_2Dreg_2A; /* gen-reg* */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_s_2Derror_2A; /* s-error* */
obj cx_complex_2D_3Edouble_2Dhummer; /* complex->double-hummer */
static obj cx__23360; /* constant #360 */
static obj cx__23367; /* constant #367 */
static obj cx__23371; /* constant #371 */
static obj cx__23387; /* constant #387 */

/* gc roots */
static obj *globv[] = {
  &cx_complex_2D_3Edouble_2Dhummer,
  &cx__23360,
  &cx__23367,
  &cx__23371,
  &cx__23387,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[40] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 25
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__23360 = (hpushstr(0, newstring("op ~a: ~a should be of ~a elements, found ~a")));
    cx__23367 = (hpushstr(0, newstring("input")));
    cx__23371 = (hpushstr(0, newstring("output")));
    cx__23387 = (hpushstr(0, newstring("no clause matches ~s")));
    hreserve(hbsz(1), 0); /* 0 live regs */
    *--hp = obj_from_fixnum(0);
    r[0] = (hendblk(1));
    hreserve(hbsz(1+1), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(1);
    r[0] = (hendblk(1+1));
    hreserve(hbsz(0+1), 1); /* 1 live regs */
    *--hp = obj_from_case(3);
    r[1] = (hendblk(0+1));
    hreserve(hbsz(0+1), 2); /* 2 live regs */
    *--hp = obj_from_case(4);
    r[2] = (hendblk(0+1));
    hreserve(hbsz(1), 3); /* 3 live regs */
    *--hp = obj_from_void(0);
    r[3] = (hendblk(1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 4); /* 4 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-dot-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-dot-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[4] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(5);
    r[5] = (hendblk(2+1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 6); /* 6 live regs */
    p = r[5];   /* gc-safe */
    *--hp = p; *--hp = obj_from_bool(0);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-dot-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-dot-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-dot-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-norm-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-norm-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-norm-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-norm-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-norm-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-norm-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-real-cmul-conj-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-real-cmul-conj-fini")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-real-cmul-conj-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-real-cmul-conj-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-real-cmul-conj-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-real-cmul-conj-init")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-sub-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-sub-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-add-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-add-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(9);
    r[5] = (hendblk(2+1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 6); /* 6 live regs */
    p = r[5];   /* gc-safe */
    *--hp = p; *--hp = obj_from_bool(0);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-cmadd")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(13);
    r[5] = (hendblk(2+1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 6); /* 6 live regs */
    p = r[5];   /* gc-safe */
    *--hp = p; *--hp = obj_from_bool(0);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-cmul")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-rmsub")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-rmsub")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-rmadd")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-rmadd")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(17);
    r[5] = (hendblk(2+1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 6); /* 6 live regs */
    p = r[5];   /* gc-safe */
    *--hp = p; *--hp = obj_from_bool(0);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-madd")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(21);
    r[5] = (hendblk(2+1));
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 6); /* 6 live regs */
    p = r[5];   /* gc-safe */
    *--hp = p; *--hp = obj_from_bool(0);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-mul")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-rmul")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-rmul")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-sub")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-sub")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-add")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-times-minus-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-times-minus-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-times-plus-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-times-plus-i")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-neg")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-neg")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-imag")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-imag")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-real")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-real")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-make")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-move")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-move")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 5); /* 5 live regs */
    p = obj_from_bool(0); /* gc-safe */
    *--hp = p; *--hp = (mksymbol(internsym("dh-zero")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (mksymbol(internsym("complex-zero")));
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[5] = (p); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    (void)(objptr_from_obj(r[3])[0] = (r[4]));
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(39);
    r[4] = (hendblk(3+1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(25);
    cx_complex_2D_3Edouble_2Dhummer = (hendblk(1+1));
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k *reg-count* */
    hreserve(hbsz(2+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = r[0];  
    *--hp = obj_from_case(2);
    r[2] = (hendblk(2+1));
    r[3] = (objptr_from_obj(r[1])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_gen_2Dreg_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[2];  
    r[4+2] = (mksymbol(internsym("b")));
    r[4+3] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 2: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k *reg-count* */
    r[4] = (objptr_from_obj(r[3])[0]);
    r[4] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    (void)(objptr_from_obj(r[3])[0] = (r[4]));
    { /* vector */
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[4] = (hendblk(2+1)); }
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 3: /* clo k cl name r* len */
    assert(rc == 6);
    r += 1; /* shift reg. wnd */
    /* k cl name r* len */
    { bool_t v1667_tmp;
    { fixnum_t v1666_tmp;
    { /* length */
    int n; obj l = r[3];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v1666_tmp = (n); }
    v1667_tmp = ((v1666_tmp) == fixnum_from_obj(r[4])); }
    r[5] = obj_from_bool(!(v1667_tmp)); }
  if (bool_from_obj(r[5])) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23360);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 4: /* clo k type */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k type */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = (((((r[1]) == (mksymbol(internsym("complex-float")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("complex-float")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("complex-float"))))))) && (1)) ? (mksymbol(internsym("dh-float"))) : (((((r[1]) == (mksymbol(internsym("complex-double")))) || ((is_flonum_obj(r[1])) && ((is_flonum_obj(mksymbol(internsym("complex-double")))) && (flonum_from_obj(r[1]) == flonum_from_obj(mksymbol(internsym("complex-double"))))))) && (1)) ? (mksymbol(internsym("dh-double"))) : (r[1])));
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 5: /* clo k attr* output* input* r* */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* check-io fresh-reg */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(6);
    r[7] = (hendblk(7+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (cx__23371);
    r[8+3] = (mksymbol(internsym("complex-mul")));
    r[8+4] = (r[2]);
    r[8+5] = obj_from_fixnum(1);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 6: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  check-io fresh-reg k r* output* input* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(7);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (cx__23367);
    r[3] = (mksymbol(internsym("complex-mul")));
    r[4] = (r[7]);
    r[5] = obj_from_fixnum(3);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 7: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  fresh-reg k r* output* input* attr* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(8);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 8: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* output* input* attr* */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("dh-dot-a")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    r[8] = (cdr((r[5])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-dot-b")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 9: /* clo k attr* output* input* r* */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* check-io fresh-reg */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(10);
    r[7] = (hendblk(7+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (cx__23371);
    r[8+3] = (mksymbol(internsym("complex-mul")));
    r[8+4] = (r[2]);
    r[8+5] = obj_from_fixnum(1);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 10: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  check-io fresh-reg k r* output* input* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(11);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (cx__23367);
    r[3] = (mksymbol(internsym("complex-mul")));
    r[4] = (r[7]);
    r[5] = obj_from_fixnum(3);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 11: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  fresh-reg k r* output* input* attr* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(12);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 12: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* output* input* attr* */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("dh-cmadd-a")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    r[8] = (cdr((r[5])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-cmadd-b")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* clo k attr* output* input* r* */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* check-io fresh-reg */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(14);
    r[7] = (hendblk(7+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (cx__23371);
    r[8+3] = (mksymbol(internsym("complex-mul")));
    r[8+4] = (r[2]);
    r[8+5] = obj_from_fixnum(1);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 14: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  check-io fresh-reg k r* output* input* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(15);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (cx__23367);
    r[3] = (mksymbol(internsym("complex-mul")));
    r[4] = (r[7]);
    r[5] = obj_from_fixnum(2);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 15: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  fresh-reg k r* output* input* attr* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(16);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* output* input* attr* */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("dh-cmul-a")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-cmul-b")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 17: /* clo k attr* output* input* r* */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* check-io fresh-reg */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(18);
    r[7] = (hendblk(7+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (cx__23371);
    r[8+3] = (mksymbol(internsym("complex-mul")));
    r[8+4] = (r[2]);
    r[8+5] = obj_from_fixnum(1);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 18: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  check-io fresh-reg k r* output* input* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(19);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (cx__23367);
    r[3] = (mksymbol(internsym("complex-mul")));
    r[4] = (r[7]);
    r[5] = obj_from_fixnum(3);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 19: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  fresh-reg k r* output* input* attr* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(20);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* output* input* attr* */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("dh-madd-a")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    r[8] = (cdr((r[5])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-madd-b")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 21: /* clo k attr* output* input* r* */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* check-io fresh-reg */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(22);
    r[7] = (hendblk(7+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (cx__23371);
    r[8+3] = (mksymbol(internsym("complex-mul")));
    r[8+4] = (r[2]);
    r[8+5] = obj_from_fixnum(1);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 22: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  check-io fresh-reg k r* output* input* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(23);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (cx__23367);
    r[3] = (mksymbol(internsym("complex-mul")));
    r[4] = (r[7]);
    r[5] = obj_from_fixnum(2);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 23: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  fresh-reg k r* output* input* attr* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(24);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 24: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* output* input* attr* */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("dh-mul-a")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-mul-b")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 25: /* clo k qa0 */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k qa0 cx->dh-decl */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (2))) {
    r[3] = (vectorref((r[1]), (0)));
    r[3] = obj_from_bool((r[3]) == (mksymbol(internsym("qa0-top"))));
  } else {
    r[3] = obj_from_bool(0);
  }
  } else {
    r[3] = obj_from_bool(0);
  }
  if (bool_from_obj(r[3])) {
    r[3] = (vectorref((r[1]), (1)));
    r[4+0] = r[0];  
    r[4+1] = r[3];  
    r[4+2] = (mknull());
    r[4+3] = r[2];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (mksymbol(internsym("variant-case")));
    r[4+3] = (cx__23387);
    r[4+4] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 26: /* clo k decl* r* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k decl* r* cx->dh-decl */
  if ((isnull((r[1])))) {
    { fixnum_t v1665_tmp;
    { /* length */
    int n; obj l = r[2];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v1665_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v1665_tmp);
    hreserve(hbsz(3)*c, 4); /* 4 live regs */
    l = r[2];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[4] = (o); } }
    { /* vector */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("qa0-top")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[4] = (hendblk(2+1)); }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(26);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(4+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(27);
    r[4] = (hendblk(4+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = (car((r[1])));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 27: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop decl* k r* */
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[3])));
    r[3] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_cx_2D_3Edh_2Dif: /* k var true-code* false-code* r* fresh-reg convert-type dh-optable */
    hreserve(hbsz(3+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(35);
    r[8] = (hendblk(3+1));
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = obj_from_case(28);
    r[9] = (hendblk(5+1));
    r[0] = r[9];  
    r[1] = r[3];  
    r[2] = r[5];  
    r[3] = r[6];  
    r[4] = r[7];  
    goto s_cx_2D_3Edh_2Dcode_2A;

case 28: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r cx->dh-code* true-code* k r* var */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(29);
    r[7] = (hendblk(4+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 29: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* r var */
    { /* vector */
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("qa0-if")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[6] = (hendblk(4+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

s_cx_2D_3Edh_2Dloop: /* k attr* var low high code* r* fresh-reg convert-type dh-optable */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = obj_from_case(30);
    r[10] = (hendblk(6+1));
    r[0] = (r[10]);
    r[1] = r[5];  
    r[2] = r[7];  
    r[3] = r[8];  
    r[4] = r[9];  
    goto s_cx_2D_3Edh_2Dcode_2A;

case 30: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* high low var attr* */
    { /* vector */
    hreserve(hbsz(6+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("qa0-loop")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(6+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[3];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 31: /* clo k code r* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k code r* fresh-reg convert-type dh-optable */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-operation"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
    r[10] = (objptr_from_obj(r[5])[0]);
    { /* assq */
    obj x = (r[7]), l = (r[10]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[10] = (l == mknull() ? obj_from_bool(0) : p); }
  if ((!bool_from_obj(r[10]))) {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[0];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[11] = (cdr((r[10])));
    r[11] = (car((r[11])));
  if (bool_from_obj(r[11])) {
    r[11] = (cdr((r[10])));
    r[11] = (car((r[11])));
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[11]);
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[2];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[11] = (cdr((r[10])));
    r[11] = (cdr((r[11])));
    r[12+0] = (r[11]);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[6];  
    r[12+3] = r[8];  
    r[12+4] = r[9];  
    r[12+5] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-load"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
    hreserve(hbsz(5+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(32);
    r[10] = (hendblk(5+1));
    r[11+0] = r[4];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[7];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-store"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
  if (((r[7]) == (mksymbol(internsym("complex-float"))))) {
    hreserve(hbsz(5+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(33);
    r[10] = (hendblk(5+1));
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  } else {
    hreserve(hbsz(5+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(34);
    r[10] = (hendblk(5+1));
    r[11+0] = r[4];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[7];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (6))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-loop"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
    r[10] = (vectorref((r[1]), (5)));
    r[11+0] = r[0];  
    r[11+1] = r[6];  
    r[11+2] = r[7];  
    r[11+3] = r[8];  
    r[11+4] = r[9];  
    r[11+5] = (r[10]);
    r[11+6] = r[2];  
    r[11+7] = r[3];  
    r[11+8] = r[4];  
    r[11+9] = r[5];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_cx_2D_3Edh_2Dloop;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (4))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-if"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9+0] = r[0];  
    r[9+1] = r[6];  
    r[9+2] = r[7];  
    r[9+3] = r[8];  
    r[9+4] = r[2];  
    r[9+5] = r[3];  
    r[9+6] = r[4];  
    r[9+7] = r[5];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_cx_2D_3Edh_2Dif;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("variant-case")));
    r[7+3] = (cx__23387);
    r[7+4] = (r[6]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }
  }

case 32: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* addr* output attr* */
    { /* vector */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-load")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 33: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* addr* attr* value */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("dh->float")));
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("dh-float")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-store")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[3];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 34: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r* value addr* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-store")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 35: /* clo k code* */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_cx_2D_3Edh_2Dcode_2A: /* k code* fresh-reg convert-type dh-optable */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(31);
    r[5] = (hendblk(3+1));
    r[6+0] = r[0];  
    r[6+1] = r[1];  
    r[6+2] = (mknull());
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v1283;

case 36: /* clo k code* r* */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v1283: /* k code* r* cx->dh-code */
  if ((isnull((r[1])))) {
    { fixnum_t v1664_tmp;
    { /* length */
    int n; obj l = r[2];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v1664_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v1664_tmp);
    hreserve(hbsz(3)*c, 4); /* 4 live regs */
    l = r[2];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[4] = (o); } }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(36);
    r[4] = (hendblk(1+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(37);
    r[4] = (hendblk(3+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = (car((r[1])));
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 37: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop code* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = (cdr((r[3])));
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_cx_2D_3Edh_2Dproc: /* k attr* name arg-name* arg-type* arg-c-name* arg-c-type* code* fresh-reg convert-type dh-optable */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = obj_from_case(38);
    r[11] = (hendblk(7+1));
    r[0] = (r[11]);
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    goto s_cx_2D_3Edh_2Dcode_2A;

case 38: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r k arg-c-type* arg-c-name* arg-type* arg-name* name attr* */
    { /* vector */
    hreserve(hbsz(8+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-proc")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(8+1)); }
    r[10+0] = r[2];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 39: /* clo k decl */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k decl fresh-reg convert-type dh-optable */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (8))) {
    r[5] = (vectorref((r[1]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("qa0-proc"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[1]), (1)));
    r[6] = (vectorref((r[1]), (2)));
    r[7] = (vectorref((r[1]), (3)));
    r[8] = (vectorref((r[1]), (4)));
    r[9] = (vectorref((r[1]), (5)));
    r[10] = (vectorref((r[1]), (6)));
    r[11] = (vectorref((r[1]), (7)));
    r[12+0] = r[0];  
    r[12+1] = r[5];  
    r[12+2] = r[6];  
    r[12+3] = r[7];  
    r[12+4] = r[8];  
    r[12+5] = r[9];  
    r[12+6] = (r[10]);
    r[12+7] = (r[11]);
    r[12+8] = r[2];  
    r[12+9] = r[3];  
    r[12+10] = r[4];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_cx_2D_3Edh_2Dproc;
  } else {
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
