/* fmap.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_fmap
#endif
#define MODULE module_fmap
#define LOAD() module_error(); module_format(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_format(void); /* format.ss */
extern void module_error(void); /* error.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_q_2Dfmt_2A; /* q-fmt* */
obj cx_empty_2Dfmap; /* empty-fmap */
obj cx_extend_2Dfmap; /* extend-fmap */
obj cx_fmap_2D_3Ealist; /* fmap->alist */
obj cx_fmap_2Dbuild_2Dkey; /* fmap-build-key */
obj cx_fmap_2Dcompare; /* fmap-compare */
obj cx_fmap_2Dfor_2Deach; /* fmap-for-each */
obj cx_lookup_2Dfmap; /* lookup-fmap */
static obj cx__23114; /* constant #114 */
static obj cx__23115; /* constant #115 */
static obj cx__23120; /* constant #120 */
static obj cx__23154; /* constant #154 */
static obj cx__23192; /* constant #192 */
static obj cx__2326; /* constant #26 */
static obj cx__23319; /* constant #319 */
static obj cx__234; /* constant #4 */

/* helper functions */
/* fmap-compare */
static obj cxs_fmap_2Dcompare(obj v8_a, obj v7_b)
{ 
    return ((strcmp(stringchars((v8_a)), stringchars((v7_b))) < 0) ? obj_from_fixnum(1) : ((strcmp(stringchars((v8_a)), stringchars((v7_b))) > 0) ? obj_from_fixnum(-1) : obj_from_fixnum(0)));
}

/* gc roots */
static obj *globv[] = {
  &cx_empty_2Dfmap,
  &cx_extend_2Dfmap,
  &cx__23114,
  &cx__23115,
  &cx__23120,
  &cx__23154,
  &cx__23192,
  &cx__2326,
  &cx__23319,
  &cx__234,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[67] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 29
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__234 = (hpushstr(0, newstring("~s")));
    cx__2326 = (hpushstr(0, newstring("no clause matches ~s")));
    cx__23114 = obj_from_flonum(0, 0.0);
    cx__23115 = obj_from_flonum(0, 0.61803398874989479);
    cx__23120 = obj_from_flonum(0, 1.0);
    cx__23154 = (hpushstr(0, newstring("can't happen (loop)")));
    cx__23192 = (hpushstr(0, newstring("can't happen (reorder)")));
    cx__23319 = (hpushstr(0, newstring("Unexpected fmap-compare value ~a")));
    { static obj c[] = { obj_from_case(1) }; cx_fmap_2Dbuild_2Dkey = (obj)c; }
    { static obj c[] = { obj_from_case(2) }; cx_fmap_2Dcompare = (obj)c; }
    { /* vector */
    hreserve(hbsz(1+1), 0); /* 0 live regs */
    *--hp = (mksymbol(internsym("treap-empty")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[0] = (hendblk(1+1)); }
    hreserve(hbsz(1+1), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(3);
    cx_empty_2Dfmap = (hendblk(1+1));
    { static obj c[] = { obj_from_case(4) }; cx_lookup_2Dfmap = (obj)c; }
    hreserve(hbsz(1), 0); /* 0 live regs */
    *--hp = (cx__23114);
    r[0] = (hendblk(1));
    hreserve(hbsz(1+1), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(6);
    r[0] = (hendblk(1+1));
    hreserve(hbsz(0+1), 1); /* 1 live regs */
    *--hp = obj_from_case(8);
    r[1] = (hendblk(0+1));
    hreserve(hbsz(0+1), 2); /* 2 live regs */
    *--hp = obj_from_case(9);
    r[2] = (hendblk(0+1));
    hreserve(hbsz(0+1), 3); /* 3 live regs */
    *--hp = obj_from_case(12);
    r[3] = (hendblk(0+1));
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(7);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(5+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = obj_from_case(15);
    cx_extend_2Dfmap = (hendblk(5+1));
    { static obj c[] = { obj_from_case(59) }; cx_fmap_2D_3Ealist = (obj)c; }
    { static obj c[] = { obj_from_case(62) }; cx_fmap_2Dfor_2Deach = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* fmap-build-key k k */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
gs_fmap_2Dbuild_2Dkey: /* k k */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_q_2Dfmt_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (cx__234);
    r[3+3] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 2: /* fmap-compare k a b */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k a b */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (cxs_fmap_2Dcompare((r[1]), (r[2])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 3: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k e */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 4: /* lookup-fmap k fm k success failure */
    assert(rc == 6);
    r += 1; /* shift reg. wnd */
gs_lookup_2Dfmap: /* k fm k success failure */
    hreserve(hbsz(4+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(5);
    r[5] = (hendblk(4+1));
    r[0] = r[5];  
    r[1] = r[2];  
    goto gs_fmap_2Dbuild_2Dkey;

case 5: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r success failure fm k */
    r[6+0] = r[5];  
    r[6+1] = r[4];  
    r[6+2] = r[2];  
    r[6+3] = r[1];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;

s_loop: /* k fm success r failure */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (1))) {
    r[5] = (vectorref((r[1]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5+0] = r[4];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (7))) {
    r[5] = (vectorref((r[1]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[1]), (1)));
    r[6] = (vectorref((r[1]), (3)));
    r[7] = (vectorref((r[1]), (5)));
    r[8] = (vectorref((r[1]), (6)));
    r[9] = (cxs_fmap_2Dcompare((r[3]), (r[5])));
  if (((((r[9]) == obj_from_fixnum(-1)) || ((is_flonum_obj(r[9])) && (0))) && (1))) {
    /* r[0] */    
    r[1] = r[7];  
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    goto s_loop;
  } else {
  if (((((r[9]) == obj_from_fixnum(1)) || ((is_flonum_obj(r[9])) && (0))) && (1))) {
    /* r[0] */    
    r[1] = r[8];  
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    goto s_loop;
  } else {
    r[10+0] = r[2];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[0];  
    r[10+2] = r[6];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (mksymbol(internsym("variant-case")));
    r[6+3] = (cx__2326);
    r[6+4] = (r[5]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 6: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2] = (objptr_from_obj(r[1])[0]);
    r[3] = (objptr_from_obj(r[1])[0]);
    r[3] = obj_from_flonum(4, flonum_from_obj(r[3]) + flonum_from_obj(cx__23115));
    r[4] = ((flonum_from_obj(r[3]) < flonum_from_obj(cx__23120)) ? (r[3]) : obj_from_flonum(4, flonum_from_obj(r[3]) - flonum_from_obj(cx__23120)));
    (void)(objptr_from_obj(r[1])[0] = (r[4]));
    /* r[2] */    
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 7: /* clo k p */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k p */
    r[2+0] = (car((r[1])));
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = r[0];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 8: /* clo k p v */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k p v */
    r[3+0] = (cdr((r[1])));
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 9: /* clo k p */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k p */
    hreserve(hbsz(1+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(10);
    r[2] = (hendblk(1+1));
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(11);
    r[3] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 10: /* clo k v */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k v p */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = obj_from_void(vectorref((r[2]), (5)) = (r[1]));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 11: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k p */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = (vectorref((r[1]), (5)));
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 12: /* clo k p */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k p */
    hreserve(hbsz(1+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(13);
    r[2] = (hendblk(1+1));
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(14);
    r[3] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* clo k v */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k v p */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = obj_from_void(vectorref((r[2]), (6)) = (r[1]));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 14: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k p */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = (vectorref((r[1]), (6)));
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 15: /* clo k fm k v */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k fm k v fmap-random! ref-ptr mk-right mk-left set-ptr! */
    hreserve(hbsz(1), 9); /* 9 live regs */
    *--hp = r[1];  
    r[9] = (hendblk(1));
    hreserve(hbsz(1), 10); /* 10 live regs */
    *--hp = obj_from_void(0);
    r[10] = (hendblk(1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(19);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(16);
    r[12] = (hendblk(1+1));
    hreserve(hbsz(12+1), 13); /* 13 live regs */
    *--hp = (r[10]);
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[11]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = (r[12]);
    *--hp = r[4];  
    *--hp = obj_from_case(20);
    r[11] = (hendblk(12+1));
    r[0] = (r[11]);
    r[1] = r[2];  
    goto gs_fmap_2Dbuild_2Dkey;

case 16: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k fm */
    hreserve(hbsz(1+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(17);
    r[2] = (hendblk(1+1));
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(18);
    r[3] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 17: /* clo k v */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k v fm */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (objptr_from_obj(r[2])[0] = (r[1]));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 18: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k fm */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = (objptr_from_obj(r[1])[0]);
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 19: /* clo k t */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k t */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (1))) {
    r[2] = (vectorref((r[1]), (0)));
    r[2] = obj_from_bool((r[2]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[2] = obj_from_bool(0);
  }
  } else {
    r[2] = obj_from_bool(0);
  }
  if (bool_from_obj(r[2])) {
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (7))) {
    r[2] = (vectorref((r[1]), (0)));
    r[2] = obj_from_bool((r[2]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[2] = obj_from_bool(0);
  }
  } else {
    r[2] = obj_from_bool(0);
  }
  if (bool_from_obj(r[2])) {
    r[2] = (vectorref((r[1]), (6)));
    r[3] = (vectorref((r[1]), (5)));
    r[4] = (vectorref((r[1]), (4)));
    r[5] = (vectorref((r[1]), (3)));
    r[6] = (vectorref((r[1]), (2)));
    r[7] = (vectorref((r[1]), (1)));
    { /* vector */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("treap-node")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[2] = (hendblk(7+1)); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("variant-case")));
    r[3+3] = (cx__2326);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek r fmap-random! mk-addr ref-ptr mk-right copy mk-left set-ptr! v k fm k mk */
    (void)(objptr_from_obj(r[13])[0] = (r[1]));
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(21);
    r[14] = (hendblk(10+1));
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = (r[11]);
    *--hp = r[8];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(32);
    r[15] = (hendblk(11+1));
    r[16+0] = (r[12]);
    r[16+1] = (objptr_from_obj(r[11])[0]);
    r[16+2] = (r[10]);
    r[16+3] = (r[14]);
    r[16+4] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto gs_lookup_2Dfmap;

case 21: /* clo k ignore */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k ignore mk-addr ref-ptr mk-right copy mk-left set-ptr! v k fm mk */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[0];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(22);
    r[12] = (hendblk(10+1));
    r[13+0] = r[2];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 22: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r ref-ptr mk-right copy mk-left set-ptr! v k fm mk k */
    r[0] = (r[11]);
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    /* r[6] */    
    /* r[7] */    
    /* r[8] */    
    /* r[9] */    
    r[10] = (r[10]);
    goto s_loop_v1049;

case 23: /* clo k p */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_loop_v1049: /* k p ref-ptr mk-right copy mk-left set-ptr! v k fm mk */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(23);
    r[11] = (hendblk(9+1));
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(24);
    r[11] = (hendblk(11+1));
    r[12+0] = r[2];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 24: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r mk-right copy mk-left loop set-ptr! v k p k fm mk */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (7))) {
    r[13] = (vectorref((r[1]), (0)));
    r[13] = obj_from_bool((r[13]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[13] = obj_from_bool(0);
  }
  } else {
    r[13] = obj_from_bool(0);
  }
  if (bool_from_obj(r[13])) {
    r[13] = (vectorref((r[1]), (1)));
    r[14] = (vectorref((r[1]), (4)));
    r[15] = (vectorref((r[1]), (5)));
    r[16] = (vectorref((r[1]), (6)));
    r[17] = (objptr_from_obj(r[12])[0]);
    r[17] = (cxs_fmap_2Dcompare((r[17]), (r[13])));
  if (((((r[17]) == obj_from_fixnum(0)) || ((is_flonum_obj(r[17])) && (0))) && (1))) {
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = obj_from_case(25);
    r[18] = (hendblk(2+1));
    r[19] = (objptr_from_obj(r[12])[0]);
    { /* vector */
    hreserve(hbsz(7+1), 20); /* 20 live regs */
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (r[19]);
    *--hp = (mksymbol(internsym("treap-node")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(7+1)); }
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[18]);
    r[2] = r[9];  
    r[3] = (r[19]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if (((((r[17]) == obj_from_fixnum(-1)) || ((is_flonum_obj(r[17])) && (0))) && (1))) {
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[10]);
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = obj_from_case(26);
    r[18] = (hendblk(5+1));
    r[19+0] = r[3];  
    pc = objptr_from_obj(r[19+0])[0];
    r[19+1] = (r[18]);
    r[19+2] = r[1];  
    r += 19; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((((r[17]) == obj_from_fixnum(1)) || ((is_flonum_obj(r[17])) && (0))) && (1))) {
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[10]);
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = obj_from_case(29);
    r[18] = (hendblk(5+1));
    r[19+0] = r[3];  
    pc = objptr_from_obj(r[19+0])[0];
    r[19+1] = (r[18]);
    r[19+2] = r[1];  
    r += 19; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    r[0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = (mksymbol(internsym("extend-fmap")));
    r[3] = (cx__23319);
    r[4] = (r[18]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[14+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = (mksymbol(internsym("variant-case")));
    r[14+3] = (cx__2326);
    r[14+4] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 25: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  k fm */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 26: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r set-ptr! p mk-left loop k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(27);
    r[7] = (hendblk(4+1));
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[3];  
    r[8+3] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 27: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  mk-left r loop k */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(28);
    r[6] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 28: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop k */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[3];  
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 29: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r set-ptr! p mk-right loop k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(30);
    r[7] = (hendblk(4+1));
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[3];  
    r[8+3] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 30: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  mk-right r loop k */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(31);
    r[6] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 31: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop k */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[3];  
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 32: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3];
    r[1+4] = p[4];
    r[1+5] = p[5];
    r[1+6] = p[6];
    r[1+7] = p[7];
    r[1+8] = p[8];
    r[1+9] = p[9];
    r[1+10] = p[10];
    r[1+11] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k fmap-random! mk-addr ref-ptr mk-right mk-left copy set-ptr! fm v k mk */
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(33);
    r[12] = (hendblk(11+1));
    r[13+0] = r[1];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 33: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r mk-addr ref-ptr mk-right mk-left copy set-ptr! fm k v k mk */
    hreserve(hbsz(12+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(34);
    r[13] = (hendblk(12+1));
    r[0] = (cx_empty_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 34: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek r mk-addr ref-ptr mk-right mk-left copy set-ptr! fm k r v k mk */
    hreserve(hbsz(13+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(35);
    r[14] = (hendblk(13+1));
    r[0] = (cx_empty_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 35: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* ek r mk-addr ref-ptr mk-right mk-left copy set-ptr! fm k r r v k mk */
    { /* vector */
    hreserve(hbsz(7+1), 15); /* 15 live regs */
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (objptr_from_obj(r[14])[0]);
    *--hp = (mksymbol(internsym("treap-node")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(7+1)); }
    hreserve(hbsz(10+1), 16); /* 16 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[15]);
    *--hp = r[7];  
    *--hp = (r[11]);
    *--hp = (r[14]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(36);
    r[16] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 36: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r ref-ptr mk-right mk-left copy mk r set-ptr! r fm k */
    r[0] = (r[11]);
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    /* r[6] */    
    /* r[7] */    
    /* r[8] */    
    /* r[9] */    
    r[10] = (r[10]);
    goto s_loop_v893;

case 37: /* clo k p */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_loop_v893: /* k p ref-ptr mk-right mk-left copy mk r set-ptr! r fm */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(37);
    r[11] = (hendblk(9+1));
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = (r[11]);
    *--hp = obj_from_case(38);
    r[11] = (hendblk(11+1));
    r[12+0] = r[2];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 38: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop mk-right mk-left copy mk r set-ptr! r p k fm */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (1))) {
    r[13] = (vectorref((r[1]), (0)));
    r[13] = obj_from_bool((r[13]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[13] = obj_from_bool(0);
  }
  } else {
    r[13] = obj_from_bool(0);
  }
  if (bool_from_obj(r[13])) {
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = obj_from_case(39);
    r[13] = (hendblk(2+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = (r[10]);
    r[3] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (7))) {
    r[13] = (vectorref((r[1]), (0)));
    r[13] = obj_from_bool((r[13]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[13] = obj_from_bool(0);
  }
  } else {
    r[13] = obj_from_bool(0);
  }
  if (bool_from_obj(r[13])) {
    r[13] = (vectorref((r[1]), (1)));
    r[14] = (vectorref((r[1]), (4)));
  if ((flonum_from_obj(r[7]) < flonum_from_obj(r[14]))) {
    hreserve(hbsz(10+1), 15); /* 15 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = obj_from_case(40);
    r[15] = (hendblk(10+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[15]);
    r[2] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 15); /* 15 live regs */
    *--hp = r[6];  
    *--hp = (r[13]);
    *--hp = (r[11]);
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = (r[10]);
    *--hp = r[8];  
    *--hp = obj_from_case(55);
    r[15] = (hendblk(8+1));
    r[16+0] = r[5];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[1];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[14+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[11]);
    r[14+2] = (mksymbol(internsym("variant-case")));
    r[14+3] = (cx__2326);
    r[14+4] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 39: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  k fm */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 40: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r r p r mk-right mk-left copy mk set-ptr! fm k */
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(41);
    r[12] = (hendblk(11+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 41: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r r p r mk-right mk-left copy mk set-ptr! fm r k */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(42);
    r[13] = (hendblk(10+1));
    r[14+0] = r[9];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[3];  
    r[14+3] = r[2];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 42: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  r mk-right mk-left copy mk set-ptr! fm r r k */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(43);
    r[12] = (hendblk(9+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 43: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r mk-right mk-left copy mk set-ptr! fm r r k */
    r[11+0] = (r[10]);
    r[11+1] = r[9];  
    r[11+2] = r[8];  
    r[11+3] = r[1];  
    r[11+4] = r[2];  
    r[11+5] = r[3];  
    r[11+6] = r[4];  
    r[11+7] = r[5];  
    r[11+8] = r[6];  
    r[11+9] = r[7];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_reorder;

case 44: /* clo k lf rt q */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6]; }
    r += 1; /* shift reg. wnd */
s_reorder: /* k lf rt q mk-right mk-left copy mk set-ptr! fm */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(44);
    r[10] = (hendblk(6+1));
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (1))) {
    r[11] = (vectorref((r[3]), (0)));
    r[11] = obj_from_bool((r[11]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[11] = obj_from_bool(0);
  }
  } else {
    r[11] = obj_from_bool(0);
  }
  if (bool_from_obj(r[11])) {
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = obj_from_case(45);
    r[11] = (hendblk(5+1));
    r[12+0] = (cx_empty_2Dfmap);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  } else {
  if ((isvector((r[3])))) {
  if (((vectorlen((r[3]))) == (7))) {
    r[11] = (vectorref((r[3]), (0)));
    r[11] = obj_from_bool((r[11]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[11] = obj_from_bool(0);
  }
  } else {
    r[11] = obj_from_bool(0);
  }
  if (bool_from_obj(r[11])) {
    r[11] = (vectorref((r[3]), (1)));
    r[12] = (vectorref((r[3]), (5)));
    r[13] = (vectorref((r[3]), (6)));
    r[14] = (objptr_from_obj(r[7])[0]);
    r[14] = (cxs_fmap_2Dcompare((r[14]), (r[11])));
  if (((((r[14]) == obj_from_fixnum(-1)) || ((is_flonum_obj(r[14])) && (0))) && (1))) {
    hreserve(hbsz(7+1), 15); /* 15 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = (r[12]);
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = obj_from_case(49);
    r[15] = (hendblk(7+1));
    r[16+0] = r[8];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[2];  
    r[16+3] = r[3];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if (((((r[14]) == obj_from_fixnum(1)) || ((is_flonum_obj(r[14])) && (0))) && (1))) {
    hreserve(hbsz(7+1), 15); /* 15 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = (r[10]);
    *--hp = (r[13]);
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = obj_from_case(52);
    r[15] = (hendblk(7+1));
    r[16+0] = r[8];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[1];  
    r[16+3] = r[3];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[15+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = r[0];  
    r[15+2] = (mksymbol(internsym("extend-fmap")));
    r[15+3] = (cx__23192);
    r[15+4] = (mknull());
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = (mksymbol(internsym("variant-case")));
    r[12+3] = (cx__2326);
    r[12+4] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 45: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r lf set-ptr! rt k fm */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(46);
    r[7] = (hendblk(4+1));
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 46: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  set-ptr! rt k fm */
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(47);
    r[6] = (hendblk(4+1));
    r[0] = (cx_empty_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 47: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r set-ptr! rt k fm */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(48);
    r[6] = (hendblk(2+1));
    r[7+0] = r[2];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[3];  
    r[7+3] = r[1];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 48: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  k fm */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 49: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  mk-left q copy left reorder lf k */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(50);
    r[9] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 50: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r copy left reorder lf k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(51);
    r[7] = (hendblk(4+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 51: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r reorder r lf k */
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[4];  
    r[6+3] = r[3];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 52: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  mk-right q copy right reorder rt k */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(53);
    r[9] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 53: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r copy right reorder rt k */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(54);
    r[7] = (hendblk(4+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 54: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r reorder rt r k */
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[4];  
    r[6+3] = r[3];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 55: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r set-ptr! p mk-right mk-left loop k key mk */
    r[10] = (objptr_from_obj(r[9])[0]);
    r[10] = (cxs_fmap_2Dcompare((r[10]), (r[8])));
    hreserve(hbsz(6+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(56);
    r[11] = (hendblk(6+1));
    r[12+0] = r[2];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[3];  
    r[12+3] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 56: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  mk-right mk-left r loop k z */
  if (((((r[7]) == obj_from_fixnum(-1)) || ((is_flonum_obj(r[7])) && (0))) && (1))) {
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(57);
    r[8] = (hendblk(2+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((((r[7]) == obj_from_fixnum(1)) || ((is_flonum_obj(r[7])) && (0))) && (1))) {
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(58);
    r[8] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = (mksymbol(internsym("extend-fmap")));
    r[3] = (cx__23154);
    r[4] = (mknull());
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 57: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop k */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[3];  
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 58: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop k */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[3];  
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 59: /* fmap->alist k fm */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k fm */
    r[2+0] = r[0];  
    r[2+1] = (mknull());
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v862;

case 60: /* clo k r* fm */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
s_loop_v862: /* k r* fm */
    hreserve(hbsz(0+1), 3); /* 3 live regs */
    *--hp = obj_from_case(60);
    r[3] = (hendblk(0+1));
  if ((isvector((r[2])))) {
  if (((vectorlen((r[2]))) == (1))) {
    r[4] = (vectorref((r[2]), (0)));
    r[4] = obj_from_bool((r[4]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[4] = obj_from_bool(0);
  }
  } else {
    r[4] = obj_from_bool(0);
  }
  if (bool_from_obj(r[4])) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isvector((r[2])))) {
  if (((vectorlen((r[2]))) == (7))) {
    r[4] = (vectorref((r[2]), (0)));
    r[4] = obj_from_bool((r[4]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[4] = obj_from_bool(0);
  }
  } else {
    r[4] = obj_from_bool(0);
  }
  if (bool_from_obj(r[4])) {
    r[4] = (vectorref((r[2]), (2)));
    r[5] = (vectorref((r[2]), (3)));
    r[6] = (vectorref((r[2]), (5)));
    r[7] = (vectorref((r[2]), (6)));
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = obj_from_case(61);
    r[8] = (hendblk(5+1));
    r[0] = r[8];  
    /* r[1] */    
    r[2] = r[6];  
    goto s_loop_v862;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (mksymbol(internsym("variant-case")));
    r[5+3] = (cx__2326);
    r[5+4] = (r[4]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 61: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop right k value verbatim */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[7];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 62: /* fmap-for-each k fm filter proc */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k fm filter proc */
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v829;

case 63: /* clo k fm */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v829: /* k fm filter proc */
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(63);
    r[4] = (hendblk(2+1));
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (1))) {
    r[5] = (vectorref((r[1]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("treap-empty"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (7))) {
    r[5] = (vectorref((r[1]), (0)));
    r[5] = obj_from_bool((r[5]) == (mksymbol(internsym("treap-node"))));
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
  if (bool_from_obj(r[5])) {
    r[5] = (vectorref((r[1]), (2)));
    r[6] = (vectorref((r[1]), (3)));
    r[7] = (vectorref((r[1]), (5)));
    r[8] = (vectorref((r[1]), (6)));
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(64);
    r[9] = (hendblk(7+1));
    r[0] = r[9];  
    r[1] = r[7];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v829;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (mksymbol(internsym("variant-case")));
    r[6+3] = (cx__2326);
    r[6+4] = (r[5]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 64: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  filter proc value verbatim loop right k */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(65);
    r[9] = (hendblk(3+1));
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(66);
    r[9] = (hendblk(7+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[5];  
    r[3] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 65: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop right k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 66: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop right k proc value verbatim k */
  if (bool_from_obj(r[1])) {
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[7];  
    r[3] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
