/* format.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_format
#endif
#define MODULE module_format
#define LOAD() module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_fixnum_2D_3Estring; /* fixnum->string */
extern obj cx_flonum_2D_3Estring; /* flonum->string */
extern obj cx_ic_2Derror_2A; /* ic-error* */
obj cx_q_2Dfmt_2A; /* q-fmt* */
static obj cx__23106; /* constant #106 */
static obj cx__23134; /* constant #134 */
static obj cx__23139; /* constant #139 */
static obj cx__2314; /* constant #14 */
static obj cx__23146; /* constant #146 */
static obj cx__2315; /* constant #15 */
static obj cx__23166; /* constant #166 */
static obj cx__23181; /* constant #181 */
static obj cx__23186; /* constant #186 */
static obj cx__23201; /* constant #201 */
static obj cx__2321; /* constant #21 */
static obj cx__23211; /* constant #211 */
static obj cx__2322; /* constant #22 */
static obj cx__2324; /* constant #24 */
static obj cx__2335; /* constant #35 */
static obj cx__2337; /* constant #37 */
static obj cx__2339; /* constant #39 */
static obj cx__2344; /* constant #44 */
static obj cx__2352; /* constant #52 */
static obj cx__2353; /* constant #53 */
static obj cx__2364; /* constant #64 */
static obj cx__2377; /* constant #77 */
static obj cx__2399; /* constant #99 */

/* gc roots */
static obj *globv[] = {
  &cx__23106,
  &cx__23134,
  &cx__23139,
  &cx__2314,
  &cx__23146,
  &cx__2315,
  &cx__23166,
  &cx__23181,
  &cx__23186,
  &cx__23201,
  &cx__2321,
  &cx__23211,
  &cx__2322,
  &cx__2324,
  &cx__2335,
  &cx__2337,
  &cx__2339,
  &cx__2344,
  &cx__2352,
  &cx__2353,
  &cx__2364,
  &cx__2377,
  &cx__2399,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[22] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 25
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__2314 = (hpushstr(0, newstring("#<unknown>")));
    cx__2315 = (hpushstr(0, newstring("#<procedure>")));
    cx__2321 = (hpushstr(0, newstring("#f")));
    cx__2322 = (hpushstr(0, newstring("#t")));
    cx__2324 = (hpushstr(0, newstring("()")));
    cx__2335 = (hpushstr(0, newstring("#<oport>")));
    cx__2337 = (hpushstr(0, newstring("#<iport>")));
    cx__2339 = (hpushstr(0, newstring("#<eof>")));
    cx__2344 = (hpushstr(0, newstring("(")));
    cx__2352 = (hpushstr(0, newstring(")")));
    cx__2353 = (hpushstr(0, newstring(" . ")));
    cx__2364 = (hpushstr(0, newstring(" ")));
    cx__2377 = (hpushstr(0, newstring("#(")));
    cx__2399 = (hpushstr(0, newstring("#&")));
    { static char s[] = { 34, 0 };
    cx__23106 = (hpushstr(0, newstring(s))); }
    { static char s[] = { 35, 92, 0 };
    cx__23134 = (hpushstr(0, newstring(s))); }
    { static char s[] = { 35, 92, 115, 112, 97, 99, 101, 0 };
    cx__23139 = (hpushstr(0, newstring(s))); }
    { static char s[] = { 35, 92, 110, 101, 119, 108, 105, 110, 101, 0 };
    cx__23146 = (hpushstr(0, newstring(s))); }
    cx__23166 = (hpushstr(0, newstring("")));
    cx__23181 = (hpushstr(0, newstring("unrecognized format ~a in ~s")));
    cx__23186 = (hpushstr(0, newstring("~")));
    cx__23201 = (hpushstr(0, newstring("Missing arguments for fmt ~s")));
    cx__23211 = (hpushstr(0, newstring("Dangling ~~, fmt ~s")));
    { static obj c[] = { obj_from_case(1) }; cx_q_2Dfmt_2A = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* q-fmt* k fmt arg* */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k fmt arg* */
    hreserve(hbsz(0+1), 3); /* 3 live regs */
    *--hp = obj_from_case(3);
    r[3] = (hendblk(0+1));
    hreserve(hbsz(0+1), 4); /* 4 live regs */
    *--hp = obj_from_case(4);
    r[4] = (hendblk(0+1));
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(12);
    r[5] = (hendblk(2+1));
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(2);
    r[6] = (hendblk(1+1));
    r[7+0] = r[0];  
    r[7+1] = (cx__23166);
    r[7+2] = r[2];  
    r[7+3] = obj_from_fixnum(0);
    r[7+4] = obj_from_fixnum(0);
    r[7+5] = r[3];  
    r[7+6] = r[5];  
    r[7+7] = r[6];  
    r[7+8] = r[1];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v534;

case 2: /* clo k r* a b */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r* a b fmt */
    { const fixnum_t v644_b = fixnum_from_obj(r[3]);
    { const fixnum_t v643_a = fixnum_from_obj(r[2]);
  if (((v643_a) >= (v644_b))) {
    r[5] = r[1];  
  } else {
    { /* substring */
    int *d = substring(stringdata((r[4])), (v643_a), (v644_b));
    r[5] = (hpushstr(5, d)); }
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((r[5])));
    r[5] = (hpushstr(6, d)); }
  }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump; }  } 

case 3: /* clo k r* */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k r* */
    { /* string */
    obj o = hpushstr(2, allocstring(1, ' '));
    char *s = stringchars(o);
    *s++ = (10);
    r[2] = (o); }
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((r[2])));
    r[2] = (hpushstr(3, d)); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 4: /* clo k s d? r* */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k s d? r* */
  if (bool_from_obj(r[2])) {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((r[1])));
    r[4] = (hpushstr(4, d)); }
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__23106)));
    r[4] = (hpushstr(4, d)); }
    r[5+0] = r[0];  
    r[5+1] = r[4];  
    r[5+2] = obj_from_fixnum(0);
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;
  }

s_loop: /* k r* i s */
    { const fixnum_t v641_i = fixnum_from_obj(r[2]);
  if (((v641_i) == (stringlen((r[3]))))) {
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__23106)));
    r[4] = (hpushstr(4, d)); }
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { const char_t v642_c = (*stringref((r[3]), (v641_i)));
  if ((((v642_c) == (92)) || ((v642_c) == (34)))) {
    { /* string */
    obj o = hpushstr(4, allocstring(2, ' '));
    char *s = stringchars(o);
    *s++ = (92);
    *s++ = (v642_c);
    r[4] = (o); }
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((r[4])));
    r[4] = (hpushstr(5, d)); }
    /* r[0] */    
    r[1] = r[4];  
    r[2] = obj_from_fixnum((v641_i) + (1));
    /* r[3] */    
    goto s_loop;
  } else {
    { /* string */
    obj o = hpushstr(4, allocstring(1, ' '));
    char *s = stringchars(o);
    *s++ = (v642_c);
    r[4] = (o); }
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((r[4])));
    r[4] = (hpushstr(5, d)); }
    /* r[0] */    
    r[1] = r[4];  
    r[2] = obj_from_fixnum((v641_i) + (1));
    /* r[3] */    
    goto s_loop;
  } } 
  } } 

case 5: /* clo k r* arg* a b */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4]; }
    r += 1; /* shift reg. wnd */
s_loop_v534: /* k r* arg* a b out-newline fmt/1 add-fmt fmt */
    hreserve(hbsz(4+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(5);
    r[9] = (hendblk(4+1));
  if ((fixnum_from_obj(r[4]) == (stringlen((r[8]))))) {
    r[10+0] = r[7];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[0];  
    r[10+2] = r[1];  
    r[10+3] = r[3];  
    r[10+4] = r[4];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    { const char_t v640_tmp = (*stringref((r[8]), fixnum_from_obj(r[4])));
    r[10] = obj_from_bool((v640_tmp) == (126)); } 
  if (bool_from_obj(r[10])) {
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = obj_from_case(6);
    r[10] = (hendblk(10+1));
  if ((fixnum_from_obj(r[4]) == ((stringlen((r[8]))) - (1)))) {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = (mksymbol(internsym("q-fmt")));
    r[3] = (cx__23211);
    r[4] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[11+0] = obj_from_ktrap();
    r[11+1] = obj_from_void(0);
    r[11+2] = r[7];  
    r[11+3] = r[3];  
    r[11+4] = r[1];  
    r[11+5] = r[5];  
    r[11+6] = r[6];  
    r[11+7] = r[9];  
    r[11+8] = r[2];  
    r[11+9] = r[0];  
    r[11+10] = r[8];  
    r[11+11] = r[4];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v536;
  }
  } else {
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    r[4] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    /* r[5] */    
    /* r[6] */    
    /* r[7] */    
    /* r[8] */    
    goto s_loop_v534;
  }
  }

case 6: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v536: /* ek  add-fmt a r* out-newline fmt/1 loop arg* k fmt b */
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(7);
    r[12] = (hendblk(7+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[4];  
    /* r[3] */    
    r[4] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 7: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r out-newline fmt/1 loop arg* k fmt b */
    r[9] = obj_from_fixnum(fixnum_from_obj(r[8]) + (1));
    r[10] = obj_from_char(*stringref((r[7]), fixnum_from_obj(r[9])));
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[9];  
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(8);
    r[11] = (hendblk(9+1));
  if ((((char_from_obj(r[10]) == (97)) || (char_from_obj(r[10]) == (115))) && (isnull((r[5]))))) {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = (mksymbol(internsym("q-fmt")));
    r[3] = (cx__23201);
    r[4] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[12+0] = obj_from_ktrap();
    r[12+1] = obj_from_void(0);
    r[12+2] = r[7];  
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r[12+5] = r[1];  
    r[12+6] = r[4];  
    r[12+7] = r[9];  
    r[12+8] = r[5];  
    r[12+9] = r[6];  
    r[12+10] = (r[10]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v540;
  }

case 8: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v540: /* ek  fmt out-newline fmt/1 r loop x arg* k c */
  if ((char_from_obj(r[10]) == (97))) {
    hreserve(hbsz(4+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(9);
    r[11] = (hendblk(4+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = (car((r[8])));
    r[3] = obj_from_bool(1);
    r[4] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((char_from_obj(r[10]) == (115))) {
    hreserve(hbsz(4+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(10);
    r[11] = (hendblk(4+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = (car((r[8])));
    r[3] = obj_from_bool(0);
    r[4] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((char_from_obj(r[10]) == (126))) {
    { /* string-append */
    int *d = stringcat(stringdata((r[5])), stringdata((cx__23186)));
    r[11] = (hpushstr(11, d)); }
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = (r[11]);
    r[3] = r[8];  
    r[4] = obj_from_fixnum(fixnum_from_obj(r[7]) + (1));
    r[5] = obj_from_fixnum(fixnum_from_obj(r[7]) + (1));
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  } else {
  if ((char_from_obj(r[10]) == (37))) {
    hreserve(hbsz(4+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(11);
    r[11] = (hendblk(4+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[9];  
    r[12+2] = (mksymbol(internsym("q-fmt")));
    r[12+3] = (cx__23181);
    r[12+4] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }

case 9: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop x arg* k */
    { const fixnum_t v639_x = fixnum_from_obj(r[3]);
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (cdr((r[4])));
    r[6+4] = obj_from_fixnum((v639_x) + (1));
    r[6+5] = obj_from_fixnum((v639_x) + (1));
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump; } 

case 10: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop x arg* k */
    { const fixnum_t v638_x = fixnum_from_obj(r[3]);
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (cdr((r[4])));
    r[6+4] = obj_from_fixnum((v638_x) + (1));
    r[6+5] = obj_from_fixnum((v638_x) + (1));
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump; } 

case 11: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop x arg* k */
    { const fixnum_t v637_x = fixnum_from_obj(r[3]);
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = r[4];  
    r[6+4] = obj_from_fixnum((v637_x) + (1));
    r[6+5] = obj_from_fixnum((v637_x) + (1));
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump; } 

case 12: /* clo k x d? r* */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k x d? r* out-newline out-string */
  if ((iseof((r[1])))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2339);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((isiport((r[1])))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2337);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((isoport((r[1])))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2335);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((issymbol((r[1])))) {
    r[6] = (hpushstr(6, newstring(symbolname(getsymbol((r[1]))))));
    r[7+0] = r[5];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[6];  
    r[7+3] = obj_from_bool(1);
    r[7+4] = r[3];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((ispair((r[1])))) {
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    goto s_out_2Dpair;
  } else {
  if ((is_fixnum_obj(r[1]))) {
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = obj_from_case(13);
    r[6] = (hendblk(3+1));
  if ((is_fixnum_obj(r[1]))) {
    r[7+0] = (cx_fixnum_2D_3Estring);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[1];  
    r[7+3] = obj_from_fixnum(10);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[7+0] = (cx_flonum_2D_3Estring);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[1];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
  if ((is_flonum_obj(r[1]))) {
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = obj_from_case(14);
    r[6] = (hendblk(3+1));
  if ((is_fixnum_obj(r[1]))) {
    r[7+0] = (cx_fixnum_2D_3Estring);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[1];  
    r[7+3] = obj_from_fixnum(10);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[7+0] = (cx_flonum_2D_3Estring);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[1];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
  if ((isnull((r[1])))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2324);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((is_bool_obj(r[1]))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (bool_from_obj(r[1]) ? (cx__2322) : (cx__2321));
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((is_char_obj(r[1]))) {
    { const char_t v636_x = char_from_obj(r[1]);
  if (bool_from_obj(r[2])) {
    { /* string */
    obj o = hpushstr(6, allocstring(1, ' '));
    char *s = stringchars(o);
    *s++ = (v636_x);
    r[6] = (o); }
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((r[6])));
    r[6] = (hpushstr(7, d)); }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((v636_x) == (10))) {
  if (bool_from_obj(r[2])) {
    r[6+0] = r[4];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__23146)));
    r[6] = (hpushstr(6, d)); }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
  if (((v636_x) == (32))) {
  if (bool_from_obj(r[2])) {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__2364)));
    r[6] = (hpushstr(6, d)); }
  } else {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__23139)));
    r[6] = (hpushstr(6, d)); }
  }
  } else {
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__23134)));
    r[6] = (hpushstr(6, d)); }
    { /* string */
    obj o = hpushstr(7, allocstring(1, ' '));
    char *s = stringchars(o);
    *s++ = (v636_x);
    r[7] = (o); }
    { /* string-append */
    int *d = stringcat(stringdata((r[6])), stringdata((r[7])));
    r[6] = (hpushstr(8, d)); }
  }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } } 
  } else {
  if ((isstring((r[1])))) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
  if ((isvector((r[1])))) {
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    goto s_out_2Dvector;
  } else {
  if ((isbox((r[1])))) {
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    goto s_out_2Dbox;
  } else {
    { /* procedure? */
    obj o = (r[1]), h;
    if (!isobjptr(o)) r[6] = obj_from_bool(0);
    h = objptr_from_obj(o)[-1];
    r[6] = obj_from_bool(notaptr(h) && size_from_obj(h) >= 1 && isaptr(hblkref(o, 0))); }
  if (bool_from_obj(r[6])) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2315);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__2314);
    r[6+3] = obj_from_bool(1);
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }

case 13: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r out-string r* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = obj_from_bool(1);
    r[5+4] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 14: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r out-string r* k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = obj_from_bool(1);
    r[5+4] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

s_out_2Dpair: /* k x d? r* out-newline out-string */
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__2344)));
    r[6] = (hpushstr(6, d)); }
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(12);
    r[7] = (hendblk(2+1));
    r[8+0] = r[0];  
    r[8+1] = r[6];  
    r[8+2] = r[1];  
    r[8+3] = r[7];  
    r[8+4] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v471;

case 15: /* clo k r* x */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v471: /* k r* x fmt/1 d? */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(15);
    r[5] = (hendblk(2+1));
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(16);
    r[5] = (hendblk(5+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (car((r[2])));
    r[6+3] = r[4];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r fmt/1 d? loop k x */
    r[7] = (cdr((r[6])));
    r[7] = obj_from_bool(ispair((r[7])));
  if (bool_from_obj(r[7])) {
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2364)));
    r[7] = (hpushstr(7, d)); }
    r[8+0] = r[4];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[5];  
    r[8+2] = r[7];  
    r[8+3] = (cdr((r[6])));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[7] = (cdr((r[6])));
    r[7] = obj_from_bool(isnull((r[7])));
  if (bool_from_obj(r[7])) {
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2352)));
    r[7] = (hpushstr(7, d)); }
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(17);
    r[7] = (hendblk(1+1));
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2353)));
    r[8] = (hpushstr(8, d)); }
    r[9+0] = r[2];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[7];  
    r[9+2] = (cdr((r[6])));
    r[9+3] = r[3];  
    r[9+4] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 17: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2352)));
    r[3] = (hpushstr(3, d)); }
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

s_out_2Dvector: /* k x d? r* out-newline out-string */
    { /* string-append */
    int *d = stringcat(stringdata((r[3])), stringdata((cx__2377)));
    r[6] = (hpushstr(6, d)); }
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(12);
    r[7] = (hendblk(2+1));
    r[8+0] = r[0];  
    r[8+1] = r[6];  
    r[8+2] = obj_from_fixnum(0);
    r[8+3] = r[7];  
    r[8+4] = r[2];  
    r[8+5] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v436;

case 18: /* clo k r* i */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
s_loop_v436: /* k r* i fmt/1 d? x */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(18);
    r[6] = (hendblk(3+1));
  if ((fixnum_from_obj(r[2]) == (vectorlen((r[5]))))) {
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2352)));
    r[7] = (hpushstr(7, d)); }
    r[8+0] = r[0];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((fixnum_from_obj(r[2]) == 0)) {
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(19);
    r[7] = (hendblk(3+1));
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = (vectorref((r[5]), fixnum_from_obj(r[2])));
    r[8+3] = r[4];  
    r[8+4] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(20);
    r[7] = (hendblk(3+1));
    { /* string-append */
    int *d = stringcat(stringdata((r[1])), stringdata((cx__2364)));
    r[8] = (hpushstr(8, d)); }
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[7];  
    r[9+2] = (vectorref((r[5]), fixnum_from_obj(r[2])));
    r[9+3] = r[4];  
    r[9+4] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }

case 19: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop i k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = obj_from_fixnum(fixnum_from_obj(r[3]) + (1));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop i k */
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = obj_from_fixnum(fixnum_from_obj(r[3]) + (1));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_out_2Dbox: /* k x d? r* out-newline out-string */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(12);
    r[6] = (hendblk(2+1));
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(21);
    r[6] = (hendblk(4+1));
    r[7+0] = r[5];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = (cx__2399);
    r[7+3] = r[3];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 21: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r fmt/1 d? x k */
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (boxref((r[4])));
    r[6+3] = r[3];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
