/* print.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_print
#endif
#define MODULE module_print
#define LOAD() module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_ic_2Derror_2A; /* ic-error* */
obj cx_q_2Dfprint_2A; /* q-fprint* */
obj cx_q_2Dwrite_2F3; /* q-write/3 */
static obj cx__23106; /* constant #106 */
static obj cx__23108; /* constant #108 */
static obj cx__23110; /* constant #110 */
static obj cx__23139; /* constant #139 */
static obj cx__2314; /* constant #14 */
static obj cx__2333; /* constant #33 */
static obj cx__2359; /* constant #59 */
static obj cx__2361; /* constant #61 */
static obj cx__2364; /* constant #64 */
static obj cx__2376; /* constant #76 */
static obj cx__2389; /* constant #89 */
static obj cx__2390; /* constant #90 */
static obj cx__2396; /* constant #96 */
static obj cx__2397; /* constant #97 */
static obj cx__2399; /* constant #99 */

/* gc roots */
static obj *globv[] = {
  &cx__23106,
  &cx__23108,
  &cx__23110,
  &cx__23139,
  &cx__2314,
  &cx__2333,
  &cx__2359,
  &cx__2361,
  &cx__2364,
  &cx__2376,
  &cx__2389,
  &cx__2390,
  &cx__2396,
  &cx__2397,
  &cx__2399,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[13] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 14
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__2314 = (hpushstr(0, newstring("#&")));
    cx__2333 = (hpushstr(0, newstring("#(")));
    { static char s[] = { 35, 92, 0 };
    cx__2359 = (hpushstr(0, newstring(s))); }
    { static char s[] = { 35, 92, 115, 112, 97, 99, 101, 0 };
    cx__2361 = (hpushstr(0, newstring(s))); }
    { static char s[] = { 35, 92, 110, 101, 119, 108, 105, 110, 101, 0 };
    cx__2364 = (hpushstr(0, newstring(s))); }
    cx__2376 = (hpushstr(0, newstring(" . ")));
    cx__2389 = (hpushstr(0, newstring("#<unknown>")));
    cx__2390 = (hpushstr(0, newstring("#<procedure>")));
    cx__2396 = (hpushstr(0, newstring("#f")));
    cx__2397 = (hpushstr(0, newstring("#t")));
    cx__2399 = (hpushstr(0, newstring("()")));
    cx__23106 = (hpushstr(0, newstring("#<oport>")));
    cx__23108 = (hpushstr(0, newstring("#<iport>")));
    cx__23110 = (hpushstr(0, newstring("#<eof>")));
    cx__23139 = (hpushstr(0, newstring("Unrecognize format char")));
    { static obj c[] = { obj_from_case(1) }; cx_q_2Dwrite_2F3 = (obj)c; }
    { static obj c[] = { obj_from_case(9) }; cx_q_2Dfprint_2A = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* q-write/3 k x d? p */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
gs_q_2Dwrite_2F3: /* k x d? p */
  if ((iseof((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputs(stringchars((cx__23110)), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isiport((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputs(stringchars((cx__23108)), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isoport((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputs(stringchars((cx__23106)), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((issymbol((r[1])))) {
    r[4] = (hpushstr(4, newstring(symbolname(getsymbol((r[1]))))));
    r[4] = obj_from_void(fputs(stringchars((r[4])), oportdata((r[3]))));
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((ispair((r[1])))) {
    (void)(fputc((40), oportdata((r[3]))));
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = obj_from_case(4);
    r[4] = (hendblk(2+1));
    r[0] = r[4];  
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    goto s_loop;
  } else {
  if ((is_fixnum_obj(r[1]))) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_void(fprintf(oportdata((r[3])), "%d", fixnum_from_obj(r[1])));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((is_flonum_obj(r[1]))) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_void(fprintf(oportdata((r[3])), "%.15g", flonum_from_obj(r[1])));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputs(stringchars((cx__2399)), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((is_bool_obj(r[1]))) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_void(fputs(stringchars((bool_from_obj(r[1]) ? (cx__2397) : (cx__2396))), oportdata((r[3]))));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((is_char_obj(r[1]))) {
    { const char_t v433_x = char_from_obj(r[1]);
  if (bool_from_obj(r[2])) {
    r[4] = obj_from_void(fputc((v433_x), oportdata((r[3]))));
  } else {
  if (((v433_x) == (10))) {
    r[4] = obj_from_void(fputs(stringchars((cx__2364)), oportdata((r[3]))));
  } else {
  if (((v433_x) == (32))) {
    r[4] = obj_from_void(fputs(stringchars((cx__2361)), oportdata((r[3]))));
  } else {
    (void)(fputs(stringchars((cx__2359)), oportdata((r[3]))));
    r[4] = obj_from_void(fputc((v433_x), oportdata((r[3]))));
  }
  }
  }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump; } 
  } else {
  if ((isstring((r[1])))) {
  if (bool_from_obj(r[2])) {
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_void(fputs(stringchars((r[1])), oportdata((r[3]))));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    (void)(fputc((34), oportdata((r[3]))));
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = obj_from_case(5);
    r[4] = (hendblk(2+1));
    r[5+0] = r[4];  
    r[5+1] = obj_from_fixnum(0);
    r[5+2] = r[3];  
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v400;
  }
  } else {
  if ((isvector((r[1])))) {
    (void)(fputs(stringchars((cx__2333)), oportdata((r[3]))));
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = obj_from_case(6);
    r[4] = (hendblk(2+1));
  if ((!((vectorlen((r[1]))) == (0)))) {
    r[5+0] = r[4];  
    r[5+1] = obj_from_fixnum(0);
    r[5+2] = r[2];  
    r[5+3] = r[3];  
    r[5+4] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v377;
  } else {
    r[5+0] = obj_from_ktrap();
    r[5+1] = obj_from_void(0);
    r[5+2] = r[0];  
    r[5+3] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v389;
  }
  } else {
  if ((isbox((r[1])))) {
    (void)(fputs(stringchars((cx__2314)), oportdata((r[3]))));
    /* r[0] */    
    r[1] = (boxref((r[1])));
    /* r[2] */    
    /* r[3] */    
    goto gs_q_2Dwrite_2F3;
  } else {
    { /* procedure? */
    obj o = (r[1]), h;
    if (!isobjptr(o)) r[4] = obj_from_bool(0);
    h = objptr_from_obj(o)[-1];
    r[4] = obj_from_bool(notaptr(h) && size_from_obj(h) >= 1 && isaptr(hblkref(o, 0))); }
  if (bool_from_obj(r[4])) {
    r[4] = obj_from_void(fputs(stringchars((cx__2390)), oportdata((r[3]))));
  } else {
    r[4] = obj_from_void(fputs(stringchars((cx__2389)), oportdata((r[3]))));
  }
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }

case 2: /* clo k x */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k x d? p */
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(2);
    r[4] = (hendblk(2+1));
    hreserve(hbsz(5+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = obj_from_case(3);
    r[4] = (hendblk(5+1));
    r[0] = r[4];  
    r[1] = (car((r[1])));
    /* r[2] */    
    /* r[3] */    
    goto gs_q_2Dwrite_2F3;

case 3: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek  d? loop k p x */
    r[7] = (cdr((r[6])));
    r[7] = obj_from_bool(ispair((r[7])));
  if (bool_from_obj(r[7])) {
    (void)(fputc((32), oportdata((r[5]))));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[6])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[7] = (cdr((r[6])));
    r[7] = obj_from_bool(isnull((r[7])));
  if (bool_from_obj(r[7])) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    (void)(fputs(stringchars((cx__2376)), oportdata((r[5]))));
    r[0] = r[4];  
    r[1] = (cdr((r[6])));
    /* r[2] */    
    r[3] = r[5];  
    goto gs_q_2Dwrite_2F3;
  }
  }

case 4: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  k p */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputc((41), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

s_loop_v400: /* k i p x */
    { const fixnum_t v431_i = fixnum_from_obj(r[1]);
  if (((v431_i) == (stringlen((r[3]))))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { const char_t v432_c = (*stringref((r[3]), (v431_i)));
    (void)((((v432_c) == (34)) || ((v432_c) == (92))) ? (void)(fputc((92), oportdata((r[2])))) : (void)(0));
    (void)(fputc((v432_c), oportdata((r[2])))); } 
    /* r[0] */    
    r[1] = obj_from_fixnum((v431_i) + (1));
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v400;
  } } 

case 5: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  k p */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputc((34), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 6: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_l_v389: /* ek  k p */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(fputc((41), oportdata((r[3]))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 7: /* clo k i */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_loop_v377: /* k i d? p x */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(7);
    r[5] = (hendblk(3+1));
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[5];  
    *--hp = obj_from_case(8);
    r[5] = (hendblk(5+1));
    r[0] = r[5];  
    r[1] = (vectorref((r[4]), fixnum_from_obj(r[1])));
    /* r[2] */    
    /* r[3] */    
    goto gs_q_2Dwrite_2F3;

case 8: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop k p i x */
    { const fixnum_t v430_i = fixnum_from_obj(r[5]);
  if ((!((v430_i) == ((vectorlen((r[6]))) - (1))))) {
    (void)(fputc((32), oportdata((r[4]))));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[3];  
    r[2] = obj_from_fixnum((v430_i) + (1));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } } 

case 9: /* q-fprint* k port fstr olst */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k port fstr olst */
    { /* string->list */
    int c = (stringlen((r[2])));
    char *s; obj l = mknull();
    hreserve(hbsz(3)*c, 4); /* 4 live regs */
    s = stringchars((r[2])); /* gc-safe */
    while (c-- > 0) { *--hp = l; *--hp = obj_from_char(s[c]);
    *--hp = obj_from_size(PAIR_BTAG); l = hendblk(3); }
    r[4] = (l); }
    r[5+0] = r[0];  
    r[5+1] = r[4];  
    r[5+2] = r[3];  
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v348;

case 10: /* clo k flst olst */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v348: /* k flst olst port */
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(10);
    r[4] = (hendblk(1+1));
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(1);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[5] = (car((r[1])));
    r[5] = obj_from_bool(char_from_obj(r[5]) == (126));
  if (bool_from_obj(r[5])) {
    r[5] = (cdr((r[1])));
    r[5] = obj_from_bool(ispair((r[5])));
  if (bool_from_obj(r[5])) {
    r[5] = (cdr((r[1])));
    r[5] = (car((r[5])));
  if ((char_from_obj(r[5]) == (97))) {
  if ((isnull((r[2])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(11);
    r[6] = (hendblk(4+1));
    r[0] = r[6];  
    r[1] = (car((r[2])));
    r[2] = obj_from_bool(1);
    /* r[3] */    
    goto gs_q_2Dwrite_2F3;
  }
  } else {
  if ((char_from_obj(r[5]) == (115))) {
  if ((isnull((r[2])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(12);
    r[6] = (hendblk(4+1));
    r[0] = r[6];  
    r[1] = (car((r[2])));
    r[2] = obj_from_bool(0);
    /* r[3] */    
    goto gs_q_2Dwrite_2F3;
  }
  } else {
  if ((char_from_obj(r[5]) == (37))) {
    (void)(fputc('\n', oportdata((r[3]))));
    r[6] = (cdr((r[1])));
    r[6] = (cdr((r[6])));
    /* r[0] */    
    r[1] = r[6];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v348;
  } else {
  if ((char_from_obj(r[5]) == (126))) {
    (void)(fputc((126), oportdata((r[3]))));
    r[6] = (cdr((r[1])));
    r[6] = (cdr((r[6])));
    /* r[0] */    
    r[1] = r[6];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v348;
  } else {
    r[6+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (mksymbol(internsym("format")));
    r[6+3] = (cx__23139);
    r[6+4] = (cdr((r[1])));
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }
  } else {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  } else {
    r[5] = (car((r[1])));
    (void)(fputc(char_from_obj(r[5]), oportdata((r[3]))));
    r[5] = (cdr((r[1])));
    /* r[0] */    
    r[1] = r[5];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v348;
  }
  }

case 11: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop olst flst k */
    r[6] = (cdr((r[4])));
    r[6] = (cdr((r[6])));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[6];  
    r[3] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 12: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop olst flst k */
    r[6] = (cdr((r[4])));
    r[6] = (cdr((r[6])));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[6];  
    r[3] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
