/* sfc.sf */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_sfc
#endif
#define MODULE module_sfc
#define LOAD() 

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
int getimmu(obj o, int t) {
  assert(isimm(o, t));
  return (int)((o >> 8) & 0xffffff);
}
int getimms(obj o, int t) {
  assert(isimm(o, t));
  return (int)((((o >> 8) & 0xffffff) ^ 0x800000) - 0x800000);
}
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifndef NDEBUG
int isnative(obj o, cxtype_t *tp) {
  return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp; 
}
void *getnative(obj o, cxtype_t *tp) {
  assert(isnative(o, tp));
  return (void*)(*objptr_from_obj(o));
}
#endif
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
int istagged(obj o, int t) {
  if (!isobjptr(o)) return 0;
  else { obj h = objptr_from_obj(o)[-1];
    return notaptr(h) && size_from_obj(h) >= 1 
      && hblkref(o, 0) == obj_from_size(t); }
}
obj cktagged(obj o, int t) {
  assert(istagged(o, t));
  return o;
}
int taggedlen(obj o, int t) {
  assert(istagged(o, t));
  return hblklen(o) - 1;
}
obj* taggedref(obj o, int t, int i) {
  int len; assert(istagged(o, t));
  len = hblklen(o);
  assert(i >= 0 && i < len-1);  
  return &hblkref(o, i+1);
}
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
static cxtype_t cxt_flonum = { "flonum", free };
cxtype_t *FLONUM_NTAG = &cxt_flonum;
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
flonum_t *dupflonum(flonum_t f) {
  flonum_t *pf = cxm_cknull(malloc(sizeof(flonum_t)), "malloc(flonum)");
  *pf = f; return pf;
}
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
static cxtype_t cxt_string = { "string", free };
cxtype_t *STRING_NTAG = &cxt_string;
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
char* stringref(obj o, int i) {
  int *d = stringdata(o);
  assert(i >= 0 && i < *d);  
  return ((char*)(d+1))+i;
}
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
int *newstring(char *s) {
  int l, *d; assert(s); l = strlen(s); 
  d = cxm_cknull(malloc(sizeof(int)+l+1), "malloc(string)");
  *d = l; strcpy((char*)(d+1), s); return d;
}
extern int *allocstring(int n, int c);
int *allocstring(int n, int c) {
  int *d; char *s; assert(n+1 > 0); 
  d = cxm_cknull(malloc(sizeof(int)+n+1), "malloc(string)");
  *d = n; s = (char*)(d+1); memset(s, c, n); s[n] = 0;
  return d;
}
extern int *substring(int *d, int from, int to);
int *substring(int *d0, int from, int to) {
  int n = to-from, *d1; char *s0, *s1; assert(d0);
  assert(0 <= from && from <= to && to <= *d0); 
  d1 = cxm_cknull(malloc(sizeof(int)+n+1), "malloc(string)");
  *d1 = n; s0 = (char*)(d0+1); s1 = (char*)(d1+1); 
  memcpy(s1, s0+from, n); s1[n] = 0;
  return d1;
}
extern int *stringcat(int *d0, int *d1);
int *stringcat(int *d0, int *d1) {
  int l0 = *d0, l1 = *d1, n = l0+l1; char *s0, *s1, *s;
  int *d = cxm_cknull(malloc(sizeof(int)+n+1), "malloc(string)");
  *d = n; s = (char*)(d+1); s0 = (char*)(d0+1); s1 = (char*)(d1+1);
  memcpy(s, s0, l0); memcpy(s+l0, s1, l1); s[n] = 0;
  return d;
}
extern int *dupstring(int *d);
int *dupstring(int *d0) {
  int n = *d0, *d1 = cxm_cknull(malloc(sizeof(int)+n+1), "malloc(string)");
  memcpy(d1, d0, sizeof(int)+n+1);
  return d1;
}
extern void stringfill(int *d, int c);
void stringfill(int *d, int c) {
  int l = *d, i; char *s = (char*)(d+1);
  for (i = 0; i < l; ++i) s[i] = c;
}
extern int strcmp_ci(char *s1, char*s2);
int strcmp_ci(char *s1, char *s2) {
  int c1, c2, d;
  do { c1 = *s1++; c2 = *s2++; d = (unsigned)tolower(c1) - (unsigned)tolower(c2); }
  while (!d && c1 && c2);
  return d;
}
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
static struct { char **a; char ***v; size_t sz; size_t u; size_t maxu; } symt;
static unsigned long hashs(char *s) {
  unsigned long i = 0, l = (unsigned long)strlen(s), h = l;
  while (i < l) h = (h << 4) ^ (h >> 28) ^ s[i++];
  return h ^ (h  >> 10) ^ (h >> 20);
}
extern char *symbolname(int sym);
char *symbolname(int sym) {
  assert(sym >= 0); assert(sym < (int)symt.u);
  return symt.a[sym];
}
extern int internsym(char *name);
int internsym(char *name) {
  size_t i, j; /* based on a code (C) 1998, 1999 by James Clark. */
  if (symt.sz == 0) { /* init */
    symt.a = cxm_cknull(calloc(64, sizeof(char*)), "symtab[0]");
    symt.v = cxm_cknull(calloc(64, sizeof(char**)), "symtab[1]");
    symt.sz = 64, symt.maxu = 64 / 2;
    i = hashs(name) & (symt.sz-1);
  } else {
    unsigned long h = hashs(name);
    for (i = h & (symt.sz-1); symt.v[i]; i = (i-1) & (symt.sz-1))
      if (strcmp(name, *symt.v[i]) == 0) return (int)(symt.v[i] - symt.a);
    if (symt.u == symt.maxu) { /* rehash */
      size_t nsz = symt.sz * 2;
      char **na = cxm_cknull(calloc(nsz, sizeof(char*)), "symtab[2]");
      char ***nv = cxm_cknull(calloc(nsz, sizeof(char**)), "symtab[3]");
      for (i = 0; i < symt.sz; i++)
        if (symt.v[i]) {
          for (j = hashs(*symt.v[i]) & (nsz-1); nv[j]; j = (j-1) & (nsz-1)) ;
          nv[j] = symt.v[i] - symt.a + na;
        }
      free(symt.v); symt.v = nv; symt.sz = nsz; symt.maxu = nsz / 2;
      memcpy(na, symt.a, symt.u * sizeof(char*)); free(symt.a); symt.a = na; 
      for (i = h & (symt.sz-1); symt.v[i]; i = (i-1) & (symt.sz-1)) ;
    }
  }
  *(symt.v[i] = symt.a + symt.u) = 
    strcpy(cxm_cknull(malloc(strlen(name)+1), "symtab[4]"), name);
  return (int)((symt.u)++);
}
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
static void ipclose(void *vp) {
  /* FILE *fp = vp; assert(fp); 
   * cannot fclose(fp) here because of FILE reuse! */ 
}
static cxtype_t cxt_iport = { "iport", ipclose };
cxtype_t *IPORT_NTAG = &cxt_iport;
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
static void opclose(void *vp) {
  /* FILE *fp = vp; assert(fp); 
   * cannot fclose(fp) here because of FILE reuse! */ 
}
static cxtype_t cxt_oport = { "oport", opclose };
cxtype_t *OPORT_NTAG = &cxt_oport;
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
obj cx__2Acurrent_2Derror_2Dport_2A; /* *current-error-port* */
obj cx__2Acurrent_2Dinput_2Dport_2A; /* *current-input-port* */
obj cx__2Acurrent_2Doutput_2Dport_2A; /* *current-output-port* */
obj cx_assoc; /* assoc */
obj cx_equal_3F; /* equal? */
obj cx_fixnum_2D_3Estring; /* fixnum->string */
obj cx_flonum_2D_3Estring; /* flonum->string */
obj cx_fxexpt; /* fxexpt */
obj cx_list_3F; /* list? */
obj cx_make_2Dpromise; /* make-promise */
obj cx_member; /* member */
obj cx_reset; /* reset */
obj cx_set_2Dreset_2Dhandler_21; /* set-reset-handler! */
obj cx_string_2D_3Efixnum; /* string->fixnum */
obj cx_string_2D_3Eflonum; /* string->flonum */
obj cx_vector_2Dfill_21; /* vector-fill! */
obj cx_with_2Dinput_2Dfrom_2Dfile; /* with-input-from-file */
obj cx_with_2Doutput_2Dto_2Dfile; /* with-output-to-file */

/* helper functions */
/* vector-fill! */
static obj cxs_vector_2Dfill_21(obj v14_v, obj v13_x)
{ 
  { /* letrec */
    obj v18_i;
  { /* let */
    obj v178_tmp = obj_from_fixnum(0);
    /* tail call */
    v18_i = (v178_tmp);
    goto s_loop;
  }
  s_loop:
  if ((fixnum_from_obj(v18_i) == (vectorlen((v14_v))))) {
    return ((0) ? obj_from_bool(0) : obj_from_void(0));
  } else {
    (void) obj_from_void(vectorref((v14_v), fixnum_from_obj(v18_i)) = (v13_x));
  { /* let */
    obj v177_tmp = obj_from_fixnum(fixnum_from_obj(v18_i) + (1));
    /* tail call */
    v18_i = (v177_tmp);
    goto s_loop;
  }
  }
  }
}

/* equal? */
static obj cxs_equal_3F(obj v72_x, obj v71_y)
{ 
  s_equal_3F:
  { /* let */
    obj v80_x = (((v72_x) == (v71_y)) ? obj_from_bool((v72_x) == (v71_y)) : ((is_flonum_obj(v72_x)) ? ((is_flonum_obj(v71_y)) ? obj_from_bool(flonum_from_obj(v72_x) == flonum_from_obj(v71_y)) : obj_from_bool(0)) : obj_from_bool(0)));
  if (bool_from_obj(v80_x)) {
    return (v80_x);
  } else {
  if ((isstring((v72_x)))) {
    return ((isstring((v71_y))) ? obj_from_bool(strcmp(stringchars((v72_x)), stringchars((v71_y))) == 0) : obj_from_bool(0));
  } else {
  if ((isvector((v72_x)))) {
  if ((isvector((v71_y)))) {
  if (((vectorlen((v72_x))) == (vectorlen((v71_y))))) {
  { /* letrec */
    obj v97_i;
  { /* let */
    obj v176_tmp = obj_from_fixnum(0);
    /* tail call */
    v97_i = (v176_tmp);
    goto s_loop;
  }
  s_loop:
  if ((fixnum_from_obj(v97_i) == (vectorlen((v72_x))))) {
    return obj_from_bool(1);
  } else {
  if (bool_from_obj(cxs_equal_3F((vectorref((v72_x), fixnum_from_obj(v97_i))), (vectorref((v71_y), fixnum_from_obj(v97_i)))))) {
  { /* let */
    obj v175_tmp = obj_from_fixnum(fixnum_from_obj(v97_i) + (1));
    /* tail call */
    v97_i = (v175_tmp);
    goto s_loop;
  }
  } else {
    return obj_from_bool(0);
  }
  }
  }
  } else {
    return obj_from_bool(0);
  }
  } else {
    return obj_from_bool(0);
  }
  } else {
  if ((ispair((v72_x)))) {
  if ((ispair((v71_y)))) {
  if (bool_from_obj(cxs_equal_3F((car((v72_x))), (car((v71_y)))))) {
  { /* let */
    obj v174_tmp = (cdr((v71_y)));
    obj v173_tmp = (cdr((v72_x)));
    /* tail call */
    v72_x = (v173_tmp);
    v71_y = (v174_tmp);
    goto s_equal_3F;
  }
  } else {
    return obj_from_bool(0);
  }
  } else {
    return obj_from_bool(0);
  }
  } else {
  if ((isbox((v72_x)))) {
  if ((isbox((v71_y)))) {
  { /* let */
    obj v172_tmp = (boxref((v71_y)));
    obj v171_tmp = (boxref((v72_x)));
    /* tail call */
    v72_x = (v171_tmp);
    v71_y = (v172_tmp);
    goto s_equal_3F;
  }
  } else {
    return obj_from_bool(0);
  }
  } else {
    return obj_from_bool(0);
  }
  }
  }
  }
  }
  }
}

/* member */
static obj cxs_member(obj v112_x, obj v111_l)
{ 
  { /* letrec */
    obj v114_l;
    /* tail call */
    v114_l = (v111_l);
    goto s_member_v113;
  s_member_v113:
  if ((isnull((v114_l)))) {
    return obj_from_bool(0);
  } else {
  if (bool_from_obj(cxs_equal_3F((v112_x), (car((v114_l)))))) {
    return (v114_l);
  } else {
  { /* let */
    obj v170_tmp = (cdr((v114_l)));
    /* tail call */
    v114_l = (v170_tmp);
    goto s_member_v113;
  }
  }
  }
  }
}

/* assoc */
static obj cxs_assoc(obj v123_x, obj v122_l)
{ 
  s_assoc:
  if ((isnull((v122_l)))) {
    return obj_from_bool(0);
  } else {
  { /* let */
    obj v125_p = (car((v122_l)));
  if (bool_from_obj(cxs_equal_3F((v123_x), (car((v125_p)))))) {
    return (v125_p);
  } else {
  { /* let */
    obj v169_tmp = (cdr((v122_l)));
    obj v168_tmp = (v123_x);
    /* tail call */
    v123_x = (v168_tmp);
    v122_l = (v169_tmp);
    goto s_assoc;
  }
  }
  }
  }
}

/* gc roots */
static obj *globv[] = {
  &cx__2Acurrent_2Derror_2Dport_2A,
  &cx__2Acurrent_2Dinput_2Dport_2A,
  &cx__2Acurrent_2Doutput_2Dport_2A,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[22] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 10
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    { static obj c[] = { obj_from_case(1) }; cx_fxexpt = (obj)c; }
    { static obj c[] = { obj_from_case(4) }; cx_vector_2Dfill_21 = (obj)c; }
    { static obj c[] = { obj_from_case(5) }; cx_list_3F = (obj)c; }
    { static obj c[] = { obj_from_case(6) }; cx_fixnum_2D_3Estring = (obj)c; }
    { static obj c[] = { obj_from_case(7) }; cx_flonum_2D_3Estring = (obj)c; }
    { static obj c[] = { obj_from_case(8) }; cx_string_2D_3Efixnum = (obj)c; }
    { static obj c[] = { obj_from_case(9) }; cx_string_2D_3Eflonum = (obj)c; }
    { static obj c[] = { obj_from_case(10) }; cx_make_2Dpromise = (obj)c; }
    cx__2Acurrent_2Dinput_2Dport_2A = (mkiport(0, stdin));
    { static obj c[] = { obj_from_case(13) }; cx_with_2Dinput_2Dfrom_2Dfile = (obj)c; }
    cx__2Acurrent_2Doutput_2Dport_2A = (mkoport(0, stdout));
    cx__2Acurrent_2Derror_2Dport_2A = (mkoport(0, stderr));
    { static obj c[] = { obj_from_case(15) }; cx_with_2Doutput_2Dto_2Dfile = (obj)c; }
    { static obj c[] = { obj_from_case(17) }; cx_equal_3F = (obj)c; }
    { static obj c[] = { obj_from_case(18) }; cx_member = (obj)c; }
    { static obj c[] = { obj_from_case(19) }; cx_assoc = (obj)c; }
    { static obj c[] = { obj_from_case(20) }; cx_reset = (obj)c; }
    { static obj c[] = { obj_from_case(21) }; cx_set_2Dreset_2Dhandler_21 = (obj)c; }
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* fxexpt k x y */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k x y */
    r[3+0] = r[0];  
    r[3+1] = r[2];  
    r[3+2] = r[1];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_ex;

s_ex: /* k y x */
    { const fixnum_t v415_y = fixnum_from_obj(r[1]);
  if (((v415_y) == 0)) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_fixnum(1);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((fixnum_from_obj(r[2]) == 0)) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_fixnum(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((v415_y) < (0))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_fixnum(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((v415_y) == (1))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((v415_y) % 2 != 0)) {
    hreserve(hbsz(2+1), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(2);
    r[3] = (hendblk(2+1));
    r[0] = r[3];  
    r[1] = obj_from_fixnum((v415_y) - (1));
    /* r[2] */    
    goto s_ex;
  } else {
    hreserve(hbsz(1+1), 3); /* 3 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(3);
    r[3] = (hendblk(1+1));
    r[0] = r[3];  
    r[1] = obj_from_fixnum((v415_y) / (2));
    /* r[2] */    
    goto s_ex;
  }
  }
  }
  }
  } } 

case 2: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k x */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = obj_from_fixnum(fixnum_from_obj(r[3]) * fixnum_from_obj(r[1]));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 3: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { const fixnum_t v414_r = fixnum_from_obj(r[1]);
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_fixnum((v414_r) * (v414_r));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump; } 

case 4: /* vector-fill! k v x */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k v x */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (cxs_vector_2Dfill_21((r[1]), (r[2])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 5: /* list? k o */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k o */
    { /* list? */
    obj l = (r[1]), s = l;
    for (;;) {
    if (isnull(l)) { r[2] = obj_from_bool(1); break; }
    else if (!ispair(l)) { r[2] = obj_from_bool(0); break; }
    else if ((l = cdr(l)) == s) { r[2] = obj_from_bool(0); break; }
    else if (isnull(l)) { r[2] = obj_from_bool(1); break; }
    else if (!ispair(l)) { r[2] = obj_from_bool(0); break; }
    else if ((l = cdr(l)) == s) { r[2] = obj_from_bool(0); break; }
    else s = cdr(s); } }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 6: /* fixnum->string k n r */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k n r */
    { /* fixnum->string */
    char buf[35], *s = buf + sizeof(buf) - 1; 
    int neg = 0;
    int num = fixnum_from_obj(r[1]);
    int radix = fixnum_from_obj(r[2]);
    if (num < 0) { neg = 1; num = -num; }
    *s = 0;
    do { int d = num % radix; *--s = d < 10 ? d + '0' : d - 10 + 'a'; }
    while (num /= radix);
    if (neg) *--s = '-';
    r[3] = (hpushstr(3, newstring(s))); }
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 7: /* flonum->string k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    { /* flonum->string */
    char buf[30], *s;
    sprintf(buf, "%.17g", flonum_from_obj(r[1]));
    for (s = buf; *s != 0; s++) if (*s == 'e' || *s == '.') break;
    if (*s == 0) {  *s++ = '.'; *s++ = '0'; *s = 0; }
    r[2] = (hpushstr(2, newstring(buf))); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 8: /* string->fixnum k s r */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k s r */
    { /* string->fixnum */
    char *e, *s = stringchars((r[1]));
    int radix = fixnum_from_obj(r[2]);
    long l;
    if (s[0] == '#' && (s[1] == 'b' || s[1] == 'B')) s += 2, radix = 2;
    else if (s[0] == '#' && (s[1] == 'o' || s[1] == 'O')) s += 2, radix = 8;
    else if (s[0] == '#' && (s[1] == 'd' || s[1] == 'D')) s += 2, radix = 10;
    else if (s[0] == '#' && (s[1] == 'x' || s[1] == 'X')) s += 2, radix = 16;
    l = (errno = 0, strtol(s, &e, radix));
    if (errno || l < FIXNUM_MIN || l > FIXNUM_MAX || e == s || *e) r[3] = obj_from_bool(0);
    else r[3] = obj_from_fixnum((int)l); }
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 9: /* string->flonum k s */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k s */
    { /* string->flonum */
    char *e, *s = stringchars((r[1]));
    double d = (errno = 0, strtod(s, &e));
    if (errno || e == s || *e) r[2] = obj_from_bool(0);
    else r[2] = obj_from_flonum(2, d); }
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 10: /* make-promise k proc */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k proc */
    hreserve(hbsz(1), 2); /* 2 live regs */
    *--hp = obj_from_bool(0);
    r[2] = (hendblk(1));
    hreserve(hbsz(1), 3); /* 3 live regs */
    *--hp = obj_from_bool(0);
    r[3] = (hendblk(1));
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(11);
    r[2] = (hendblk(3+1));
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 11: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k proc result result-ready? */
  if (bool_from_obj(objptr_from_obj(r[3])[0])) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[2])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = obj_from_case(12);
    r[4] = (hendblk(3+1));
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  }

case 12: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r k result result-ready? */
  if (bool_from_obj(objptr_from_obj(r[4])[0])) {
    r[5] = (objptr_from_obj(r[3])[0]);
  } else {
    (void)(objptr_from_obj(r[4])[0] = obj_from_bool(1));
    (void)(objptr_from_obj(r[3])[0] = (r[1]));
    r[5] = (objptr_from_obj(r[3])[0]);
  }
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* with-input-from-file k fn thunk */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k fn thunk */
    r[3] = (cx__2Acurrent_2Dinput_2Dport_2A);
    r[4] = (mkiport(4, cxm_cknull(fopen(stringchars((r[1])), "r"), "fopen")));
    cx__2Acurrent_2Dinput_2Dport_2A = r[4];  
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = obj_from_case(14);
    r[5] = (hendblk(3+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 14: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r k p0 p1 */
    (void)(fclose(iportdata((r[4]))));
    cx__2Acurrent_2Dinput_2Dport_2A = r[3];  
    r[5] = r[1];  
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 15: /* with-output-to-file k fn thunk */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k fn thunk */
    r[3] = (cx__2Acurrent_2Doutput_2Dport_2A);
    r[4] = (mkoport(4, cxm_cknull(fopen(stringchars((r[1])), "w"), "fopen")));
    cx__2Acurrent_2Doutput_2Dport_2A = r[4];  
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = obj_from_case(16);
    r[5] = (hendblk(3+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r k p0 p1 */
    (void)(fclose(oportdata((r[4]))));
    cx__2Acurrent_2Doutput_2Dport_2A = r[3];  
    r[5] = r[1];  
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 17: /* equal? k x y */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k x y */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (cxs_equal_3F((r[1]), (r[2])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 18: /* member k x l */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k x l */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (cxs_member((r[1]), (r[2])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 19: /* assoc k x l */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k x l */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = (cxs_assoc((r[1]), (r[2])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 20: /* reset k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = r[0];  
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = obj_from_ktrap();
    r[1+2] = obj_from_void(exit(1));
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 21: /* set-reset-handler! k fn */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k fn */
    cx_reset = r[1];  
    r[2] = obj_from_void(0);
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
