/* c2real.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_c2real
#endif
#define MODULE module_c2real
#define LOAD() module_attr(); module_cenv(); module_ast(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_ast(void); /* ast.ss */
extern void module_cenv(void); /* cenv.ss */
extern void module_attr(void); /* attr.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_ce_2Dbind; /* ce-bind */
extern obj cx_gen_2Dreg_2A; /* gen-reg* */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_lookup_2Dfmap; /* lookup-fmap */
extern obj cx_member; /* member */
obj cx_complex_2D_3Ereal; /* complex->real */
static obj cx__231658; /* constant #1658 */
static obj cx__231666; /* constant #1666 */
static obj cx__231674; /* constant #1674 */
static obj cx__231847; /* constant #1847 */

/* gc roots */
static obj *globv[] = {
  &cx_complex_2D_3Ereal,
  &cx__231658,
  &cx__231666,
  &cx__231674,
  &cx__231847,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[194] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 30
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__231658 = (hpushstr(0, newstring("float size")));
    cx__231666 = (hpushstr(0, newstring("double size")));
    cx__231674 = (hpushstr(0, newstring("REAL size")));
    cx__231847 = (hpushstr(0, newstring("no clause matches ~s")));
    hreserve(hbsz(1), 0); /* 0 live regs */
    *--hp = obj_from_fixnum(0);
    r[0] = (hendblk(1));
    hreserve(hbsz(1+1), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(1);
    r[0] = (hendblk(1+1));
    hreserve(hbsz(1), 1); /* 1 live regs */
    *--hp = obj_from_void(0);
    r[1] = (hendblk(1));
    hreserve(hbsz(1), 2); /* 2 live regs */
    *--hp = obj_from_void(0);
    r[2] = (hendblk(1));
    hreserve(hbsz(1), 3); /* 3 live regs */
    *--hp = obj_from_void(0);
    r[3] = (hendblk(1));
    hreserve(hbsz(1), 4); /* 4 live regs */
    *--hp = obj_from_void(0);
    r[4] = (hendblk(1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(3);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(8);
    r[6] = (hendblk(1+1));
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(14);
    r[7] = (hendblk(1+1));
    hreserve(hbsz(1+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(20);
    r[8] = (hendblk(1+1));
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = obj_from_case(25);
    r[9] = (hendblk(2+1));
    hreserve(hbsz(1+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = obj_from_case(28);
    r[10] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("complex-float")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[6];  
    *--hp = obj_from_case(29);
    r[11] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("complex-double")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[6];  
    *--hp = obj_from_case(30);
    r[11] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(31);
    r[11] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("complex-float")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(32);
    r[12] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("complex-double")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(33);
    r[12] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(34);
    r[12] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("complex-dot-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(3+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(112);
    r[13] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-dot-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(39);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-dot-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(42);
    r[13] = (hendblk(0+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-norm-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(43);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-norm-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(47);
    r[13] = (hendblk(0+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-norm-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(48);
    r[13] = (hendblk(0+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(49);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(55);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_case(113);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-sub-i")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_case(121);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-add-i")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(3+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(129);
    r[13] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-cmadd")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(3+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(153);
    r[13] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-cmul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(61);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-rmsub")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(68);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-rmadd")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(3+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(141);
    r[13] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-madd")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(3+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(163);
    r[13] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-mul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(75);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-rmul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(80);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-sub")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(87);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_case(173);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-times-minus-i")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_case(179);
    r[13] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-times-plus-i")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(94);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-neg")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(99);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-imag")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(101);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(103);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("complex-move")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(106);
    r[13] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-zero")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    (void)(objptr_from_obj(r[1])[0] = obj_from_fixnum(0));
    (void)(objptr_from_obj(r[2])[0] = (r[10]));
    (void)(objptr_from_obj(r[3])[0] = (r[11]));
    (void)(objptr_from_obj(r[4])[0] = (r[12]));
    hreserve(hbsz(3+1), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(193);
    r[10] = (hendblk(3+1));
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(109);
    cx_complex_2D_3Ereal = (hendblk(1+1));
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k n */
    hreserve(hbsz(2+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = r[0];  
    *--hp = obj_from_case(2);
    r[2] = (hendblk(2+1));
    r[3] = (objptr_from_obj(r[1])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_gen_2Dreg_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[2];  
    r[4+2] = (mksymbol(internsym("r")));
    r[4+3] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 2: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k n */
    r[4] = (objptr_from_obj(r[3])[0]);
    r[4] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    (void)(objptr_from_obj(r[3])[0] = (r[4]));
    r[4] = r[1];  
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 3: /* clo k env base part */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k env base part new-reg */
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("complex->real")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(4);
    r[6] = (hendblk(1+1));
    hreserve(hbsz(3+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(5);
    r[7] = (hendblk(3+1));
    r[8+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[5];  
    r[8+4] = r[6];  
    r[8+5] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 4: /* clo k val */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k val env */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[1];  
    r[3+3] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 5: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k new-reg key env */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(6);
    r[4] = (hendblk(3+1));
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 6: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r key env k */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(7);
    r[5] = (hendblk(2+1));
    r[6+0] = (cx_ce_2Dbind);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[3];  
    r[6+3] = r[2];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 7: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r[4+3] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 8: /* clo k attr* addr* value r-type msg r* env */
    assert(rc == 9);
    { obj* p = objptr_from_obj(r[0]);
    r[1+8] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r-type msg r* env c2r-rename */
    hreserve(hbsz(8+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(9);
    r[9] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(12);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(13);
    r[12] = (hendblk(1+1));
    r[13+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[9];  
    r[13+2] = r[7];  
    r[13+3] = (r[10]);
    r[13+4] = (r[11]);
    r[13+5] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 9: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename value k r* addr* r-type attr* */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(10);
    r[11] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = r[4];  
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 10: /* clo k x-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x-re env c2r-rename value k r* off-im addr* r-type attr* */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(11);
    r[11] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = r[4];  
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 11: /* clo k x-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k x-im env k r* off-im addr* r-type attr* x-re */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-store")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { fixnum_t v6658_tmp;
    { /* length */
    int n; obj l = r[6];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v6658_tmp = (n); }
    { /* append */
    obj t, l, o, *p, *d; int c = (v6658_tmp);
    hreserve(hbsz(3)*c, 12); /* 12 live regs */
    l = r[6];   t = r[5];   /* gc-safe */
    o = t; p = &o; 
    for (; l != mknull(); l = cdr(l)) {
    *--hp = t; d = hp; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); 
    *p = hendblk(3); p = d; }  
    r[12] = (o); } }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-store")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 12); /* 12 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[10] = (p); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 12: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k msg */
    r[2+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = r[0];  
    r[2+2] = (mksymbol(internsym("ce-lookup-x")));
    r[2+3] = (r[1]);
    r[2+4] = (mknull());
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 14: /* clo k attr* type output addr* real-type msg r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type output addr* real-type msg r* env c2r-rename */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[7];  
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = obj_from_case(15);
    r[10] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(18);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = obj_from_case(19);
    r[13] = (hendblk(1+1));
    r[14+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = r[8];  
    r[14+3] = (r[11]);
    r[14+4] = (r[12]);
    r[14+5] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 15: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename output k r* addr* real-type attr* */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(16);
    r[11] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = r[4];  
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 16: /* clo k x-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x-re env c2r-rename output k r* off-im addr* real-type attr* */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(17);
    r[11] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = r[4];  
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 17: /* clo k x-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k x-im env k r* off-im addr* real-type attr* x-re */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-load")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { fixnum_t v6657_tmp;
    { /* length */
    int n; obj l = r[6];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v6657_tmp = (n); }
    { /* append */
    obj t, l, o, *p, *d; int c = (v6657_tmp);
    hreserve(hbsz(3)*c, 11); /* 11 live regs */
    l = r[6];   t = r[5];   /* gc-safe */
    o = t; p = &o; 
    for (; l != mknull(); l = cdr(l)) {
    *--hp = t; d = hp; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); 
    *p = hendblk(3); p = d; }  
    r[11] = (o); } }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-load")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 12); /* 12 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[10] = (p); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 18: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 19: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k msg */
    r[2+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = r[0];  
    r[2+2] = (mksymbol(internsym("ce-lookup-x")));
    r[2+3] = (r[1]);
    r[2+4] = (mknull());
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 20: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(21);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 21: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env input* c2r-rename output* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(22);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 22: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename output* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(23);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 23: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename output* k r* a-im attr* a-re */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(24);
    r[10] = (hendblk(6+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 24: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* a-im attr* b-re a-re */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 11); /* 11 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 25: /* clo k c2r-xxx attr* output* input* r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1];
    r[1+8] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c2r-xxx attr* output* input* r* env c2r-complex-move *reg-count* */
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = obj_from_case(26);
    r[9] = (hendblk(9+1));
    r[10] = (objptr_from_obj(r[8])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    r[11+0] = (cx_gen_2Dreg_2A);
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[9];  
    r[11+2] = (mksymbol(internsym("cr")));
    r[11+3] = (r[10]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 26: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r c2r-xxx env r* input* c2r-complex-move output* attr* k *reg-count* */
    r[11] = (objptr_from_obj(r[10])[0]);
    r[11] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    (void)(objptr_from_obj(r[10])[0] = (r[11]));
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = r[6];  
    *--hp = obj_from_case(27);
    r[13] = (hendblk(5+1));
    r[14+0] = r[2];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[8];  
    r[14+3] = (r[12]);
    r[14+4] = r[5];  
    r[14+5] = r[4];  
    r[14+6] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 27: /* clo k r* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k r* env c2r-complex-move r output* attr* k */
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[6];  
    r[8+3] = r[5];  
    r[8+4] = r[4];  
    r[8+5] = r[1];  
    r[8+6] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 28: /* clo k attr* type addr* value r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type addr* value r* env c2r-store-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[3];  
    r[8+4] = r[4];  
    r[8+5] = (mksymbol(internsym("float")));
    r[8+6] = (cx__231658);
    r[8+7] = (r[5]);
    r[8+8] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;

case 29: /* clo k attr* type addr* value r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type addr* value r* env c2r-store-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[3];  
    r[8+4] = r[4];  
    r[8+5] = (mksymbol(internsym("double")));
    r[8+6] = (cx__231666);
    r[8+7] = (r[5]);
    r[8+8] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;

case 30: /* clo k attr* type addr* value r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type addr* value r* env c2r-store-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[3];  
    r[8+4] = r[4];  
    r[8+5] = (mksymbol(internsym("REAL")));
    r[8+6] = (cx__231674);
    r[8+7] = (r[5]);
    r[8+8] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;

case 31: /* clo k attr* type output addr* r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type output addr* r* env c2r-load-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[2];  
    r[8+4] = r[3];  
    r[8+5] = r[4];  
    r[8+6] = (mksymbol(internsym("float")));
    r[8+7] = (cx__231658);
    r[8+8] = (r[5]);
    r[8+9] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 32: /* clo k attr* type output addr* r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type output addr* r* env c2r-load-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[2];  
    r[8+4] = r[3];  
    r[8+5] = r[4];  
    r[8+6] = (mksymbol(internsym("double")));
    r[8+7] = (cx__231666);
    r[8+8] = (r[5]);
    r[8+9] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 33: /* clo k attr* type output addr* r* env */
    assert(rc == 8);
    { obj* p = objptr_from_obj(r[0]);
    r[1+7] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* type output addr* r* env c2r-load-x */
    r[8+0] = r[7];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[2];  
    r[8+4] = r[3];  
    r[8+5] = r[4];  
    r[8+6] = (mksymbol(internsym("REAL")));
    r[8+7] = (cx__231674);
    r[8+8] = (r[5]);
    r[8+9] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 34: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = obj_from_case(35);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[2])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 35: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* c2r-rename input* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(36);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 36: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(37);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 37: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im attr* a-re */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(38);
    r[10] = (hendblk(6+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 38: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* a-im attr* a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 11); /* 11 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 39: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(40);
    r[7] = (hendblk(5+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[2])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 40: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env c2r-rename output* k r* attr* */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(41);
    r[8] = (hendblk(4+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 41: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env k r* attr* a-re */
    { /* vector */
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("double-zero")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("double-zero")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 42: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env */
    { /* vector */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[1]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[6] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 7); /* 7 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[6] = (p); }
    r[7+0] = r[0];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = obj_from_ktrap();
    r[7+2] = r[6];  
    r[7+3] = r[5];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 43: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename */
    r[8] = (car((r[3])));
    hreserve(hbsz(8+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = obj_from_case(44);
    r[9] = (hendblk(8+1));
    r[10+0] = r[6];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 44: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* output* attr* a */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(45);
    r[10] = (hendblk(8+1));
    r[11] = (cdr((r[4])));
    r[11] = (car((r[11])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (r[11]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 45: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* output* attr* r a */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(46);
    r[11] = (hendblk(7+1));
    r[12] = (cdr((r[4])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 46: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* output* attr* r a b-re */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 12); /* 12 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[10] = (p); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 47: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env */
    { /* vector */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = (mksymbol(internsym("double-zero")));
    *--hp = (r[1]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[6] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 7); /* 7 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[6] = (p); }
    r[7+0] = r[0];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = obj_from_ktrap();
    r[7+2] = r[6];  
    r[7+3] = r[5];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 48: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env */
    { /* vector */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[1]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[6] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 7); /* 7 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[6] = (p); }
    r[7+0] = r[0];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = obj_from_ktrap();
    r[7+2] = r[6];  
    r[7+3] = r[5];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 49: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = obj_from_case(50);
    r[8] = (hendblk(7+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 50: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename k r* output* attr* input* */
    r[9] = (car((r[8])));
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = r[3];  
    *--hp = obj_from_case(51);
    r[10] = (hendblk(8+1));
    r[11] = (cdr((r[8])));
    r[11] = (car((r[11])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (r[11]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 51: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env c2r-rename input* k r* output* attr* r s */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(52);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[4])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 52: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* output* attr* r s a-re */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(53);
    r[12] = (hendblk(10+1));
    r[13] = (cdr((r[4])));
    r[13] = (cdr((r[13])));
    r[13] = (car((r[13])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 53: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* output* a-im attr* r s a-re */
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(54);
    r[13] = (hendblk(9+1));
    r[14] = (cdr((r[4])));
    r[14] = (cdr((r[14])));
    r[14] = (car((r[14])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (r[14]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 54: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* output* a-im attr* r s a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 14); /* 14 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[12] = (p); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 55: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = obj_from_case(56);
    r[8] = (hendblk(7+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 56: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* output* attr* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(57);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 57: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env c2r-rename input* k r* output* attr* r */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(58);
    r[10] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 58: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* output* attr* r a-re */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(59);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[4])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 59: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* output* a-im attr* r a-re */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(60);
    r[12] = (hendblk(8+1));
    r[13] = (cdr((r[4])));
    r[13] = (car((r[13])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 60: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* output* a-im attr* r a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 13); /* 13 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[11] = (p); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r[12+3] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 61: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(62);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 62: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env c2r-rename output* k r* attr* input* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(63);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 63: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename output* k r* attr* a-re input* */
    r[10] = (cdr((r[9])));
    r[10] = (car((r[10])));
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[9];  
    *--hp = obj_from_case(64);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[9])));
    r[12] = (cdr((r[12])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 64: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env input* c2r-rename output* k r* a-im attr* a-re b */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(65);
    r[12] = (hendblk(9+1));
    r[13] = (cdr((r[3])));
    r[13] = (cdr((r[13])));
    r[13] = (car((r[13])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 65: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env c2r-rename output* k r* a-im attr* a-re b c-re */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(66);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 66: /* clo k d-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k d-re env c2r-rename output* k r* a-im c-im attr* a-re b c-re */
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(67);
    r[13] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 67: /* clo k d-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k d-im env k r* a-im c-im attr* d-re a-re b c-re */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 14); /* 14 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[12] = (p); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 68: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(69);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 69: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env c2r-rename output* k r* attr* input* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(70);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 70: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename output* k r* a-re attr* input* */
    r[10] = (cdr((r[9])));
    r[10] = (car((r[10])));
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[9];  
    *--hp = obj_from_case(71);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[9])));
    r[12] = (cdr((r[12])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 71: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env input* c2r-rename output* k r* a-re attr* a-im b */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(72);
    r[12] = (hendblk(9+1));
    r[13] = (cdr((r[3])));
    r[13] = (cdr((r[13])));
    r[13] = (car((r[13])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 72: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env c2r-rename output* k r* a-re c-re attr* a-im b */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(73);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 73: /* clo k d-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k d-re env c2r-rename output* k r* a-re c-re attr* a-im b c-im */
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(74);
    r[13] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 74: /* clo k d-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k d-im env k r* d-re a-re c-re attr* a-im b c-im */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 14); /* 14 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[12] = (p); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 75: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    r[7] = (car((r[3])));
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(76);
    r[8] = (hendblk(7+1));
    r[9] = (cdr((r[3])));
    r[9] = (car((r[9])));
    r[10+0] = r[6];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[8];  
    r[10+2] = r[5];  
    r[10+3] = r[9];  
    r[10+4] = (mksymbol(internsym("real")));
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 76: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env input* c2r-rename output* k r* attr* a */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(77);
    r[10] = (hendblk(7+1));
    r[11] = (cdr((r[3])));
    r[11] = (car((r[11])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (r[11]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 77: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename output* k r* attr* a b-re */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(78);
    r[10] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 78: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename output* k r* b-im attr* a b-re */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(79);
    r[11] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 79: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* b-im attr* c-re a b-re */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 12); /* 12 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[10] = (p); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 80: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(81);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 81: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env input* c2r-rename output* k r* attr* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(82);
    r[9] = (hendblk(7+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 82: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env input* c2r-rename output* k r* attr* a-re */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(83);
    r[10] = (hendblk(8+1));
    r[11] = (cdr((r[3])));
    r[11] = (car((r[11])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (r[11]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 83: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env input* c2r-rename output* k r* a-im attr* a-re */
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(84);
    r[11] = (hendblk(8+1));
    r[12] = (cdr((r[3])));
    r[12] = (car((r[12])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 84: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename output* k r* a-im attr* a-re b-re */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(85);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 85: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename output* k r* a-im b-im attr* a-re b-re */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(86);
    r[12] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 86: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im b-im attr* c-re a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-sub")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-sub")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 13); /* 13 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[11] = (p); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r[12+3] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 87: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(88);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 88: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env input* c2r-rename output* k r* attr* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(89);
    r[9] = (hendblk(7+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 89: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env input* c2r-rename output* k r* attr* a-re */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(90);
    r[10] = (hendblk(8+1));
    r[11] = (cdr((r[3])));
    r[11] = (car((r[11])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (r[11]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 90: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env input* c2r-rename output* k r* a-im attr* a-re */
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(91);
    r[11] = (hendblk(8+1));
    r[12] = (cdr((r[3])));
    r[12] = (car((r[12])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 91: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename output* k r* a-im attr* a-re b-re */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(92);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 92: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename output* k r* a-im b-im attr* a-re b-re */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(93);
    r[12] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 93: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im b-im attr* c-re a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-add")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-add")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 13); /* 13 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[11] = (p); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r[12+3] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 94: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(95);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 95: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env input* c2r-rename output* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(96);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 96: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename output* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(97);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 97: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename output* k r* a-im attr* a-re */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(98);
    r[10] = (hendblk(6+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 98: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* a-im attr* b-re a-re */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-neg")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-neg")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 11); /* 11 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 99: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = obj_from_case(100);
    r[7] = (hendblk(4+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("imag")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 100: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env k r* output* attr* */
    { /* vector */
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 8); /* 8 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 101: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = obj_from_case(102);
    r[7] = (hendblk(4+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[3])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 102: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env k r* output* attr* */
    { /* vector */
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 8); /* 8 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 103: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(104);
    r[7] = (hendblk(6+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[2])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 104: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename output* k r* attr* input* */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(105);
    r[9] = (hendblk(5+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 105: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* attr* b-re input* */
    r[8] = (car((r[7])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 10); /* 10 live regs */
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    r[9] = (cdr((r[7])));
    r[9] = (car((r[9])));
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 10); /* 10 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[8] = (p); }
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = obj_from_ktrap();
    r[9+2] = r[8];  
    r[9+3] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 106: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = obj_from_case(107);
    r[7] = (hendblk(5+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[5];  
    r[8+3] = (car((r[2])));
    r[8+4] = (mksymbol(internsym("real")));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 107: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename output* k r* attr* */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(108);
    r[8] = (hendblk(4+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 108: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* attr* b-re */
    { /* vector */
    hreserve(hbsz(2+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("double-zero")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("double-zero")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 9); /* 9 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[7] = (p); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 109: /* clo k ast env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k ast env c2r-decl */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (2))) {
    r[4] = (vectorref((r[1]), (0)));
    r[4] = obj_from_bool((r[4]) == (mksymbol(internsym("qa0-top"))));
  } else {
    r[4] = obj_from_bool(0);
  }
  } else {
    r[4] = obj_from_bool(0);
  }
  if (bool_from_obj(r[4])) {
    r[4] = (vectorref((r[1]), (1)));
    r[5+0] = r[0];  
    r[5+1] = (mknull());
    r[5+2] = r[4];  
    r[5+3] = r[2];  
    r[5+4] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (mksymbol(internsym("variant-case")));
    r[5+3] = (cx__231847);
    r[5+4] = (r[4]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 110: /* clo k r* decl* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k r* decl* env c2r-decl */
  if ((isnull((r[2])))) {
    { fixnum_t v6656_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v6656_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v6656_tmp);
    hreserve(hbsz(3)*c, 5); /* 5 live regs */
    l = r[1];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[5] = (o); } }
    { /* vector */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("qa0-top")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[5] = (hendblk(2+1)); }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(110);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = obj_from_case(111);
    r[5] = (hendblk(4+1));
    r[6+0] = r[4];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (car((r[2])));
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 111: /* clo k d e */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k d e loop decl* r* k */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[6];  
    r[8+2] = r[7];  
    r[8+3] = (cdr((r[4])));
    r[8+4] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 112: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename c2r-split */
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    /* r[6] */    
    /* r[7] */    
    /* r[8] */    
    goto s_c2r_2Dcomplex_2Dcmadd;

case 113: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename c2r-split */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(113);
    r[8] = (hendblk(2+1));
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(114);
    r[8] = (hendblk(9+1));
    r[9+0] = (cx_member);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = (car((r[2])));
    r[9+3] = (cdr((r[3])));
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 114: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r c2r-rename c2r-split env r* input* output* attr* c2r-complex-sub-i k */
  if (bool_from_obj(r[1])) {
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[7];  
    r[11+5] = r[6];  
    r[11+6] = r[5];  
    r[11+7] = r[4];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(6+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(115);
    r[11] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[4];  
    r[3] = (car((r[7])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 115: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* c2r-rename input* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(116);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 116: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(117);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 117: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im attr* a-re */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(118);
    r[10] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 118: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im attr* a-re b-re */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(119);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[4])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 119: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im b-im attr* a-re b-re */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(120);
    r[12] = (hendblk(8+1));
    r[13] = (cdr((r[4])));
    r[13] = (car((r[13])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 120: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im b-im c-re attr* a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-add")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-sub")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 13); /* 13 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[11] = (p); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r[12+3] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 121: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename c2r-split */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(121);
    r[8] = (hendblk(2+1));
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(122);
    r[8] = (hendblk(9+1));
    r[9+0] = (cx_member);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = (car((r[2])));
    r[9+3] = (cdr((r[3])));
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 122: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r c2r-rename c2r-split env r* input* output* attr* c2r-complex-add-i k */
  if (bool_from_obj(r[1])) {
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[7];  
    r[11+5] = r[6];  
    r[11+6] = r[5];  
    r[11+7] = r[4];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(6+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(123);
    r[11] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[4];  
    r[3] = (car((r[7])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 123: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* c2r-rename input* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(124);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 124: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(125);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 125: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im attr* a-re */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(126);
    r[10] = (hendblk(8+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 126: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im attr* a-re b-re */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(127);
    r[11] = (hendblk(9+1));
    r[12] = (cdr((r[4])));
    r[12] = (car((r[12])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 127: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im b-im attr* a-re b-re */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(128);
    r[12] = (hendblk(8+1));
    r[13] = (cdr((r[4])));
    r[13] = (car((r[13])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (r[13]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 128: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im b-im c-re attr* a-re b-re */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("double-sub")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("double-add")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 13); /* 13 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[11] = (p); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = obj_from_ktrap();
    r[12+2] = (r[11]);
    r[12+3] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 129: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
s_c2r_2Dcomplex_2Dcmadd: /* k attr* output* input* r* env new-reg c2r-rename c2r-split */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(129);
    r[9] = (hendblk(3+1));
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(130);
    r[9] = (hendblk(10+1));
    r[10+0] = (cx_member);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = (car((r[2])));
    r[10+3] = (cdr((r[3])));
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 130: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg c2r-rename c2r-split env r* input* output* attr* c2r-complex-cmadd k */
  if (bool_from_obj(r[1])) {
    r[12+0] = r[4];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[8];  
    r[12+5] = r[7];  
    r[12+6] = r[6];  
    r[12+7] = r[5];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = obj_from_case(131);
    r[12] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[5];  
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 131: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* new-reg c2r-rename input* k r* attr* */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(132);
    r[10] = (hendblk(7+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 132: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env new-reg c2r-rename input* k r* a-re attr* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(133);
    r[10] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 133: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg env c2r-rename input* k r* a-im a-re attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(134);
    r[11] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 134: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* a-im a-re attr* r */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(135);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 135: /* clo k x-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k x-re env c2r-rename input* k r* a-im a-re r attr* r */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(136);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 136: /* clo k x-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k x-im env c2r-rename input* k r* a-im a-re r attr* r x-re */
    hreserve(hbsz(11+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(137);
    r[13] = (hendblk(11+1));
    r[14] = (cdr((r[4])));
    r[14] = (car((r[14])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (r[14]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 137: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im a-re r x-im attr* r x-re */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(138);
    r[14] = (hendblk(12+1));
    r[15] = (cdr((r[4])));
    r[15] = (car((r[15])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    r[3] = (r[15]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 138: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im a-re r x-im attr* r x-re b-re */
    hreserve(hbsz(13+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(139);
    r[15] = (hendblk(13+1));
    r[16] = (cdr((r[4])));
    r[16] = (cdr((r[16])));
    r[16] = (car((r[16])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[15]);
    /* r[2] */    
    r[3] = (r[16]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 139: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12];
    r[1+15] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im a-re b-im r x-im attr* r x-re b-re */
    hreserve(hbsz(12+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(140);
    r[16] = (hendblk(12+1));
    r[17] = (cdr((r[4])));
    r[17] = (cdr((r[17])));
    r[17] = (car((r[17])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    /* r[2] */    
    r[3] = (r[17]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 140: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im a-re b-im r x-im attr* r x-re b-re c-re */
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (mknull());
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (mknull());
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (mknull());
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[19] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*5, 19); /* 19 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[15] = (p); }
    r[16+0] = r[3];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = obj_from_ktrap();
    r[16+2] = (r[15]);
    r[16+3] = r[2];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 141: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename c2r-split */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(141);
    r[9] = (hendblk(3+1));
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(142);
    r[9] = (hendblk(10+1));
    r[10+0] = (cx_member);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = (car((r[2])));
    r[10+3] = (cdr((r[3])));
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 142: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg c2r-rename c2r-split env r* input* output* attr* c2r-complex-madd k */
  if (bool_from_obj(r[1])) {
    r[12+0] = r[4];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[8];  
    r[12+5] = r[7];  
    r[12+6] = r[6];  
    r[12+7] = r[5];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = obj_from_case(143);
    r[12] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[5];  
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 143: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* new-reg c2r-rename input* k r* attr* */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(144);
    r[10] = (hendblk(7+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 144: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env new-reg c2r-rename input* k r* a-re attr* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(145);
    r[10] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 145: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg env c2r-rename input* k r* a-im a-re attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(146);
    r[11] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 146: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* a-im a-re attr* r */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(147);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 147: /* clo k x-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k x-re env c2r-rename input* k r* a-im a-re r attr* r */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(148);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 148: /* clo k x-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k x-im env c2r-rename input* k r* a-im a-re r attr* r x-re */
    hreserve(hbsz(11+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(149);
    r[13] = (hendblk(11+1));
    r[14] = (cdr((r[4])));
    r[14] = (car((r[14])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (r[14]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 149: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im a-re r x-im attr* r x-re */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(150);
    r[14] = (hendblk(12+1));
    r[15] = (cdr((r[4])));
    r[15] = (car((r[15])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    r[3] = (r[15]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 150: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im a-re r x-im attr* r x-re b-re */
    hreserve(hbsz(13+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(151);
    r[15] = (hendblk(13+1));
    r[16] = (cdr((r[4])));
    r[16] = (cdr((r[16])));
    r[16] = (car((r[16])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[15]);
    /* r[2] */    
    r[3] = (r[16]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 151: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12];
    r[1+15] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im a-re b-im r x-im attr* r x-re b-re */
    hreserve(hbsz(12+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(152);
    r[16] = (hendblk(12+1));
    r[17] = (cdr((r[4])));
    r[17] = (cdr((r[17])));
    r[17] = (car((r[17])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    /* r[2] */    
    r[3] = (r[17]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 152: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im a-re b-im r x-im attr* r x-re b-re c-re */
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (mknull());
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 19); /* 19 live regs */
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 19); /* 19 live regs */
    *--hp = (mknull());
    *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[18] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 19); /* 19 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[19] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 20); /* 20 live regs */
    *--hp = (mknull());
    *--hp = (r[19]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[19] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 20); /* 20 live regs */
    *--hp = (r[18]);
    *--hp = (r[19]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[18] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*5, 19); /* 19 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[18]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[15] = (p); }
    r[16+0] = r[3];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = obj_from_ktrap();
    r[16+2] = (r[15]);
    r[16+3] = r[2];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 153: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename c2r-split */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(153);
    r[9] = (hendblk(3+1));
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(154);
    r[9] = (hendblk(10+1));
    r[10+0] = (cx_member);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = (car((r[2])));
    r[10+3] = r[3];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 154: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg c2r-rename c2r-split env r* input* output* attr* c2r-complex-cmul k */
  if (bool_from_obj(r[1])) {
    r[12+0] = r[4];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[8];  
    r[12+5] = r[7];  
    r[12+6] = r[6];  
    r[12+7] = r[5];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = obj_from_case(155);
    r[12] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[5];  
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 155: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* new-reg c2r-rename input* k r* attr* */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(156);
    r[10] = (hendblk(7+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 156: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env new-reg c2r-rename input* k r* a-re attr* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(157);
    r[10] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 157: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg env c2r-rename input* k r* a-im a-re attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(158);
    r[11] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 158: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* a-im a-re attr* r */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(159);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 159: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im a-re r attr* r */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(160);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 160: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im a-re r attr* r b-re */
    hreserve(hbsz(11+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(161);
    r[13] = (hendblk(11+1));
    r[14] = (cdr((r[4])));
    r[14] = (car((r[14])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (r[14]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 161: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im a-re b-im r attr* r b-re */
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(162);
    r[14] = (hendblk(10+1));
    r[15] = (cdr((r[4])));
    r[15] = (car((r[15])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    r[3] = (r[15]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 162: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im a-re b-im r attr* r b-re c-re */
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (r[14]);
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 16); /* 16 live regs */
    *--hp = (r[14]);
    *--hp = (r[15]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*5, 17); /* 17 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[13] = (p); }
    r[14+0] = r[3];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = obj_from_ktrap();
    r[14+2] = (r[13]);
    r[14+3] = r[2];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 163: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env new-reg c2r-rename c2r-split */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(163);
    r[9] = (hendblk(3+1));
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(164);
    r[9] = (hendblk(10+1));
    r[10+0] = (cx_member);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = (car((r[2])));
    r[10+3] = r[3];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 164: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg c2r-rename c2r-split env r* input* output* attr* c2r-complex-mul k */
  if (bool_from_obj(r[1])) {
    r[12+0] = r[4];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[8];  
    r[12+5] = r[7];  
    r[12+6] = r[6];  
    r[12+7] = r[5];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = obj_from_case(165);
    r[12] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[5];  
    r[3] = (car((r[8])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 165: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* new-reg c2r-rename input* k r* attr* */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(166);
    r[10] = (hendblk(7+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 166: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env new-reg c2r-rename input* k r* a-re attr* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(167);
    r[10] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 167: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg env c2r-rename input* k r* a-im a-re attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(168);
    r[11] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 168: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r env c2r-rename input* k r* a-im a-re attr* r */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(169);
    r[11] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 169: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im a-re r attr* r */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(170);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 170: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env c2r-rename input* k r* a-im a-re r attr* r b-re */
    hreserve(hbsz(11+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(171);
    r[13] = (hendblk(11+1));
    r[14] = (cdr((r[4])));
    r[14] = (car((r[14])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = (r[14]);
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 171: /* clo k c-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k c-re env c2r-rename input* k r* a-im a-re b-im r attr* r b-re */
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(172);
    r[14] = (hendblk(10+1));
    r[15] = (cdr((r[4])));
    r[15] = (car((r[15])));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    r[3] = (r[15]);
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 172: /* clo k c-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k c-im env k r* a-im a-re b-im r attr* r b-re c-re */
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (r[14]);
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 16); /* 16 live regs */
    *--hp = (r[14]);
    *--hp = (r[15]);
    *--hp = (mksymbol(internsym("double-mul")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 17); /* 17 live regs */
    *--hp = (r[15]);
    *--hp = (r[16]);
    *--hp = (mksymbol(internsym("double-msub")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (mknull());
    *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[17] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 18); /* 18 live regs */
    *--hp = (mknull());
    *--hp = (r[17]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[17] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 18); /* 18 live regs */
    *--hp = (r[16]);
    *--hp = (r[17]);
    *--hp = (mksymbol(internsym("double-madd")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[16] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*5, 17); /* 17 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[16]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[13] = (p); }
    r[14+0] = r[3];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = obj_from_ktrap();
    r[14+2] = (r[13]);
    r[14+3] = r[2];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 173: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename c2r-split */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(179);
    r[8] = (hendblk(2+1));
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(174);
    r[8] = (hendblk(9+1));
    r[9+0] = (cx_member);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = (car((r[2])));
    r[9+3] = r[3];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 174: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r c2r-rename c2r-split env r* input* output* attr* c2r-complex-times-plus-i k */
  if (bool_from_obj(r[1])) {
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[7];  
    r[11+5] = r[6];  
    r[11+6] = r[5];  
    r[11+7] = r[4];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(6+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(175);
    r[11] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[4];  
    r[3] = (car((r[7])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 175: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* c2r-rename input* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(176);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 176: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* a-re attr* */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(177);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 177: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-re attr* a-im */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(178);
    r[10] = (hendblk(6+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 178: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* a-re attr* a-im b-re */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-neg")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 11); /* 11 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 179: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env c2r-rename c2r-split */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(179);
    r[8] = (hendblk(2+1));
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(180);
    r[8] = (hendblk(9+1));
    r[9+0] = (cx_member);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = (car((r[2])));
    r[9+3] = r[3];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 180: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r c2r-rename c2r-split env r* input* output* attr* c2r-complex-times-plus-i k */
  if (bool_from_obj(r[1])) {
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[7];  
    r[11+5] = r[6];  
    r[11+6] = r[5];  
    r[11+7] = r[4];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    hreserve(hbsz(6+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(181);
    r[11] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[4];  
    r[3] = (car((r[7])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 181: /* clo k a-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-re env output* c2r-rename input* k r* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(182);
    r[9] = (hendblk(6+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[3])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 182: /* clo k a-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k a-im env c2r-rename input* k r* attr* a-re */
    hreserve(hbsz(7+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(183);
    r[9] = (hendblk(7+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("real")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 183: /* clo k b-re env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k b-re env c2r-rename input* k r* a-im attr* a-re */
    hreserve(hbsz(6+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(184);
    r[10] = (hendblk(6+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    /* r[2] */    
    r[3] = (car((r[4])));
    r[4] = (mksymbol(internsym("imag")));
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 184: /* clo k b-im env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k b-im env k r* a-im b-re attr* a-re */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("double-neg")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("double-move")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*3, 11); /* 11 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_c2r_2Dloop: /* k c attr* var low high code* r* env c2r-store* c2r-load* c2r-op* */
    hreserve(hbsz(6+1), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[0];  
    *--hp = obj_from_case(185);
    r[12] = (hendblk(6+1));
    r[0] = (r[12]);
    r[1] = r[6];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_c2r_2Dcode_2A;

case 185: /* clo k c* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k c* env k r* high low var attr* */
    { /* vector */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-loop")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(6+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_c2r_2Dif: /* k c var true-code* false-code* r* env c2r-store* c2r-load* c2r-op* */
    hreserve(hbsz(3+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(189);
    r[10] = (hendblk(3+1));
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = (r[10]);
    *--hp = obj_from_case(186);
    r[11] = (hendblk(5+1));
    r[0] = (r[11]);
    r[1] = r[3];  
    r[2] = r[6];  
    r[3] = r[7];  
    r[4] = r[8];  
    r[5] = r[9];  
    goto s_c2r_2Dcode_2A;

case 186: /* clo k t* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k t* env c2r-code* false-code* k r* var */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(187);
    r[8] = (hendblk(4+1));
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[4];  
    r[9+3] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 187: /* clo k f* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k f* env k r* t* var */
    { /* vector */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-if")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(4+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[4];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 188: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k c r* env c2r-store* c2r-load* c2r-op* */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-operation"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[6])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = r[2];  
    r[12+6] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-load"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[5])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[8];  
    r[12+4] = r[9];  
    r[12+5] = (r[10]);
    r[12+6] = r[2];  
    r[12+7] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-store"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[4])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[8];  
    r[12+4] = r[9];  
    r[12+5] = (r[10]);
    r[12+6] = r[2];  
    r[12+7] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 8);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (6))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-loop"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (vectorref((r[1]), (5)));
    r[12+0] = r[0];  
    r[12+1] = r[1];  
    r[12+2] = r[7];  
    r[12+3] = r[8];  
    r[12+4] = r[9];  
    r[12+5] = (r[10]);
    r[12+6] = (r[11]);
    r[12+7] = r[2];  
    r[12+8] = r[3];  
    r[12+9] = r[4];  
    r[12+10] = r[5];  
    r[12+11] = r[6];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c2r_2Dloop;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (4))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-if"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10+0] = r[0];  
    r[10+1] = r[1];  
    r[10+2] = r[7];  
    r[10+3] = r[8];  
    r[10+4] = r[9];  
    r[10+5] = r[2];  
    r[10+6] = r[3];  
    r[10+7] = r[4];  
    r[10+8] = r[5];  
    r[10+9] = r[6];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c2r_2Dif;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = (mksymbol(internsym("variant-case")));
    r[8+3] = (cx__231847);
    r[8+4] = (r[7]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }
  }

case 189: /* clo k code* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
s_c2r_2Dcode_2A: /* k code* env c2r-store* c2r-load* c2r-op* */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(188);
    r[6] = (hendblk(3+1));
    r[7+0] = r[0];  
    r[7+1] = (mknull());
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v3845;

case 190: /* clo k r* code* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v3845: /* k r* code* env c2r-code */
  if ((isnull((r[2])))) {
    { fixnum_t v6655_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v6655_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v6655_tmp);
    hreserve(hbsz(3)*c, 5); /* 5 live regs */
    l = r[1];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[5] = (o); } }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(190);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = obj_from_case(191);
    r[5] = (hendblk(3+1));
    r[6+0] = r[4];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (car((r[2])));
    r[6+3] = r[1];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 191: /* clo k r* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k r* env loop code* k */
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (cdr((r[4])));
    r[6+4] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

s_c2r_2Dproc: /* k attr* name arg-name* arg-type* arg-c-name* arg-c-type* code* env c2r-store* c2r-load* c2r-op* */
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = obj_from_case(192);
    r[12] = (hendblk(7+1));
    r[0] = (r[12]);
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_c2r_2Dcode_2A;

case 192: /* clo k c* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k c* env k arg-c-type* arg-c-name* arg-type* arg-name* name attr* */
    { /* vector */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-proc")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(8+1)); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 193: /* clo k decl env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k decl env c2r-store* c2r-load* c2r-op* */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (8))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-proc"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
    r[10] = (vectorref((r[1]), (5)));
    r[11] = (vectorref((r[1]), (6)));
    r[12] = (vectorref((r[1]), (7)));
    r[13+0] = r[0];  
    r[13+1] = r[6];  
    r[13+2] = r[7];  
    r[13+3] = r[8];  
    r[13+4] = r[9];  
    r[13+5] = (r[10]);
    r[13+6] = (r[11]);
    r[13+7] = (r[12]);
    r[13+8] = r[2];  
    r[13+9] = r[3];  
    r[13+10] = r[4];  
    r[13+11] = r[5];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c2r_2Dproc;
  } else {
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
