/* q2complex.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_q2complex
#endif
#define MODULE module_q2complex
#define LOAD() module_attr(); module_cenv(); module_ast(); module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */
extern void module_ast(void); /* ast.ss */
extern void module_cenv(void); /* cenv.ss */
extern void module_attr(void); /* attr.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_attr_2Dsearch; /* attr-search */
extern obj cx_ce_2Dbind; /* ce-bind */
extern obj cx_gen_2Dreg_2A; /* gen-reg* */
extern obj cx_ic_2Derror_2A; /* ic-error* */
extern obj cx_lookup_2Dfmap; /* lookup-fmap */
extern obj cx_s_2Derror_2A; /* s-error* */
obj cx_qcd_2D_3Ecomplex; /* qcd->complex */
static obj cx__231021; /* constant #1021 */
static obj cx__231050; /* constant #1050 */
static obj cx__231051; /* constant #1051 */
static obj cx__231082; /* constant #1082 */
static obj cx__231150; /* constant #1150 */
static obj cx__231331; /* constant #1331 */
static obj cx__231332; /* constant #1332 */
static obj cx__231437; /* constant #1437 */
static obj cx__231438; /* constant #1438 */
static obj cx__231544; /* constant #1544 */
static obj cx__231545; /* constant #1545 */
static obj cx__231656; /* constant #1656 */
static obj cx__231657; /* constant #1657 */
static obj cx__231768; /* constant #1768 */
static obj cx__231769; /* constant #1769 */
static obj cx__231860; /* constant #1860 */
static obj cx__231861; /* constant #1861 */
static obj cx__231939; /* constant #1939 */
static obj cx__231940; /* constant #1940 */
static obj cx__232027; /* constant #2027 */
static obj cx__232028; /* constant #2028 */
static obj cx__232052; /* constant #2052 */
static obj cx__232063; /* constant #2063 */
static obj cx__232133; /* constant #2133 */
static obj cx__232134; /* constant #2134 */
static obj cx__232149; /* constant #2149 */
static obj cx__232150; /* constant #2150 */
static obj cx__232194; /* constant #2194 */
static obj cx__232233; /* constant #2233 */
static obj cx__232234; /* constant #2234 */
static obj cx__232263; /* constant #2263 */
static obj cx__232264; /* constant #2264 */
static obj cx__232279; /* constant #2279 */
static obj cx__232280; /* constant #2280 */
static obj cx__232296; /* constant #2296 */
static obj cx__232297; /* constant #2297 */
static obj cx__232312; /* constant #2312 */
static obj cx__232313; /* constant #2313 */
static obj cx__232393; /* constant #2393 */
static obj cx__232394; /* constant #2394 */
static obj cx__232434; /* constant #2434 */
static obj cx__232435; /* constant #2435 */
static obj cx__232450; /* constant #2450 */
static obj cx__232451; /* constant #2451 */
static obj cx__232664; /* constant #2664 */
static obj cx__232665; /* constant #2665 */
static obj cx__232898; /* constant #2898 */
static obj cx__233181; /* constant #3181 */
static obj cx__23445; /* constant #445 */
static obj cx__23454; /* constant #454 */
static obj cx__23461; /* constant #461 */
static obj cx__23489; /* constant #489 */
static obj cx__23569; /* constant #569 */
static obj cx__23598; /* constant #598 */
static obj cx__23599; /* constant #599 */
static obj cx__23607; /* constant #607 */
static obj cx__23734; /* constant #734 */
static obj cx__23735; /* constant #735 */
static obj cx__23743; /* constant #743 */
static obj cx__23762; /* constant #762 */
static obj cx__23876; /* constant #876 */
static obj cx__23877; /* constant #877 */
static obj cx__23885; /* constant #885 */
static obj cx__23891; /* constant #891 */
static obj cx__23929; /* constant #929 */
static obj cx__23935; /* constant #935 */

/* gc roots */
static obj *globv[] = {
  &cx_qcd_2D_3Ecomplex,
  &cx__231021,
  &cx__231050,
  &cx__231051,
  &cx__231082,
  &cx__231150,
  &cx__231331,
  &cx__231332,
  &cx__231437,
  &cx__231438,
  &cx__231544,
  &cx__231545,
  &cx__231656,
  &cx__231657,
  &cx__231768,
  &cx__231769,
  &cx__231860,
  &cx__231861,
  &cx__231939,
  &cx__231940,
  &cx__232027,
  &cx__232028,
  &cx__232052,
  &cx__232063,
  &cx__232133,
  &cx__232134,
  &cx__232149,
  &cx__232150,
  &cx__232194,
  &cx__232233,
  &cx__232234,
  &cx__232263,
  &cx__232264,
  &cx__232279,
  &cx__232280,
  &cx__232296,
  &cx__232297,
  &cx__232312,
  &cx__232313,
  &cx__232393,
  &cx__232394,
  &cx__232434,
  &cx__232435,
  &cx__232450,
  &cx__232451,
  &cx__232664,
  &cx__232665,
  &cx__232898,
  &cx__233181,
  &cx__23445,
  &cx__23454,
  &cx__23461,
  &cx__23489,
  &cx__23569,
  &cx__23598,
  &cx__23599,
  &cx__23607,
  &cx__23734,
  &cx__23735,
  &cx__23743,
  &cx__23762,
  &cx__23876,
  &cx__23877,
  &cx__23885,
  &cx__23891,
  &cx__23929,
  &cx__23935,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[404] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 35
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    cx__23445 = (hpushstr(0, newstring("qcd-unproject-sub")));
    cx__23454 = (hpushstr(0, newstring("unproj op-table for ~a")));
    cx__23461 = (hpushstr(0, newstring("Color count")));
    cx__23489 = (hpushstr(0, newstring("Unknown unproject operation ~a")));
    cx__23569 = (hpushstr(0, newstring("Unprojection operation")));
    cx__23598 = (hpushstr(0, newstring("QCD gamma unproject-sub sources")));
    cx__23599 = (hpushstr(0, newstring("QCD gamma unproject-sub result")));
    cx__23607 = (hpushstr(0, newstring("qcd-unproject-add")));
    cx__23734 = (hpushstr(0, newstring("QCD gamma unproject-add sources")));
    cx__23735 = (hpushstr(0, newstring("QCD gamma unproject-add result")));
    cx__23743 = (hpushstr(0, newstring("qcd-unproject")));
    cx__23762 = (hpushstr(0, newstring("Fermion dim")));
    cx__23876 = (hpushstr(0, newstring("QCD gamma unprojection source")));
    cx__23877 = (hpushstr(0, newstring("QCD gamma unprojection result")));
    cx__23885 = (hpushstr(0, newstring("qcd-project")));
    cx__23891 = (hpushstr(0, newstring("project op-table for ~a")));
    cx__23929 = (hpushstr(0, newstring("Unknown first factor (~a ~a)")));
    cx__23935 = (hpushstr(0, newstring("Unknown second factor (~a ~a)")));
    cx__231021 = (hpushstr(0, newstring("Projection operation")));
    cx__231050 = (hpushstr(0, newstring("QCD gamma projection source")));
    cx__231051 = (hpushstr(0, newstring("QCD gamma projection result")));
    cx__231082 = (hpushstr(0, newstring("ERROR: ~a")));
    cx__231150 = (hpushstr(0, newstring("Field dimension")));
    cx__231331 = (hpushstr(0, newstring("QCD mul inputs")));
    cx__231332 = (hpushstr(0, newstring("QCD mul outputs")));
    cx__231437 = (hpushstr(0, newstring("QCD msub inputs")));
    cx__231438 = (hpushstr(0, newstring("QCD msub outputs")));
    cx__231544 = (hpushstr(0, newstring("QCD madd inputs")));
    cx__231545 = (hpushstr(0, newstring("QCD madd outputs")));
    cx__231656 = (hpushstr(0, newstring("QCD msub-lohi inputs")));
    cx__231657 = (hpushstr(0, newstring("QCD msub-lohi outputs")));
    cx__231768 = (hpushstr(0, newstring("QCD madd-lohi inputs")));
    cx__231769 = (hpushstr(0, newstring("QCD madd-lohi outputs")));
    cx__231860 = (hpushstr(0, newstring("QCD scale inputs")));
    cx__231861 = (hpushstr(0, newstring("QCD scale outputs")));
    cx__231939 = (hpushstr(0, newstring("QCD zero inputs")));
    cx__231940 = (hpushstr(0, newstring("QCD zero outputs")));
    cx__232027 = (hpushstr(0, newstring("QCD add inputs")));
    cx__232028 = (hpushstr(0, newstring("QCD add outputs")));
    cx__232052 = (hpushstr(0, newstring("Fermion size")));
    cx__232063 = (hpushstr(0, newstring("complex size")));
    cx__232133 = (hpushstr(0, newstring("QCD staggered fermion dot fini inputs")));
    cx__232134 = (hpushstr(0, newstring("QCD staggered fermion dot fini outputs")));
    cx__232149 = (hpushstr(0, newstring("QCD fermion dot fini inputs")));
    cx__232150 = (hpushstr(0, newstring("QCD fermion dot fini outputs")));
    cx__232194 = (hpushstr(0, newstring("Fermion dimension")));
    cx__232233 = (hpushstr(0, newstring("QCD fermion dot add inputs")));
    cx__232234 = (hpushstr(0, newstring("QCD fermion dot add outputs")));
    cx__232263 = (hpushstr(0, newstring("QCD staggered fermion dot init inputs")));
    cx__232264 = (hpushstr(0, newstring("QCD staggered fermion dot init outputs")));
    cx__232279 = (hpushstr(0, newstring("QCD fermion dot init inputs")));
    cx__232280 = (hpushstr(0, newstring("QCD fermion dot init outputs")));
    cx__232296 = (hpushstr(0, newstring("QCD staggered fermion norm fini inputs")));
    cx__232297 = (hpushstr(0, newstring("QCD staggered fermion norm fini outputs")));
    cx__232312 = (hpushstr(0, newstring("QCD fermion norm fini inputs")));
    cx__232313 = (hpushstr(0, newstring("QCD fermion norm fini outputs")));
    cx__232393 = (hpushstr(0, newstring("QCD fermion norm add inputs")));
    cx__232394 = (hpushstr(0, newstring("QCD fermion norm add outputs")));
    cx__232434 = (hpushstr(0, newstring("QCD staggered fermion norm init inputs")));
    cx__232435 = (hpushstr(0, newstring("QCD staggered fermion norm init outputs")));
    cx__232450 = (hpushstr(0, newstring("QCD fermion norm init inputs")));
    cx__232451 = (hpushstr(0, newstring("QCD fermion norm init outputs")));
    cx__232664 = (hpushstr(0, newstring("qcd-su-n-real-trace-conj-mul inputs")));
    cx__232665 = (hpushstr(0, newstring("qcd-su-n-real-trace-conj-mul outputs")));
    cx__232898 = (hpushstr(0, newstring("double size")));
    cx__233181 = (hpushstr(0, newstring("no clause matches ~s")));
    hreserve(hbsz(1), 0); /* 0 live regs */
    *--hp = obj_from_fixnum(0);
    r[0] = (hendblk(1));
    hreserve(hbsz(1+1), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(1);
    r[0] = (hendblk(1+1));
    hreserve(hbsz(0+1), 1); /* 1 live regs */
    *--hp = obj_from_case(3);
    r[1] = (hendblk(0+1));
    hreserve(hbsz(1), 2); /* 2 live regs */
    *--hp = obj_from_void(0);
    r[2] = (hendblk(1));
    hreserve(hbsz(1), 3); /* 3 live regs */
    *--hp = obj_from_void(0);
    r[3] = (hendblk(1));
    hreserve(hbsz(1), 4); /* 4 live regs */
    *--hp = obj_from_void(0);
    r[4] = (hendblk(1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(4);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(16);
    r[6] = (hendblk(2+1));
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(47);
    r[7] = (hendblk(1+1));
    hreserve(hbsz(1+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(52);
    r[8] = (hendblk(1+1));
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(68);
    r[9] = (hendblk(1+1));
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(84);
    r[10] = (hendblk(2+1));
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(96);
    r[11] = (hendblk(2+1));
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(109);
    r[12] = (hendblk(2+1));
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(123);
    r[13] = (hendblk(2+1));
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(135);
    r[14] = (hendblk(2+1));
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(148);
    r[15] = (hendblk(2+1));
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(162);
    r[16] = (hendblk(2+1));
    hreserve(hbsz(1+1), 17); /* 17 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(176);
    r[17] = (hendblk(1+1));
    hreserve(hbsz(1+1), 18); /* 18 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(177);
    r[18] = (hendblk(1+1));
    hreserve(hbsz(1+1), 19); /* 19 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(178);
    r[19] = (hendblk(1+1));
    hreserve(hbsz(1+1), 20); /* 20 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(179);
    r[20] = (hendblk(1+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(180);
    r[21] = (hendblk(1+1));
    hreserve(hbsz(1+1), 22); /* 22 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(181);
    r[22] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 23); /* 23 live regs */
    *--hp = (r[22]);
    *--hp = (mksymbol(internsym("qcd-projected-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 23); /* 23 live regs */
    *--hp = (mknull());
    *--hp = (r[22]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(182);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-staggered-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(183);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-fermion-hi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(184);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-fermion-lo")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(185);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[8];  
    *--hp = obj_from_case(186);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-su-n")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[22] = (hendblk(3)); }
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(187);
    r[23] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (r[23]);
    *--hp = (mksymbol(internsym("qcd-fermion-hi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 24); /* 24 live regs */
    *--hp = (mknull());
    *--hp = (r[23]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(188);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-fermion-lo")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[23]);
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(189);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[23]);
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(190);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-staggered-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[23]);
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(191);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-projected-fermion")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[23]);
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(192);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-su-n")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[23]);
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[23] = (hendblk(3)); }
    hreserve(hbsz(1+1), 24); /* 24 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(193);
    r[24] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (r[24]);
    *--hp = (mksymbol(internsym("qcd-projected-fermion-offset")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 25); /* 25 live regs */
    *--hp = (mknull());
    *--hp = (r[24]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(0+1), 25); /* 25 live regs */
    *--hp = obj_from_case(194);
    r[25] = (hendblk(0+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-staggered-fermion-offset")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(198);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fermion-offset")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[5];  
    *--hp = obj_from_case(199);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-offset")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(200);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-sdot-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[11]);
    *--hp = obj_from_case(203);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-sdot-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(204);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-sdot-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(207);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fdot-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[11]);
    *--hp = obj_from_case(210);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fdot-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(211);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fdot-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(214);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-snorm-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(217);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-snorm-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(218);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-snorm-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(221);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fnorm-fini")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(224);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fnorm-hi-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(225);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fnorm-lo-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(226);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fnorm-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(227);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-fnorm-init")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(230);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msub-lohi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[16]);
    *--hp = obj_from_case(246);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msubs")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[16]);
    *--hp = obj_from_case(247);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msubh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[16]);
    *--hp = obj_from_case(248);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msubf-hi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[16]);
    *--hp = obj_from_case(249);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msubf-lo")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[16]);
    *--hp = obj_from_case(250);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-msubf")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[15]);
    *--hp = obj_from_case(251);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-madds")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[15]);
    *--hp = obj_from_case(252);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-maddh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(253);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-madd-lohi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[15]);
    *--hp = obj_from_case(269);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-maddf-hi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[15]);
    *--hp = obj_from_case(270);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-maddf-lo")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[15]);
    *--hp = obj_from_case(271);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-maddf")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(272);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-subs")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(273);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-subh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(274);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-subf")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(275);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-subu")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(276);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-adds")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(277);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-addh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(278);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-addf")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[12]);
    *--hp = obj_from_case(279);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-addu")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(280);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scales")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(281);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scaleh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(282);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scalef-hi")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(283);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scalef-lo")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(284);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scalef")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(285);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-scaleu")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(286);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-zeros")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(287);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-zeroh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(288);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-zerof")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(1+1), 25); /* 25 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(289);
    r[25] = (hendblk(1+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-zerou")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(290);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-real-trace-conj-mul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[20]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(301);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-conj-mul-conj")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[20]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(302);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-mul-conj")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[20]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(303);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-conj-mul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = (r[20]);
    *--hp = r[6];  
    *--hp = obj_from_case(304);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-su-n-mul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[19]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(305);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-muls-conj")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[18]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(306);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-mulh-conj")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[17]);
    *--hp = (r[21]);
    *--hp = r[6];  
    *--hp = obj_from_case(307);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-mulf-conj")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[19]);
    *--hp = (r[20]);
    *--hp = r[6];  
    *--hp = obj_from_case(308);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-muls")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[18]);
    *--hp = (r[20]);
    *--hp = r[6];  
    *--hp = obj_from_case(309);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-mulh")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(3+1), 25); /* 25 live regs */
    *--hp = (r[17]);
    *--hp = (r[20]);
    *--hp = r[6];  
    *--hp = obj_from_case(310);
    r[25] = (hendblk(3+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-mulf")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(311);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-unproject-sub")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(330);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-unproject-add")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(349);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-unproject")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    hreserve(hbsz(2+1), 25); /* 25 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_case(370);
    r[25] = (hendblk(2+1));
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[25]);
    *--hp = (mksymbol(internsym("qcd-project")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[25] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 26); /* 26 live regs */
    *--hp = (r[24]);
    *--hp = (r[25]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[24] = (hendblk(3)); }
    (void)(objptr_from_obj(r[2])[0] = (r[22]));
    (void)(objptr_from_obj(r[3])[0] = (r[23]));
    (void)(objptr_from_obj(r[4])[0] = (r[24]));
    hreserve(hbsz(3+1), 22); /* 22 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(403);
    r[22] = (hendblk(3+1));
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = (r[22]);
    *--hp = obj_from_case(392);
    cx_qcd_2D_3Ecomplex = (hendblk(1+1));
    r[0] = obj_from_void(0);
    r[1+0] = r[0];
    pc = 0; /* exit from module init */
    r[1+1] = r[0];  
    r += 1; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 1: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k n */
    hreserve(hbsz(2+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = r[0];  
    *--hp = obj_from_case(2);
    r[2] = (hendblk(2+1));
    r[3] = (objptr_from_obj(r[1])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_gen_2Dreg_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[2];  
    r[4+2] = (mksymbol(internsym("c")));
    r[4+3] = (r[3]);
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 2: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k n */
    r[4] = (objptr_from_obj(r[3])[0]);
    r[4] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    (void)(objptr_from_obj(r[3])[0] = (r[4]));
    r[4] = r[1];  
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 3: /* clo k x* size msg */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k x* size msg */
    { bool_t v9550_tmp;
    { fixnum_t v9549_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v9549_tmp = (n); }
    v9550_tmp = ((v9549_tmp) == fixnum_from_obj(r[2])); }
    r[4] = obj_from_bool(!(v9550_tmp)); }
  if (bool_from_obj(r[4])) {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (cx__231082);
    r[5+3] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_void(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 4: /* clo k attr* output* input* c-n f-n t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* c-n f-n t r* env new-reg */
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_case(5);
    r[10] = (hendblk(7+1));
  if (((is_fixnum_obj(r[4])) || (is_flonum_obj(r[4])))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = r[4];  
    r[11+2] = r[5];  
    r[11+3] = r[9];  
    r[11+4] = r[0];  
    r[11+5] = r[8];  
    r[11+6] = r[7];  
    r[11+7] = r[2];  
    r[11+8] = r[3];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v9453;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(14);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(15);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[8];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 5: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
s_l_v9453: /* ek  f-n new-reg k env r* output* input* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(6);
    r[9] = (hendblk(6+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[0] = obj_from_ktrap();
    r[1] = r[2];  
    r[2] = r[3];  
    r[3] = r[4];  
    r[4] = r[5];  
    r[5] = r[6];  
    r[6] = r[7];  
    r[7] = r[8];  
    goto s_l_v9465;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(12);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(13);
    r[12] = (hendblk(0+1));
    r[13+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[9];  
    r[13+2] = r[5];  
    r[13+3] = (r[10]);
    r[13+4] = (r[11]);
    r[13+5] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 6: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
s_l_v9465: /* ek r new-reg k env r* output* input* */
    hreserve(hbsz(7+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(7);
    r[8] = (hendblk(7+1));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(10);
    r[10] = (hendblk(0+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(11);
    r[11] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[4];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 7: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg k env r* output* r input* */
    r[9] = (car((r[8])));
    r[10] = (cdr((r[8])));
    r[10] = (car((r[10])));
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(8);
    r[11] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 8: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r new-reg k env r* output* f c r r */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(9);
    r[12] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 9: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek r k env r* output* f r c r r */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = obj_from_fixnum(fixnum_from_obj(r[9]) * fixnum_from_obj(r[10]));
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("int-mul")));
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[14]);
    *--hp = (mksymbol(internsym("int-mul")));
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("int-add")));
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*4, 15); /* 15 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    *--hp = p; *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[12] = (p); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (r[12]);
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 10: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 11: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232063);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 12: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 13: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232052);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 14: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 15: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 16: /* clo k attr* output* input* f-n r-get op-0 op-k u-get f-get r* env */
    assert(rc == 13);
    { obj* p = objptr_from_obj(r[0]);
    r[1+12] = p[1];
    r[1+13] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* f-n r-get op-0 op-k u-get f-get r* env q2c-check-list new-reg */
    hreserve(hbsz(14+1), 14); /* 14 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = (r[13]);
    *--hp = r[4];  
    *--hp = (r[12]);
    *--hp = obj_from_case(17);
    r[14] = (hendblk(14+1));
    r[15+0] = (r[12]);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[2];  
    r[15+3] = obj_from_fixnum(1);
    r[15+4] = (cx__231332);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 17: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-n new-reg env op-0 r* k r-get u-get f-get op-k attr* output* input* */
    hreserve(hbsz(13+1), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(18);
    r[16] = (hendblk(13+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    r[2] = (r[15]);
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__231331);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 18: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n new-reg env op-0 r* k r-get u-get f-get op-k attr* output* input* */
    hreserve(hbsz(12+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(19);
    r[15] = (hendblk(12+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[0] = obj_from_ktrap();
    r[1] = r[2];  
    r[2] = r[3];  
    r[3] = r[4];  
    r[4] = r[5];  
    r[5] = r[6];  
    r[6] = r[7];  
    r[7] = r[8];  
    r[8] = r[9];  
    r[9] = (r[10]);
    r[10] = (r[11]);
    r[11] = (r[12]);
    r[12] = (r[13]);
    r[13] = (r[14]);
    goto s_l_v9195;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    hreserve(hbsz(0+1), 17); /* 17 live regs */
    *--hp = obj_from_case(45);
    r[17] = (hendblk(0+1));
    hreserve(hbsz(0+1), 18); /* 18 live regs */
    *--hp = obj_from_case(46);
    r[18] = (hendblk(0+1));
    r[19+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[19+0])[0];
    r[19+1] = (r[15]);
    r[19+2] = r[4];  
    r[19+3] = (r[16]);
    r[19+4] = (r[17]);
    r[19+5] = (r[18]);
    r += 19; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 19: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
s_l_v9195: /* ek r new-reg env op-0 r* k r-get u-get f-get op-k attr* output* input* */
    hreserve(hbsz(13+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(20);
    r[14] = (hendblk(13+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("*colors*")));
    r[15+2] = (r[2]);
    r[15+3] = (r[3]);
    r[15+4] = (r[4]);
    r[15+5] = (r[5]);
    r[15+6] = (r[6]);
    r[15+7] = (r[7]);
    r[15+8] = (r[8]);
    r[15+9] = (r[9]);
    r[15+10] = (r[10]);
    r[15+11] = (r[11]);
    r[15+12] = (r[1]);
    r[15+13] = (r[12]);
    r[15+14] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v9207;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    hreserve(hbsz(0+1), 16); /* 16 live regs */
    *--hp = obj_from_case(43);
    r[16] = (hendblk(0+1));
    hreserve(hbsz(0+1), 17); /* 17 live regs */
    *--hp = obj_from_case(44);
    r[17] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = r[3];  
    r[3] = (r[15]);
    r[4] = (r[16]);
    r[5] = (r[17]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13]; }
    r += 1; /* shift reg. wnd */
s_l_v9207: /* ek r new-reg env op-0 r* k r-get u-get f-get op-k attr* r output* input* */
    r[15] = (car((r[14])));
    r[16] = (cdr((r[14])));
    r[16] = (car((r[16])));
    r[17] = (car((r[13])));
  if ((fixnum_from_obj(r[1]) == (1))) {
    hreserve(hbsz(9+1), 18); /* 18 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[4];  
    *--hp = (r[17]);
    *--hp = r[7];  
    *--hp = (r[16]);
    *--hp = r[9];  
    *--hp = obj_from_case(28);
    r[18] = (hendblk(9+1));
    r[19+0] = r[8];  
    pc = objptr_from_obj(r[19+0])[0];
    r[19+1] = (r[18]);
    r[19+2] = (r[15]);
    r[19+3] = obj_from_fixnum(0);
    r[19+4] = obj_from_fixnum(0);
    r[19+5] = r[3];  
    r += 19; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 18); /* 18 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = (r[16]);
    *--hp = r[9];  
    *--hp = (r[15]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(21);
    r[18] = (hendblk(9+1));
    hreserve(hbsz(15+1), 19); /* 19 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = r[3];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[4];  
    *--hp = (r[16]);
    *--hp = r[9];  
    *--hp = (r[15]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(32);
    r[18] = (hendblk(15+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[18]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  }

case 21: /* clo k r-x r-r c r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3];
    r[1+9] = p[4];
    r[1+10] = p[5];
    r[1+11] = p[6];
    r[1+12] = p[7];
    r[1+13] = p[8];
    r[1+14] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k r-x r-r c r* env r-get u-get r-U f-get r-b op-k attr* r r */
    r[15+0] = r[0];  
    r[15+1] = obj_from_fixnum(0);
    r[15+2] = r[4];  
    r[15+3] = r[5];  
    r[15+4] = r[1];  
    r[15+5] = r[6];  
    r[15+6] = r[7];  
    r[15+7] = r[8];  
    r[15+8] = r[9];  
    r[15+9] = r[3];  
    r[15+10] = (r[10]);
    r[15+11] = (r[11]);
    r[15+12] = (r[12]);
    r[15+13] = (r[13]);
    r[15+14] = r[2];  
    r[15+15] = (r[14]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_x_2Dloop;

case 22: /* clo k x r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10];
    r[1+14] = p[11];
    r[1+15] = p[12]; }
    r += 1; /* shift reg. wnd */
s_x_2Dloop: /* k x r* env r-x r-get u-get r-U f-get c r-b op-k attr* r r-r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[15]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    r[4] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(12+1), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(22);
    r[16] = (hendblk(12+1));
    r[17+0] = r[0];  
    r[17+1] = obj_from_fixnum(0);
    r[17+2] = r[2];  
    r[17+3] = r[3];  
    r[17+4] = r[4];  
    r[17+5] = r[5];  
    r[17+6] = (r[14]);
    r[17+7] = r[6];  
    r[17+8] = r[7];  
    r[17+9] = r[8];  
    r[17+10] = r[9];  
    r[17+11] = (r[10]);
    r[17+12] = (r[11]);
    r[17+13] = (r[12]);
    r[17+14] = (r[16]);
    r[17+15] = r[1];  
    r[17+16] = (r[13]);
    r += 17; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_y_2Dloop;
  }

case 23: /* clo k y r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10];
    r[1+14] = p[11];
    r[1+15] = p[12];
    r[1+16] = p[13]; }
    r += 1; /* shift reg. wnd */
s_y_2Dloop: /* k y r* env r-x r-get r-r u-get r-U f-get c r-b op-k attr* x-loop x r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[16]))) {
    r[17+0] = (r[14]);
    pc = objptr_from_obj(r[17+0])[0];
    r[17+1] = r[0];  
    r[17+2] = obj_from_fixnum(fixnum_from_obj(r[15]) + (1));
    r[17+3] = r[2];  
    r[17+4] = r[3];  
    r += 17; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(13+1), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(23);
    r[17] = (hendblk(13+1));
    hreserve(hbsz(14+1), 18); /* 18 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[2];  
    *--hp = (r[17]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[15]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(24);
    r[17] = (hendblk(14+1));
    r[18+0] = r[5];  
    pc = objptr_from_obj(r[18+0])[0];
    r[18+1] = (r[17]);
    r[18+2] = r[4];  
    r[18+3] = (r[15]);
    r[18+4] = r[1];  
    r[18+5] = r[3];  
    r += 18; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 24: /* clo k q-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12];
    r[1+15] = p[13];
    r[1+16] = p[14]; }
    r += 1; /* shift reg. wnd */
    /* k q-v env r-get r-r u-get x r-U f-get c r-b y-loop r* op-k attr* y k */
    hreserve(hbsz(13+1), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = r[1];  
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(25);
    r[17] = (hendblk(13+1));
    r[18+0] = r[3];  
    pc = objptr_from_obj(r[18+0])[0];
    r[18+1] = (r[17]);
    r[18+2] = r[4];  
    r[18+3] = r[6];  
    r[18+4] = (r[15]);
    r[18+5] = r[2];  
    r += 18; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 25: /* clo k r-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12];
    r[1+15] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* k r-v env u-get x r-U f-get c r-b y-loop r* op-k attr* q-v y k */
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(26);
    r[16] = (hendblk(11+1));
    r[17+0] = r[3];  
    pc = objptr_from_obj(r[17+0])[0];
    r[17+1] = (r[16]);
    r[17+2] = r[5];  
    r[17+3] = r[4];  
    r[17+4] = r[7];  
    r[17+5] = r[2];  
    r += 17; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 26: /* clo k U-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k U-v env f-get c r-b y-loop r* op-k attr* r-v q-v y k */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(27);
    r[14] = (hendblk(9+1));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[5];  
    r[15+3] = r[4];  
    r[15+4] = (r[12]);
    r[15+5] = r[2];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 27: /* clo k b-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b-v env y-loop r* op-k attr* r-v q-v U-v y k */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[4];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[11]);
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[13+3] = (r[12]);
    r[13+4] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 28: /* clo k U-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k U-v env f-get r-b r-get r-r op-0 attr* r r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r[12+5] = r[4];  
    r[12+6] = r[5];  
    r[12+7] = r[6];  
    r[12+8] = r[7];  
    r[12+9] = r[8];  
    r[12+10] = r[1];  
    r[12+11] = r[9];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;

case 29: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_loop: /* k f r* env f-get r-b r-get r-r op-0 attr* U-v r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(29);
    r[12] = (hendblk(8+1));
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = (r[12]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(30);
    r[12] = (hendblk(9+1));
    r[13+0] = r[4];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[5];  
    r[13+3] = obj_from_fixnum(0);
    r[13+4] = r[1];  
    r[13+5] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 30: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k b env r-get r-r loop r* op-0 attr* U-v f k */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(31);
    r[12] = (hendblk(8+1));
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[4];  
    r[13+3] = obj_from_fixnum(0);
    r[13+4] = (r[10]);
    r[13+5] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 31: /* clo k z env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k z env loop r* op-0 attr* U-v b f k */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[4];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[10]);
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[9]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 32: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15]; }
    r += 1; /* shift reg. wnd */
    /* ek r r-get u-get r-U f-get r-b op-0 attr* r env r* new-reg s-madd-x r-r r k */
    hreserve(hbsz(5+1), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = obj_from_case(38);
    r[17] = (hendblk(5+1));
    r[18+0] = (r[17]);
    r[18+1] = obj_from_fixnum(0);
    r[18+2] = (r[11]);
    r[18+3] = (r[10]);
    r[18+4] = r[2];  
    r[18+5] = r[3];  
    r[18+6] = r[4];  
    r[18+7] = r[5];  
    r[18+8] = r[6];  
    r[18+9] = r[7];  
    r[18+10] = r[8];  
    r[18+11] = r[9];  
    r[18+12] = r[1];  
    r[18+13] = (r[15]);
    r += 18; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_x_2Dloop_v9257;

case 33: /* clo k x r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10]; }
    r += 1; /* shift reg. wnd */
s_x_2Dloop_v9257: /* k x r* env r-get u-get r-U f-get r-b op-0 attr* r r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[13]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    r[4] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(33);
    r[14] = (hendblk(10+1));
    r[15+0] = r[0];  
    r[15+1] = obj_from_fixnum(0);
    r[15+2] = r[2];  
    r[15+3] = r[3];  
    r[15+4] = r[4];  
    r[15+5] = (r[12]);
    r[15+6] = r[5];  
    r[15+7] = r[6];  
    r[15+8] = r[7];  
    r[15+9] = r[8];  
    r[15+10] = r[9];  
    r[15+11] = (r[10]);
    r[15+12] = (r[14]);
    r[15+13] = r[1];  
    r[15+14] = (r[11]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_y_2Dloop_v9258;
  }

case 34: /* clo k y r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10];
    r[1+14] = p[11]; }
    r += 1; /* shift reg. wnd */
s_y_2Dloop_v9258: /* k y r* env r-get r u-get r-U f-get r-b op-0 attr* x-loop x r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[14]))) {
    r[15+0] = (r[12]);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = r[0];  
    r[15+2] = obj_from_fixnum(fixnum_from_obj(r[13]) + (1));
    r[15+3] = r[2];  
    r[15+4] = r[3];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(34);
    r[15] = (hendblk(11+1));
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[2];  
    *--hp = (r[15]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[13]);
    *--hp = r[6];  
    *--hp = obj_from_case(35);
    r[15] = (hendblk(11+1));
    r[16+0] = r[4];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[5];  
    r[16+3] = (r[13]);
    r[16+4] = r[1];  
    r[16+5] = r[3];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 35: /* clo k q-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k q-v env u-get x r-U f-get r-b y-loop r* op-0 attr* y k */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(36);
    r[14] = (hendblk(9+1));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[5];  
    r[15+3] = r[4];  
    r[15+4] = obj_from_fixnum(0);
    r[15+5] = r[2];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 36: /* clo k U-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k U-v env f-get r-b y-loop r* op-0 attr* q-v y k */
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(37);
    r[12] = (hendblk(8+1));
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[4];  
    r[13+3] = obj_from_fixnum(0);
    r[13+4] = (r[10]);
    r[13+5] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 37: /* clo k b-v env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b-v env y-loop r* op-0 attr* q-v U-v y k */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[12]);
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[4];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[10]);
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[9]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 38: /* clo k r* env r-x */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k r* env r-x new-reg s-madd-x r-r r k */
    r[9+0] = r[8];  
    r[9+1] = obj_from_fixnum(1);
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = r[4];  
    r[9+6] = r[5];  
    r[9+7] = r[6];  
    r[9+8] = r[7];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v9212;

case 39: /* clo k c r* env r-x */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4]; }
    r += 1; /* shift reg. wnd */
s_loop_v9212: /* k c r* env r-x new-reg s-madd-x r-r r */
  if ((fixnum_from_obj(r[1]) == (fixnum_from_obj(r[8]) - (1)))) {
    hreserve(hbsz(1+1), 9); /* 9 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(40);
    r[9] = (hendblk(1+1));
    r[10+0] = r[6];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = r[4];  
    r[10+3] = r[7];  
    r[10+4] = r[1];  
    r[10+5] = r[2];  
    r[10+6] = r[3];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  } else {
    hreserve(hbsz(4+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(39);
    r[9] = (hendblk(4+1));
    hreserve(hbsz(7+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[6];  
    *--hp = obj_from_case(41);
    r[9] = (hendblk(7+1));
    r[10+0] = r[5];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  }

case 40: /* clo k r* env r-x */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r* env r-x k */
    r[5+0] = r[4];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[1];  
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 41: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek r s-madd-x env r* r-x loop c k */
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(42);
    r[9] = (hendblk(3+1));
    r[10+0] = r[2];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = r[5];  
    r[10+3] = r[1];  
    r[10+4] = r[7];  
    r[10+5] = r[4];  
    r[10+6] = r[3];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 42: /* clo k r* env r-x */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k r* env r-x loop c k */
    r[7+0] = r[4];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = obj_from_fixnum(fixnum_from_obj(r[5]) + (1));
    r[7+3] = r[1];  
    r[7+4] = r[2];  
    r[7+5] = r[3];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 43: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 44: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 45: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 46: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 47: /* clo k env base type i-a i-b */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k env base type i-a i-b new-reg */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("qcd->complex")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(1+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(48);
    r[8] = (hendblk(1+1));
    hreserve(hbsz(3+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(49);
    r[9] = (hendblk(3+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[0];  
    r[10+2] = r[1];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 48: /* clo k val */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k val env */
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = r[1];  
    r[3+3] = r[2];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 49: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2];
    r[1+3] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k new-reg key env */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(50);
    r[4] = (hendblk(3+1));
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 50: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r key env k */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(51);
    r[5] = (hendblk(2+1));
    r[6+0] = (cx_ce_2Dbind);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[3];  
    r[6+3] = r[2];  
    r[6+4] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 51: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r[4+3] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 52: /* clo k attr* addr* value c-n f-n part t r* env */
    assert(rc == 11);
    { obj* p = objptr_from_obj(r[0]);
    r[1+10] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value c-n f-n part t r* env q2c-rename */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[7];  
    *--hp = (r[10]);
    *--hp = r[5];  
    *--hp = obj_from_case(53);
    r[11] = (hendblk(10+1));
  if (((is_fixnum_obj(r[4])) || (is_flonum_obj(r[4])))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = r[4];  
    r[12+2] = r[5];  
    r[12+3] = (r[10]);
    r[12+4] = r[7];  
    r[12+5] = r[3];  
    r[12+6] = r[1];  
    r[12+7] = r[2];  
    r[12+8] = r[6];  
    r[12+9] = r[9];  
    r[12+10] = r[8];  
    r[12+11] = r[0];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v9043;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(66);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(67);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[9];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 53: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v9043: /* ek r f-n q2c-rename t value attr* addr* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(54);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[8];  
    r[13+8] = r[1];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v9055;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(64);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(65);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[9];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 54: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v9055: /* ek r q2c-rename t value attr* addr* part r env r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[2];  
    r[12+5] = r[3];  
    r[12+6] = r[4];  
    r[12+7] = r[5];  
    r[12+8] = r[6];  
    r[12+9] = r[1];  
    r[12+10] = r[7];  
    r[12+11] = r[8];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop;

case 55: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop: /* k c r* env q2c-rename t value attr* addr* r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(55);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(((r[10]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[9]) / (2)) : (0));
    r[13+2] = (r[2]);
    r[13+3] = (r[3]);
    r[13+4] = (r[4]);
    r[13+5] = (r[5]);
    r[13+6] = (r[6]);
    r[13+7] = (r[7]);
    r[13+8] = (r[8]);
    r[13+9] = (r[12]);
    r[13+10] = (r[1]);
    r[13+11] = (r[9]);
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop;
  }

case 56: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop: /* k f r* env q2c-rename t value attr* addr* c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[12]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[11]) / (2)) : (r[11])))) {
    r[13+0] = r[9];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(56);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = (r[13]);
    *--hp = obj_from_case(57);
    r[13] = (hendblk(8+1));
    r[14+0] = r[4];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[3];  
    r[14+3] = r[6];  
    r[14+4] = r[5];  
    r[14+5] = (r[10]);
    r[14+6] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 57: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x env f-loop k r* attr* addr* f r c */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(58);
    r[11] = (hendblk(10+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(62);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(63);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 58: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r f-loop env k r* attr* x addr* f r c */
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(59);
    r[12] = (hendblk(11+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("complex-double")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(60);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(61);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[3];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 59: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r f-loop env k r* attr* x addr* r f r c */
    { const fixnum_t v9547_f = fixnum_from_obj(r[10]);
    { const fixnum_t v9546_r = fixnum_from_obj(r[9]);
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = obj_from_fixnum((v9546_r) * ((v9547_f) + (fixnum_from_obj(r[11]) * fixnum_from_obj(r[12]))));
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { fixnum_t v9548_tmp;
    { /* length */
    int n; obj l = r[8];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v9548_tmp = (n); }
    { /* append */
    obj t, l, o, *p, *d; int c = (v9548_tmp);
    hreserve(hbsz(3)*c, 14); /* 14 live regs */
    l = r[8];   t = (r[13]); /* gc-safe */
    o = t; p = &o; 
    for (; l != mknull(); l = cdr(l)) {
    *--hp = t; d = hp; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); 
    *p = hendblk(3); p = d; }  
    r[13] = (o); } }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (((v9546_r) == fixnum_from_obj(r[1])) ? (mksymbol(internsym("complex-double"))) : (mksymbol(internsym("complex-float"))));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-store")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = r[5];  
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[14+0] = r[2];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = r[4];  
    r[14+2] = obj_from_fixnum((v9547_f) + (1));
    r[14+3] = (r[13]);
    r[14+4] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump; }  } 

case 60: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 61: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232898);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 62: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 63: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232063);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 64: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 65: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232052);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 66: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 67: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 68: /* clo k attr* output addr* c-n f-n part t r* env */
    assert(rc == 11);
    { obj* p = objptr_from_obj(r[0]);
    r[1+10] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* c-n f-n part t r* env q2c-rename */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = (r[10]);
    *--hp = r[5];  
    *--hp = obj_from_case(69);
    r[11] = (hendblk(10+1));
  if (((is_fixnum_obj(r[4])) || (is_flonum_obj(r[4])))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = r[4];  
    r[12+2] = r[5];  
    r[12+3] = (r[10]);
    r[12+4] = r[7];  
    r[12+5] = r[2];  
    r[12+6] = r[1];  
    r[12+7] = r[3];  
    r[12+8] = r[6];  
    r[12+9] = r[9];  
    r[12+10] = r[8];  
    r[12+11] = r[0];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8931;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(82);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(83);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[9];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 69: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8931: /* ek r f-n q2c-rename t output attr* addr* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(70);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[8];  
    r[13+8] = r[1];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8943;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(80);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(81);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[9];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 70: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8943: /* ek r q2c-rename t output attr* addr* part r env r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[2];  
    r[12+5] = r[3];  
    r[12+6] = r[4];  
    r[12+7] = r[5];  
    r[12+8] = r[6];  
    r[12+9] = r[1];  
    r[12+10] = r[7];  
    r[12+11] = r[8];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8944;

case 71: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8944: /* k c r* env q2c-rename t output attr* addr* r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(71);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(((r[10]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[9]) / (2)) : (0));
    r[13+2] = (r[2]);
    r[13+3] = (r[3]);
    r[13+4] = (r[4]);
    r[13+5] = (r[5]);
    r[13+6] = (r[6]);
    r[13+7] = (r[7]);
    r[13+8] = (r[8]);
    r[13+9] = (r[12]);
    r[13+10] = (r[1]);
    r[13+11] = (r[9]);
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8945;
  }

case 72: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8945: /* k f r* env q2c-rename t output attr* addr* c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[12]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[11]) / (2)) : (r[11])))) {
    r[13+0] = r[9];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(72);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = (r[13]);
    *--hp = obj_from_case(73);
    r[13] = (hendblk(8+1));
    r[14+0] = r[4];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[3];  
    r[14+3] = r[6];  
    r[14+4] = r[5];  
    r[14+5] = (r[10]);
    r[14+6] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 73: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x env f-loop k r* attr* addr* f r c */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(74);
    r[11] = (hendblk(10+1));
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(78);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(79);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    /* r[2] */    
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 74: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r f-loop env k r* attr* addr* f r c x */
    hreserve(hbsz(11+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(75);
    r[12] = (hendblk(11+1));
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("complex-double")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(76);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(77);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[3];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 75: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek r f-loop env k r* attr* addr* r f r c x */
    { const fixnum_t v9544_f = fixnum_from_obj(r[9]);
    { const fixnum_t v9543_r = fixnum_from_obj(r[8]);
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = obj_from_fixnum((v9543_r) * ((v9544_f) + (fixnum_from_obj(r[10]) * fixnum_from_obj(r[11]))));
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { fixnum_t v9545_tmp;
    { /* length */
    int n; obj l = r[7];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v9545_tmp = (n); }
    { /* append */
    obj t, l, o, *p, *d; int c = (v9545_tmp);
    hreserve(hbsz(3)*c, 15); /* 15 live regs */
    l = r[7];   t = (r[14]); /* gc-safe */
    o = t; p = &o; 
    for (; l != mknull(); l = cdr(l)) {
    *--hp = t; d = hp; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); 
    *p = hendblk(3); p = d; }  
    r[14] = (o); } }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (((v9543_r) == fixnum_from_obj(r[1])) ? (mksymbol(internsym("complex-double"))) : (mksymbol(internsym("complex-float"))));
    *--hp = (r[6]);
    *--hp = (mksymbol(internsym("qa0-load")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = r[5];  
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[14+0] = r[2];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = r[4];  
    r[14+2] = obj_from_fixnum((v9544_f) + (1));
    r[14+3] = (r[13]);
    r[14+4] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump; }  } 

case 76: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 77: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232898);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 78: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 79: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232063);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 80: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 81: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232052);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 82: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 83: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 84: /* clo k attr* output* input* r* env part f-dim f-kind */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env part f-dim f-kind q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = (r[10]);
    *--hp = r[7];  
    *--hp = r[9];  
    *--hp = obj_from_case(85);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[2];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__232394);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 85: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-dim q2c-rename f-kind output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(86);
    r[13] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__232393);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 86: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-dim q2c-rename f-kind output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(87);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    r[10] = (r[10]);
    r[11] = (r[11]);
    goto s_l_v8845;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(94);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(95);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[9];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 87: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8845: /* ek r f-dim q2c-rename f-kind output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(88);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[8];  
    r[13+8] = r[1];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8857;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(92);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(93);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[9];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 88: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8857: /* ek r q2c-rename f-kind output* attr* input* part r env r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[2];  
    r[12+5] = r[3];  
    r[12+6] = r[4];  
    r[12+7] = r[5];  
    r[12+8] = r[6];  
    r[12+9] = r[1];  
    r[12+10] = r[7];  
    r[12+11] = r[8];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8858;

case 89: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8858: /* k c r* env q2c-rename f-kind output* attr* input* r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(89);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(((r[10]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[9]) / (2)) : (0));
    r[13+2] = (r[2]);
    r[13+3] = (r[3]);
    r[13+4] = (r[4]);
    r[13+5] = (r[5]);
    r[13+6] = (r[6]);
    r[13+7] = (r[7]);
    r[13+8] = (r[8]);
    r[13+9] = (r[12]);
    r[13+10] = (r[1]);
    r[13+11] = (r[9]);
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8859;
  }

case 90: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8859: /* k f r* env q2c-rename f-kind output* attr* input* c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[12]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[11]) / (2)) : (r[11])))) {
    r[13+0] = r[9];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(90);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(7+1), 14); /* 14 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = obj_from_case(91);
    r[13] = (hendblk(7+1));
    r[14] = (cdr((r[8])));
    r[14] = (car((r[14])));
    r[15+0] = r[4];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[13]);
    r[15+2] = r[3];  
    r[15+3] = (r[14]);
    r[15+4] = r[5];  
    r[15+5] = (r[10]);
    r[15+6] = r[1];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 91: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k a env f-loop f k r* output* attr* input* */
    r[10] = (car((r[9])));
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("complex-norm-add")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[5];  
    r[11+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[11+3] = (r[10]);
    r[11+4] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 92: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 93: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232194);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 94: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 95: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 96: /* clo k attr* output* input* r* env f-dim f-kind */
    assert(rc == 9);
    { obj* p = objptr_from_obj(r[0]);
    r[1+8] = p[1];
    r[1+9] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env f-dim f-kind q2c-check-list q2c-rename */
    hreserve(hbsz(10+1), 10); /* 10 live regs */
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = r[9];  
    *--hp = r[6];  
    *--hp = r[8];  
    *--hp = obj_from_case(97);
    r[10] = (hendblk(10+1));
    r[11+0] = r[8];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = (r[10]);
    r[11+2] = r[2];  
    r[11+3] = obj_from_fixnum(1);
    r[11+4] = (cx__232234);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 97: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-dim q2c-rename f-kind output* attr* input* env r* k */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(98);
    r[12] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(3);
    r[4] = (cx__232233);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 98: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-dim q2c-rename f-kind output* attr* input* env r* k */
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(99);
    r[11] = (hendblk(8+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[0] = obj_from_ktrap();
    r[1] = r[2];  
    r[2] = r[3];  
    r[3] = r[4];  
    r[4] = r[5];  
    r[5] = r[6];  
    r[6] = r[7];  
    r[7] = r[8];  
    r[8] = r[9];  
    r[9] = (r[10]);
    goto s_l_v8749;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(107);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(108);
    r[14] = (hendblk(0+1));
    r[15+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[11]);
    r[15+2] = r[8];  
    r[15+3] = (r[12]);
    r[15+4] = (r[13]);
    r[15+5] = (r[14]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 99: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
s_l_v8749: /* ek r q2c-rename f-kind output* attr* input* env r* k */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(100);
    r[10] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = (mksymbol(internsym("*colors*")));
    r[11+2] = (r[2]);
    r[11+3] = (r[3]);
    r[11+4] = (r[4]);
    r[11+5] = (r[5]);
    r[11+6] = (r[6]);
    r[11+7] = (r[1]);
    r[11+8] = (r[7]);
    r[11+9] = (r[8]);
    r[11+10] = (r[9]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8761;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(105);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(106);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[7];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 100: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v8761: /* ek r q2c-rename f-kind output* attr* input* r env r* k */
    r[11+0] = (r[10]);
    r[11+1] = obj_from_fixnum(0);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[2];  
    r[11+5] = r[3];  
    r[11+6] = r[4];  
    r[11+7] = r[5];  
    r[11+8] = r[6];  
    r[11+9] = r[7];  
    r[11+10] = r[1];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8762;

case 101: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8762: /* k c r* env q2c-rename f-kind output* attr* input* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[10]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(101);
    r[11] = (hendblk(7+1));
    r[12+0] = r[0];  
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = r[2];  
    r[12+3] = r[3];  
    r[12+4] = r[4];  
    r[12+5] = r[5];  
    r[12+6] = r[6];  
    r[12+7] = r[7];  
    r[12+8] = r[8];  
    r[12+9] = (r[11]);
    r[12+10] = r[1];  
    r[12+11] = r[9];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8763;
  }

case 102: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8763: /* k f r* env q2c-rename f-kind output* attr* input* c-loop c r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(102);
    r[12] = (hendblk(8+1));
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = obj_from_case(103);
    r[12] = (hendblk(10+1));
    r[13] = (cdr((r[8])));
    r[13] = (car((r[13])));
    r[14+0] = r[4];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[12]);
    r[14+2] = r[3];  
    r[14+3] = (r[13]);
    r[14+4] = r[5];  
    r[14+5] = (r[10]);
    r[14+6] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 103: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k a env q2c-rename c f-kind f-loop f k r* output* attr* input* */
    hreserve(hbsz(8+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(104);
    r[13] = (hendblk(8+1));
    r[14] = (cdr((r[12])));
    r[14] = (cdr((r[14])));
    r[14] = (car((r[14])));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[13]);
    r[15+2] = r[2];  
    r[15+3] = (r[14]);
    r[15+4] = r[5];  
    r[15+5] = r[4];  
    r[15+6] = r[7];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 104: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k b env f-loop f k r* output* attr* a input* */
    r[11] = (car((r[10])));
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("complex-cmadd")));
    *--hp = (r[8]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[5];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 105: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 106: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 107: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 108: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232194);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 109: /* clo k c-op attr* output* input* f-n t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c-op attr* output* input* f-n t r* env q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[9];  
    *--hp = obj_from_case(110);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[3];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__232028);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 110: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-n input* q2c-rename t output* c-op attr* env r* k */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(111);
    r[13] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = r[4];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__232027);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 111: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n input* q2c-rename t output* c-op attr* env r* k */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(112);
    r[12] = (hendblk(9+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[0] = obj_from_ktrap();
    r[1] = r[2];  
    r[2] = r[3];  
    r[3] = r[4];  
    r[4] = r[5];  
    r[5] = r[6];  
    r[6] = r[7];  
    r[7] = r[8];  
    r[8] = r[9];  
    r[9] = (r[10]);
    r[10] = (r[11]);
    goto s_l_v8643;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(121);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(122);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[9];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 112: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v8643: /* ek r input* q2c-rename t output* c-op attr* env r* k */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(113);
    r[11] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = (mksymbol(internsym("*colors*")));
    r[12+2] = (r[2]);
    r[12+3] = (r[3]);
    r[12+4] = (r[4]);
    r[12+5] = (r[5]);
    r[12+6] = (r[6]);
    r[12+7] = (r[7]);
    r[12+8] = (r[1]);
    r[12+9] = (r[8]);
    r[12+10] = (r[9]);
    r[12+11] = (r[10]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8655;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(119);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(120);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[8];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 113: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8655: /* ek r input* q2c-rename t output* c-op attr* r env r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[2];  
    r[12+5] = r[3];  
    r[12+6] = r[4];  
    r[12+7] = r[5];  
    r[12+8] = r[6];  
    r[12+9] = r[7];  
    r[12+10] = r[8];  
    r[12+11] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8656;

case 114: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8656: /* k c r* env input* q2c-rename t output* c-op attr* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(114);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r[13+5] = r[5];  
    r[13+6] = r[6];  
    r[13+7] = r[7];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[12]);
    r[13+11] = r[1];  
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8657;
  }

case 115: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8657: /* k f r* env input* q2c-rename t output* c-op attr* c-loop c r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[12]))) {
    r[13+0] = (r[10]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(115);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(11+1), 14); /* 14 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(116);
    r[13] = (hendblk(11+1));
    r[14+0] = r[5];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[3];  
    r[14+3] = (car((r[4])));
    r[14+4] = r[6];  
    r[14+5] = (r[11]);
    r[14+6] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 116: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k a env input* q2c-rename c t output* f-loop f k r* c-op attr* */
    hreserve(hbsz(11+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(117);
    r[14] = (hendblk(11+1));
    r[15] = (cdr((r[3])));
    r[15] = (car((r[15])));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    r[3] = (r[15]);
    r[4] = r[6];  
    /* r[5] */    
    r[6] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 117: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k b env q2c-rename c t output* f-loop f k r* c-op attr* a */
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(118);
    r[14] = (hendblk(8+1));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[2];  
    r[15+3] = (car((r[6])));
    r[15+4] = r[5];  
    r[15+5] = r[4];  
    r[15+6] = r[8];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 118: /* clo k d env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k d env f-loop f k r* c-op attr* b a */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[5];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 119: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 120: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 121: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 122: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 123: /* clo k attr* output* input* f-n part t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* f-n part t r* env q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[9];  
    *--hp = obj_from_case(124);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[2];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__231940);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 124: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list input* f-n q2c-rename t output* attr* part env r* k */
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(125);
    r[13] = (hendblk(9+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = r[3];  
    r[3] = obj_from_fixnum(0);
    r[4] = (cx__231939);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 125: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n q2c-rename t output* attr* part env r* k */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(126);
    r[11] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    r[10] = (r[10]);
    goto s_l_v8553;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(133);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(134);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[8];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 126: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v8553: /* ek r f-n q2c-rename t output* attr* part env r* k */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(127);
    r[11] = (hendblk(9+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = r[2];  
    r[12+2] = r[3];  
    r[12+3] = r[4];  
    r[12+4] = r[5];  
    r[12+5] = r[6];  
    r[12+6] = r[7];  
    r[12+7] = r[1];  
    r[12+8] = r[8];  
    r[12+9] = r[9];  
    r[12+10] = (r[10]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8565;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(131);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(132);
    r[14] = (hendblk(0+1));
    r[15+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[11]);
    r[15+2] = r[8];  
    r[15+3] = (r[12]);
    r[15+4] = (r[13]);
    r[15+5] = (r[14]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 127: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v8565: /* ek r q2c-rename t output* attr* part r env r* k */
    r[11+0] = (r[10]);
    r[11+1] = obj_from_fixnum(0);
    r[11+2] = r[9];  
    r[11+3] = r[8];  
    r[11+4] = r[2];  
    r[11+5] = r[3];  
    r[11+6] = r[4];  
    r[11+7] = r[5];  
    r[11+8] = r[1];  
    r[11+9] = r[6];  
    r[11+10] = r[7];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8566;

case 128: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8566: /* k c r* env q2c-rename t output* attr* r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[10]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(128);
    r[11] = (hendblk(7+1));
    r[12+0] = r[0];  
    r[12+1] = obj_from_fixnum(((r[9]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[8]) / (2)) : (0));
    r[12+2] = (r[2]);
    r[12+3] = (r[3]);
    r[12+4] = (r[4]);
    r[12+5] = (r[5]);
    r[12+6] = (r[6]);
    r[12+7] = (r[7]);
    r[12+8] = (r[11]);
    r[12+9] = (r[1]);
    r[12+10] = (r[8]);
    r[12+11] = (r[9]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8567;
  }

case 129: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8567: /* k f r* env q2c-rename t output* attr* c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[11]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[10]) / (2)) : (r[10])))) {
    r[12+0] = r[8];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[9]) + (1));
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(129);
    r[12] = (hendblk(8+1));
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = obj_from_case(130);
    r[12] = (hendblk(5+1));
    r[13+0] = r[4];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[3];  
    r[13+3] = (car((r[6])));
    r[13+4] = r[5];  
    r[13+5] = r[9];  
    r[13+6] = r[1];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 130: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k r env f-loop f k r* attr* */
    { /* vector */
    hreserve(hbsz(2+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("complex-zero")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[6];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[5];  
    r[9+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[9+3] = r[8];  
    r[9+4] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 131: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 132: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 133: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 134: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 135: /* clo k attr* output* input* f-n part t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* f-n part t r* env q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_case(136);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[2];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__231861);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 136: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-n q2c-rename t output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(137);
    r[13] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__231860);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 137: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n q2c-rename t output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(138);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    r[10] = (r[10]);
    r[11] = (r[11]);
    goto s_l_v8455;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(146);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(147);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[9];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 138: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8455: /* ek r f-n q2c-rename t output* attr* input* part env r* k */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(139);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[8];  
    r[13+8] = r[1];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8467;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(144);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(145);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[9];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 139: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8467: /* ek r q2c-rename t output* attr* input* part r env r* k */
    r[12+0] = (r[11]);
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = (r[10]);
    r[12+3] = r[9];  
    r[12+4] = r[2];  
    r[12+5] = r[3];  
    r[12+6] = r[4];  
    r[12+7] = r[5];  
    r[12+8] = r[6];  
    r[12+9] = r[1];  
    r[12+10] = r[7];  
    r[12+11] = r[8];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8468;

case 140: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8468: /* k c r* env q2c-rename t output* attr* input* r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(140);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(((r[10]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[9]) / (2)) : (0));
    r[13+2] = (r[2]);
    r[13+3] = (r[3]);
    r[13+4] = (r[4]);
    r[13+5] = (r[5]);
    r[13+6] = (r[6]);
    r[13+7] = (r[7]);
    r[13+8] = (r[8]);
    r[13+9] = (r[12]);
    r[13+10] = (r[1]);
    r[13+11] = (r[9]);
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8469;
  }

case 141: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8469: /* k f r* env q2c-rename t output* attr* input* c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[12]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[11]) / (2)) : (r[11])))) {
    r[13+0] = r[9];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[10]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[13] = (car((r[8])));
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(141);
    r[14] = (hendblk(9+1));
    hreserve(hbsz(10+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[14]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = obj_from_case(142);
    r[14] = (hendblk(10+1));
    r[15] = (cdr((r[8])));
    r[15] = (car((r[15])));
    r[16+0] = r[4];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[14]);
    r[16+2] = r[3];  
    r[16+3] = (r[15]);
    r[16+4] = r[5];  
    r[16+5] = (r[10]);
    r[16+6] = r[1];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 142: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k b env q2c-rename c t output* f-loop f k r* attr* a */
    hreserve(hbsz(7+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(143);
    r[13] = (hendblk(7+1));
    r[14+0] = r[3];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[2];  
    r[14+3] = (car((r[6])));
    r[14+4] = r[5];  
    r[14+5] = r[4];  
    r[14+6] = r[8];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 143: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k r env f-loop f k r* attr* a b */
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("complex-rmul")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[5];  
    r[11+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[11+3] = (r[10]);
    r[11+4] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 144: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 145: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 146: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 147: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 148: /* clo k attr* output* input* f-n part t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* f-n part t r* env q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_case(149);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[2];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__231545);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 149: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(150);
    r[13] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = (r[12]);
    r[3] = obj_from_fixnum(3);
    r[4] = (cx__231544);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 150: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(151);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    r[10] = (r[10]);
    r[11] = (r[11]);
    goto s_l_v8349;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(160);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(161);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[8];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 151: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8349: /* ek r f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(152);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[1];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8361;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(158);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(159);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[8];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 152: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8361: /* ek r q2c-rename t output* attr* part r env r* k input* */
    r[12] = (car((r[11])));
    r[13] = (cdr((r[11])));
    r[13] = (car((r[13])));
    r[14] = (cdr((r[11])));
    r[14] = (cdr((r[14])));
    r[14] = (car((r[14])));
    r[15+0] = (r[10]);
    r[15+1] = obj_from_fixnum(0);
    r[15+2] = r[9];  
    r[15+3] = r[8];  
    r[15+4] = (r[14]);
    r[15+5] = (r[12]);
    r[15+6] = r[2];  
    r[15+7] = r[3];  
    r[15+8] = r[4];  
    r[15+9] = r[5];  
    r[15+10] = (r[13]);
    r[15+11] = r[1];  
    r[15+12] = r[6];  
    r[15+13] = r[7];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8362;

case 153: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8362: /* k c r* env s a q2c-rename t output* attr* alpha r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[13]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(153);
    r[14] = (hendblk(10+1));
    r[15+0] = r[0];  
    r[15+1] = obj_from_fixnum(((r[12]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[11]) / (2)) : (0));
    r[15+2] = (r[2]);
    r[15+3] = (r[3]);
    r[15+4] = (r[4]);
    r[15+5] = (r[5]);
    r[15+6] = (r[6]);
    r[15+7] = (r[7]);
    r[15+8] = (r[8]);
    r[15+9] = (r[9]);
    r[15+10] = (r[10]);
    r[15+11] = (r[14]);
    r[15+12] = (r[1]);
    r[15+13] = (r[11]);
    r[15+14] = (r[12]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8363;
  }

case 154: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10];
    r[1+14] = p[11]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8363: /* k f r* env s a q2c-rename t output* attr* alpha c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[14]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[13]) / (2)) : (r[13])))) {
    r[15+0] = (r[11]);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = r[0];  
    r[15+2] = obj_from_fixnum(fixnum_from_obj(r[12]) + (1));
    r[15+3] = r[2];  
    r[15+4] = r[3];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(154);
    r[15] = (hendblk(11+1));
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[15]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(155);
    r[15] = (hendblk(11+1));
    r[16+0] = r[6];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[3];  
    r[16+3] = r[4];  
    r[16+4] = r[7];  
    r[16+5] = (r[12]);
    r[16+6] = r[1];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 155: /* clo k s env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k s env a q2c-rename c t output* f-loop f k r* attr* alpha */
    hreserve(hbsz(11+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(156);
    r[14] = (hendblk(11+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    /* r[3] */    
    r[4] = r[6];  
    /* r[5] */    
    r[6] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 156: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k a env q2c-rename c t output* f-loop f k r* attr* alpha s */
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(157);
    r[14] = (hendblk(8+1));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[2];  
    r[15+3] = (car((r[6])));
    r[15+4] = r[5];  
    r[15+5] = r[4];  
    r[15+6] = r[8];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 157: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x env f-loop f k r* attr* alpha s a */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("complex-rmadd")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[5];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 158: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 159: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 160: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 161: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 162: /* clo k attr* output* input* f-n part t r* env */
    assert(rc == 10);
    { obj* p = objptr_from_obj(r[0]);
    r[1+9] = p[1];
    r[1+10] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* f-n part t r* env q2c-check-list q2c-rename */
    hreserve(hbsz(11+1), 11); /* 11 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = (r[10]);
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_case(163);
    r[11] = (hendblk(11+1));
    r[12+0] = r[9];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[2];  
    r[12+3] = obj_from_fixnum(1);
    r[12+4] = (cx__231438);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 163: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(164);
    r[13] = (hendblk(10+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = (r[12]);
    r[3] = obj_from_fixnum(3);
    r[4] = (cx__231437);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 164: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek  f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(165);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    r[10] = (r[10]);
    r[11] = (r[11]);
    goto s_l_v8243;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(174);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(175);
    r[15] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = r[8];  
    r[3] = (r[13]);
    r[4] = (r[14]);
    r[5] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 165: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8243: /* ek r f-n q2c-rename t output* attr* part env r* k input* */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(166);
    r[12] = (hendblk(10+1));
  if (((is_fixnum_obj(r[2])) || (is_flonum_obj(r[2])))) {
    r[13+0] = obj_from_ktrap();
    r[13+1] = r[2];  
    r[13+2] = r[3];  
    r[13+3] = r[4];  
    r[13+4] = r[5];  
    r[13+5] = r[6];  
    r[13+6] = r[7];  
    r[13+7] = r[1];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[10]);
    r[13+11] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v8255;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(172);
    r[14] = (hendblk(0+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(173);
    r[15] = (hendblk(0+1));
    r[16+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[12]);
    r[16+2] = r[8];  
    r[16+3] = (r[13]);
    r[16+4] = (r[14]);
    r[16+5] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 166: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v8255: /* ek r q2c-rename t output* attr* part r env r* k input* */
    r[12] = (car((r[11])));
    r[13] = (cdr((r[11])));
    r[13] = (car((r[13])));
    r[14] = (cdr((r[11])));
    r[14] = (cdr((r[14])));
    r[14] = (car((r[14])));
    r[15+0] = (r[10]);
    r[15+1] = obj_from_fixnum(0);
    r[15+2] = r[9];  
    r[15+3] = r[8];  
    r[15+4] = (r[14]);
    r[15+5] = (r[12]);
    r[15+6] = r[2];  
    r[15+7] = r[3];  
    r[15+8] = r[4];  
    r[15+9] = r[5];  
    r[15+10] = (r[13]);
    r[15+11] = r[1];  
    r[15+12] = r[6];  
    r[15+13] = r[7];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v8256;

case 167: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v8256: /* k c r* env s a q2c-rename t output* attr* alpha r part r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[13]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(167);
    r[14] = (hendblk(10+1));
    r[15+0] = r[0];  
    r[15+1] = obj_from_fixnum(((r[12]) == (mksymbol(internsym("high")))) ? (fixnum_from_obj(r[11]) / (2)) : (0));
    r[15+2] = (r[2]);
    r[15+3] = (r[3]);
    r[15+4] = (r[4]);
    r[15+5] = (r[5]);
    r[15+6] = (r[6]);
    r[15+7] = (r[7]);
    r[15+8] = (r[8]);
    r[15+9] = (r[9]);
    r[15+10] = (r[10]);
    r[15+11] = (r[14]);
    r[15+12] = (r[1]);
    r[15+13] = (r[11]);
    r[15+14] = (r[12]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v8257;
  }

case 168: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9];
    r[1+13] = p[10];
    r[1+14] = p[11]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v8257: /* k f r* env s a q2c-rename t output* attr* alpha c-loop c r part */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(((r[14]) == (mksymbol(internsym("low")))) ? obj_from_fixnum(fixnum_from_obj(r[13]) / (2)) : (r[13])))) {
    r[15+0] = (r[11]);
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = r[0];  
    r[15+2] = obj_from_fixnum(fixnum_from_obj(r[12]) + (1));
    r[15+3] = r[2];  
    r[15+4] = r[3];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(168);
    r[15] = (hendblk(11+1));
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[15]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(169);
    r[15] = (hendblk(11+1));
    r[16+0] = r[6];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[3];  
    r[16+3] = r[4];  
    r[16+4] = r[7];  
    r[16+5] = (r[12]);
    r[16+6] = r[1];  
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 169: /* clo k s env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k s env a q2c-rename c t output* f-loop f k r* attr* alpha */
    hreserve(hbsz(11+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(170);
    r[14] = (hendblk(11+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    /* r[2] */    
    /* r[3] */    
    r[4] = r[6];  
    /* r[5] */    
    r[6] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 170: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k a env q2c-rename c t output* f-loop f k r* attr* alpha s */
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(171);
    r[14] = (hendblk(8+1));
    r[15+0] = r[3];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[2];  
    r[15+3] = (car((r[6])));
    r[15+4] = r[5];  
    r[15+5] = r[4];  
    r[15+6] = r[8];  
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 171: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k x env f-loop f k r* attr* alpha s a */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("complex-rmsub")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[6];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[5];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[12+3] = (r[11]);
    r[12+4] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 172: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 173: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 174: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 175: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 176: /* clo k r i j env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r i j env q2c-rename */
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r[6+4] = (mksymbol(internsym("fermion")));
    r[6+5] = (r[2]);
    r[6+6] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 177: /* clo k r i j env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r i j env q2c-rename */
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r[6+4] = (mksymbol(internsym("projected-fermion")));
    r[6+5] = (r[2]);
    r[6+6] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 178: /* clo k r i j env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r i j env q2c-rename */
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r[6+4] = (mksymbol(internsym("staggered-fermion")));
    r[6+5] = (r[2]);
    r[6+6] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 179: /* clo k r i j env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r i j env q2c-rename */
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r[6+4] = (mksymbol(internsym("gauge")));
    r[6+5] = (r[2]);
    r[6+6] = (r[3]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 180: /* clo k r i j env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r i j env q2c-rename */
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r[6+4] = (mksymbol(internsym("gauge")));
    r[6+5] = (r[3]);
    r[6+6] = (r[2]);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 181: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("projected-fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 182: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = obj_from_fixnum(1);
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("staggered-fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 183: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("high")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 184: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("low")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 185: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 186: /* clo k attr* addr* value r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* addr* value r* env q2c-store-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*colors*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("gauge")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 187: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("high")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 188: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("low")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 189: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 190: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = obj_from_fixnum(1);
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("staggered-fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 191: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("projected-fermion")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 192: /* clo k attr* output addr* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output addr* r* env q2c-load-xy */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*colors*")));
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("gauge")));
    r[7+9] = (r[4]);
    r[7+10] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 11);
    goto jump;

case 193: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-offset */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 194: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = obj_from_case(195);
    r[6] = (hendblk(5+1));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("COMPLEX")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = (mksymbol(internsym("size-of")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    hreserve(hbsz(0+1), 8); /* 8 live regs */
    *--hp = obj_from_case(196);
    r[8] = (hendblk(0+1));
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(197);
    r[9] = (hendblk(0+1));
    r[10+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[6];  
    r[10+2] = r[5];  
    r[10+3] = r[7];  
    r[10+4] = r[8];  
    r[10+5] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 195: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r k env r* output* input* */
    r[7] = (car((r[6])));
    r[8] = (car((r[5])));
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("c-expr-number")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("int-mul")));
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* list* */
    obj p;
    hreserve(hbsz(3)*2, 10); /* 10 live regs */
    p = r[4];   /* gc-safe */
    *--hp = p; *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); p = hendblk(3);
    r[9] = (p); }
    r[10+0] = r[2];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[3];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 196: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 197: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__232063);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 198: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-offset */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 199: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-offset */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("*colors*")));
    r[7+7] = (mksymbol(internsym("gauge")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 200: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(201);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232134);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 201: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(202);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__232133);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 202: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-dot-fini")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 203: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xdot-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = obj_from_fixnum(1);
    r[7+8] = (mksymbol(internsym("staggered-fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;

case 204: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(205);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232264);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 205: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(206);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(0);
    r[4] = (cx__232263);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 206: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-dot-init")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 207: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(208);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232150);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 208: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(209);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__232149);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 209: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-dot-fini")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 210: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xdot-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = (mksymbol(internsym("*fermion-dim*")));
    r[7+8] = (mksymbol(internsym("fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;

case 211: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(212);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232280);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 212: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(213);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(0);
    r[4] = (cx__232279);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 213: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-dot-init")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 214: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(215);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232297);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 215: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(216);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__232296);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 216: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-norm-fini")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 217: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xnorm-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = obj_from_fixnum(1);
    r[7+9] = (mksymbol(internsym("staggered-fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 218: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(219);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232435);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 219: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(220);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(0);
    r[4] = (cx__232434);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 220: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-norm-init")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 221: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(222);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232313);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 222: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(223);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__232312);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 223: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-norm-fini")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 224: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xnorm-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = (mksymbol(internsym("high")));
    r[7+8] = (mksymbol(internsym("*fermion-dim*")));
    r[7+9] = (mksymbol(internsym("fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 225: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xnorm-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = (mksymbol(internsym("low")));
    r[7+8] = (mksymbol(internsym("*fermion-dim*")));
    r[7+9] = (mksymbol(internsym("fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 226: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-xnorm-add-do */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = r[4];  
    r[7+6] = r[5];  
    r[7+7] = (mksymbol(internsym("all")));
    r[7+8] = (mksymbol(internsym("*fermion-dim*")));
    r[7+9] = (mksymbol(internsym("fermion")));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 227: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list */
    hreserve(hbsz(7+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = obj_from_case(228);
    r[7] = (hendblk(7+1));
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r[8+3] = obj_from_fixnum(1);
    r[8+4] = (cx__232451);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 228: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list k env r* input* output* attr* */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(229);
    r[9] = (hendblk(6+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[9];  
    r[2] = r[6];  
    r[3] = obj_from_fixnum(0);
    r[4] = (cx__232450);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 229: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  k env r* input* output* attr* */
    { /* vector */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("complex-norm-init")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[8] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[4];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 230: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(3+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(231);
    r[8] = (hendblk(3+1));
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[6];  
    *--hp = obj_from_case(235);
    r[8] = (hendblk(6+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__231657);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 231: /* clo k c f s alpha a r* env */
    assert(rc == 9);
    { obj* p = objptr_from_obj(r[0]);
    r[1+8] = p[1];
    r[1+9] = p[2];
    r[1+10] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k c f s alpha a r* env q2c-rename output* attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[4];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = obj_from_case(232);
    r[11] = (hendblk(9+1));
    r[12+0] = r[8];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[7];  
    r[12+3] = r[3];  
    r[12+4] = (mksymbol(internsym("fermion")));
    r[12+5] = (r[1]);
    r[12+6] = (r[2]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 232: /* clo k s env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k s env a q2c-rename f c output* k r* attr* alpha */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(233);
    r[12] = (hendblk(9+1));
    r[13+0] = r[4];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = (mksymbol(internsym("fermion")));
    r[13+5] = (r[6]);
    r[13+6] = (r[5]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 233: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k a env q2c-rename f c output* k r* attr* s alpha */
    hreserve(hbsz(6+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(234);
    r[12] = (hendblk(6+1));
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[2];  
    r[13+3] = (car((r[6])));
    r[13+4] = (mksymbol(internsym("fermion")));
    r[13+5] = (r[5]);
    r[13+6] = (r[4]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 234: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k x env k r* attr* s alpha a */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("complex-rmsub")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 235: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list complex-msub env r* k input* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(236);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[7];  
    r[3] = obj_from_fixnum(5);
    r[4] = (cx__231656);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 236: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek  complex-msub env r* k input* */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(237);
    r[7] = (hendblk(5+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    goto s_l_v7490;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(244);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(245);
    r[10] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    r[3] = r[8];  
    r[4] = r[9];  
    r[5] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 237: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
s_l_v7490: /* ek r complex-msub env r* k input* */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(238);
    r[7] = (hendblk(6+1));
  if (((is_fixnum_obj(mksymbol(internsym("*fermion-dim*")))) || (is_flonum_obj(mksymbol(internsym("*fermion-dim*")))))) {
    r[8+0] = obj_from_ktrap();
    r[8+1] = (mksymbol(internsym("*fermion-dim*")));
    r[8+2] = (r[2]);
    r[8+3] = (r[1]);
    r[8+4] = (r[3]);
    r[8+5] = (r[4]);
    r[8+6] = (r[5]);
    r[8+7] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v7502;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*fermion-dim*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(242);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(243);
    r[10] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    r[3] = r[8];  
    r[4] = r[9];  
    r[5] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 238: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
s_l_v7502: /* ek r complex-msub r env r* k input* */
    r[8] = (car((r[7])));
    r[9] = (cdr((r[7])));
    r[9] = (car((r[9])));
    r[10] = (cdr((r[7])));
    r[10] = (cdr((r[10])));
    r[10] = (car((r[10])));
    r[11] = (cdr((r[7])));
    r[11] = (cdr((r[11])));
    r[11] = (cdr((r[11])));
    r[11] = (car((r[11])));
    r[12] = (cdr((r[7])));
    r[12] = (cdr((r[12])));
    r[12] = (cdr((r[12])));
    r[12] = (cdr((r[12])));
    r[12] = (car((r[12])));
    r[13+0] = r[6];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[5];  
    r[13+3] = r[4];  
    r[13+4] = (r[12]);
    r[13+5] = (r[11]);
    r[13+6] = r[2];  
    r[13+7] = (r[10]);
    r[13+8] = r[9];  
    r[13+9] = r[8];  
    r[13+10] = r[1];  
    r[13+11] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v7503;

case 239: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v7503: /* k c r* env b beta complex-msub a alpha s r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(239);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r[13+5] = r[5];  
    r[13+6] = r[6];  
    r[13+7] = r[7];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[12]);
    r[13+11] = r[1];  
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v7504;
  }

case 240: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v7504: /* k f r* env b beta complex-msub a alpha s c-loop c r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[12]))) {
    r[13+0] = (r[10]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(240);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(3+1), 14); /* 14 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = obj_from_case(241);
    r[13] = (hendblk(3+1));
  if ((fixnum_from_obj(r[1]) < (fixnum_from_obj(r[12]) / (2)))) {
    r[14+0] = r[6];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[11]);
    r[14+3] = r[1];  
    r[14+4] = r[9];  
    r[14+5] = r[8];  
    r[14+6] = r[7];  
    r[14+7] = r[2];  
    r[14+8] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;
  } else {
    r[14+0] = r[6];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[11]);
    r[14+3] = r[1];  
    r[14+4] = r[9];  
    r[14+5] = r[5];  
    r[14+6] = r[4];  
    r[14+7] = r[2];  
    r[14+8] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;
  }
  }

case 241: /* clo k r* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k r* env f-loop f k */
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[6+3] = r[1];  
    r[6+4] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 242: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 243: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 244: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 245: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 246: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-msubx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = obj_from_fixnum(1);
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 247: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-msubx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 248: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-msubx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("high")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 249: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-msubx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("low")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 250: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-msubx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 251: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-maddx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = obj_from_fixnum(1);
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 252: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-maddx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 253: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(3+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(254);
    r[8] = (hendblk(3+1));
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[8];  
    *--hp = r[6];  
    *--hp = obj_from_case(258);
    r[8] = (hendblk(6+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__231769);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 254: /* clo k c f s alpha a r* env */
    assert(rc == 9);
    { obj* p = objptr_from_obj(r[0]);
    r[1+8] = p[1];
    r[1+9] = p[2];
    r[1+10] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k c f s alpha a r* env q2c-rename output* attr* */
    hreserve(hbsz(9+1), 11); /* 11 live regs */
    *--hp = r[4];  
    *--hp = (r[10]);
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[8];  
    *--hp = r[5];  
    *--hp = obj_from_case(255);
    r[11] = (hendblk(9+1));
    r[12+0] = r[8];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = (r[11]);
    r[12+2] = r[7];  
    r[12+3] = r[3];  
    r[12+4] = (mksymbol(internsym("fermion")));
    r[12+5] = (r[1]);
    r[12+6] = (r[2]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 255: /* clo k s env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k s env a q2c-rename f c output* k r* attr* alpha */
    hreserve(hbsz(9+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(256);
    r[12] = (hendblk(9+1));
    r[13+0] = r[4];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = (mksymbol(internsym("fermion")));
    r[13+5] = (r[6]);
    r[13+6] = (r[5]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 256: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k a env q2c-rename f c output* k r* attr* s alpha */
    hreserve(hbsz(6+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(257);
    r[12] = (hendblk(6+1));
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[2];  
    r[13+3] = (car((r[6])));
    r[13+4] = (mksymbol(internsym("fermion")));
    r[13+5] = (r[5]);
    r[13+6] = (r[4]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 257: /* clo k x env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k x env k r* attr* s alpha a */
    { /* vector */
    hreserve(hbsz(2+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = (mknull());
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[10] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("complex-rmadd")));
    *--hp = (r[5]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 258: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list complex-madd env r* k input* */
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(259);
    r[8] = (hendblk(5+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[7];  
    r[3] = obj_from_fixnum(5);
    r[4] = (cx__231768);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 259: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek  complex-madd env r* k input* */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(260);
    r[7] = (hendblk(5+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    goto s_l_v7266;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(267);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(268);
    r[10] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    r[3] = r[8];  
    r[4] = r[9];  
    r[5] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 260: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
s_l_v7266: /* ek r complex-madd env r* k input* */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = obj_from_case(261);
    r[7] = (hendblk(6+1));
  if (((is_fixnum_obj(mksymbol(internsym("*fermion-dim*")))) || (is_flonum_obj(mksymbol(internsym("*fermion-dim*")))))) {
    r[8+0] = obj_from_ktrap();
    r[8+1] = (mksymbol(internsym("*fermion-dim*")));
    r[8+2] = (r[2]);
    r[8+3] = (r[1]);
    r[8+4] = (r[3]);
    r[8+5] = (r[4]);
    r[8+6] = (r[5]);
    r[8+7] = (r[6]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v7278;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*fermion-dim*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    hreserve(hbsz(0+1), 9); /* 9 live regs */
    *--hp = obj_from_case(265);
    r[9] = (hendblk(0+1));
    hreserve(hbsz(0+1), 10); /* 10 live regs */
    *--hp = obj_from_case(266);
    r[10] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[3];  
    r[3] = r[8];  
    r[4] = r[9];  
    r[5] = (r[10]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 261: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
s_l_v7278: /* ek r complex-madd r env r* k input* */
    r[8] = (car((r[7])));
    r[9] = (cdr((r[7])));
    r[9] = (car((r[9])));
    r[10] = (cdr((r[7])));
    r[10] = (cdr((r[10])));
    r[10] = (car((r[10])));
    r[11] = (cdr((r[7])));
    r[11] = (cdr((r[11])));
    r[11] = (cdr((r[11])));
    r[11] = (car((r[11])));
    r[12] = (cdr((r[7])));
    r[12] = (cdr((r[12])));
    r[12] = (cdr((r[12])));
    r[12] = (cdr((r[12])));
    r[12] = (car((r[12])));
    r[13+0] = r[6];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[5];  
    r[13+3] = r[4];  
    r[13+4] = (r[12]);
    r[13+5] = (r[11]);
    r[13+6] = r[2];  
    r[13+7] = (r[10]);
    r[13+8] = r[9];  
    r[13+9] = r[8];  
    r[13+10] = r[1];  
    r[13+11] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v7279;

case 262: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v7279: /* k c r* env b beta complex-madd a alpha s r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(262);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r[13+5] = r[5];  
    r[13+6] = r[6];  
    r[13+7] = r[7];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[12]);
    r[13+11] = r[1];  
    r[13+12] = (r[10]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v7280;
  }

case 263: /* clo k f r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8];
    r[1+12] = p[9]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v7280: /* k f r* env b beta complex-madd a alpha s c-loop c r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[12]))) {
    r[13+0] = (r[10]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(263);
    r[13] = (hendblk(9+1));
    hreserve(hbsz(3+1), 14); /* 14 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = obj_from_case(264);
    r[13] = (hendblk(3+1));
  if ((fixnum_from_obj(r[1]) < (fixnum_from_obj(r[12]) / (2)))) {
    r[14+0] = r[6];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[11]);
    r[14+3] = r[1];  
    r[14+4] = r[9];  
    r[14+5] = r[8];  
    r[14+6] = r[7];  
    r[14+7] = r[2];  
    r[14+8] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;
  } else {
    r[14+0] = r[6];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[11]);
    r[14+3] = r[1];  
    r[14+4] = r[9];  
    r[14+5] = r[5];  
    r[14+6] = r[4];  
    r[14+7] = r[2];  
    r[14+8] = r[3];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 9);
    goto jump;
  }
  }

case 264: /* clo k r* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k r* env f-loop f k */
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = obj_from_fixnum(fixnum_from_obj(r[4]) + (1));
    r[6+3] = r[1];  
    r[6+4] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 265: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 266: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__231150);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 267: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 268: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 269: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-maddx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("high")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 270: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-maddx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("low")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 271: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-maddx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 272: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-sub")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = obj_from_fixnum(1);
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 273: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-sub")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 274: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-sub")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 275: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-sub")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*colors*")));
    r[7+7] = (mksymbol(internsym("gauge")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 276: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-add")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = obj_from_fixnum(1);
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 277: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-add")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 278: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-add")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*fermion-dim*")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 279: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-addx */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = (mksymbol(internsym("complex-add")));
    r[7+3] = (r[1]);
    r[7+4] = (r[2]);
    r[7+5] = (r[3]);
    r[7+6] = (mksymbol(internsym("*colors*")));
    r[7+7] = (mksymbol(internsym("gauge")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 280: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = obj_from_fixnum(1);
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 281: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 282: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("high")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 283: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("low")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 284: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 285: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-scalex */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("gauge")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 286: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-zerox */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = obj_from_fixnum(1);
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("staggered-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 287: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-zerox */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("projected-fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 288: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-zerox */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*fermion-dim*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("fermion")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 289: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-zerox */
    r[7+0] = r[6];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[0];  
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[3];  
    r[7+5] = (mksymbol(internsym("*colors*")));
    r[7+6] = (mksymbol(internsym("all")));
    r[7+7] = (mksymbol(internsym("gauge")));
    r[7+8] = (r[4]);
    r[7+9] = (r[5]);
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 10);
    goto jump;

case 290: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename new-reg */
    hreserve(hbsz(9+1), 9); /* 9 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(291);
    r[9] = (hendblk(9+1));
    r[10+0] = r[6];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[9];  
    r[10+2] = r[2];  
    r[10+3] = obj_from_fixnum(1);
    r[10+4] = (cx__232665);
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 291: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename new-reg attr* env r* k input* output* */
    hreserve(hbsz(8+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(292);
    r[11] = (hendblk(8+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[9];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__232664);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 292: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-rename new-reg attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(293);
    r[10] = (hendblk(8+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[0] = obj_from_ktrap();
    r[1] = (mksymbol(internsym("*colors*")));
    r[2] = (r[2]);
    r[3] = (r[3]);
    r[4] = (r[4]);
    r[5] = (r[5]);
    r[6] = (r[6]);
    r[7] = (r[7]);
    r[8] = (r[8]);
    r[9] = (r[9]);
    goto s_l_v6886;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(299);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(300);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[5];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 293: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
s_l_v6886: /* ek r q2c-rename new-reg attr* env r* k input* output* */
    r[10] = (car((r[9])));
    r[11] = (car((r[8])));
    r[12] = (cdr((r[8])));
    r[12] = (car((r[12])));
    r[13+0] = r[7];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[6];  
    r[13+3] = r[5];  
    r[13+4] = obj_from_bool(0);
    r[13+5] = (r[11]);
    r[13+6] = r[2];  
    r[13+7] = (r[12]);
    r[13+8] = r[3];  
    r[13+9] = r[4];  
    r[13+10] = (r[10]);
    r[13+11] = r[1];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_2Dx;

case 294: /* clo k x r* env q */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7]; }
    r += 1; /* shift reg. wnd */
s_loop_2Dx: /* k x r* env q r-a q2c-rename r-b new-reg attr* r-r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-fini")));
    *--hp = (r[9]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[2];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (r[12]);
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(294);
    r[12] = (hendblk(7+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = r[2];  
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r[13+5] = r[5];  
    r[13+6] = r[6];  
    r[13+7] = r[7];  
    r[13+8] = r[8];  
    r[13+9] = r[9];  
    r[13+10] = (r[12]);
    r[13+11] = r[1];  
    r[13+12] = (r[11]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_2Dy;
  }

case 295: /* clo k y r* env q */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7];
    r[1+12] = p[8]; }
    r += 1; /* shift reg. wnd */
s_loop_2Dy: /* k y r* env q r-a q2c-rename r-b new-reg attr* loop-x x r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[12]))) {
    r[13+0] = (r[10]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r[13+5] = r[4];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(295);
    r[13] = (hendblk(8+1));
    hreserve(hbsz(10+1), 14); /* 14 live regs */
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = r[9];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(296);
    r[13] = (hendblk(10+1));
    r[14+0] = r[6];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[3];  
    r[14+3] = r[5];  
    r[14+4] = (mksymbol(internsym("gauge")));
    r[14+5] = (r[1]);
    r[14+6] = (r[11]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  }

case 296: /* clo k v-a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k v-a env q2c-rename r-b new-reg loop-y k r* q attr* y x */
    hreserve(hbsz(9+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(297);
    r[13] = (hendblk(9+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    /* r[2] */    
    r[3] = r[4];  
    r[4] = (mksymbol(internsym("gauge")));
    r[5] = (r[12]);
    r[6] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 297: /* clo k v-b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k v-b env new-reg loop-y k r* q attr* v-a y x */
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[1];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(298);
    r[12] = (hendblk(10+1));
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 298: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop-y env k r* q attr* v-b v-a y x */
    { const fixnum_t v9542_y = fixnum_from_obj(r[10]);
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
  if (((fixnum_from_obj(r[11]) == 0) && ((v9542_y) == 0))) {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-init")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[15] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = (r[15]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (mksymbol(internsym("complex-real-cmul-conj-add")));
    *--hp = (r[7]);
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(5+1)); }
  }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = r[5];  
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[14+0] = r[2];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = r[4];  
    r[14+2] = obj_from_fixnum((v9542_y) + (1));
    r[14+3] = (r[13]);
    r[14+4] = r[3];  
    r[14+5] = (r[12]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump; } 

case 299: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 300: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 301: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-gauge */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*colors*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-ccmul")));
    r[9+8] = (mksymbol(internsym("complex-ccmadd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[7]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 302: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-gauge */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*colors*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-c2mul")));
    r[9+8] = (mksymbol(internsym("complex-c2madd")));
    r[9+9] = (r[8]);
    r[9+10] = (r[7]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 303: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-gauge */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*colors*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-cmul")));
    r[9+8] = (mksymbol(internsym("complex-cmadd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 304: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-gauge */
    r[8+0] = r[6];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = r[1];  
    r[8+3] = r[2];  
    r[8+4] = r[3];  
    r[8+5] = (mksymbol(internsym("*colors*")));
    r[8+6] = (r[7]);
    r[8+7] = (mksymbol(internsym("complex-mul")));
    r[8+8] = (mksymbol(internsym("complex-madd")));
    r[8+9] = (r[7]);
    r[8+10] = (r[7]);
    r[8+11] = (r[4]);
    r[8+12] = (r[5]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 305: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-staggered-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = obj_from_fixnum(1);
    r[9+6] = r[8];  
    r[9+7] = (mksymbol(internsym("complex-cmul")));
    r[9+8] = (mksymbol(internsym("complex-cmadd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 306: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-projected-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-cmul")));
    r[9+8] = (mksymbol(internsym("complex-cmadd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 307: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-conj-gauge q2c-get-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*fermion-dim*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-cmul")));
    r[9+8] = (mksymbol(internsym("complex-cmadd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 308: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-gauge q2c-get-staggered-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = obj_from_fixnum(1);
    r[9+6] = r[8];  
    r[9+7] = (mksymbol(internsym("complex-mul")));
    r[9+8] = (mksymbol(internsym("complex-madd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 309: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-gauge q2c-get-projected-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*projected-fermion-dim*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-mul")));
    r[9+8] = (mksymbol(internsym("complex-madd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 310: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2];
    r[1+8] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-mul-g q2c-get-gauge q2c-get-fermion */
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = r[1];  
    r[9+3] = r[2];  
    r[9+4] = r[3];  
    r[9+5] = (mksymbol(internsym("*fermion-dim*")));
    r[9+6] = (r[8]);
    r[9+7] = (mksymbol(internsym("complex-mul")));
    r[9+8] = (mksymbol(internsym("complex-madd")));
    r[9+9] = (r[7]);
    r[9+10] = (r[8]);
    r[9+11] = (r[4]);
    r[9+12] = (r[5]);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 13);
    goto jump;

case 311: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(8+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(312);
    r[8] = (hendblk(8+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__23599);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 312: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(313);
    r[10] = (hendblk(8+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__23598);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 313: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(314);
    r[10] = (hendblk(8+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(328);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(329);
    r[12] = (hendblk(0+1));
    r[0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[4];  
    r[3] = (mksymbol(internsym("unproject")));
    r[4] = (r[11]);
    r[5] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 314: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(315);
    r[10] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("unproject")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(326);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(327);
    r[13] = (hendblk(1+1));
    r[14+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = r[5];  
    r[14+3] = (r[11]);
    r[14+4] = (r[12]);
    r[14+5] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 315: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(316);
    r[10] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = (mksymbol(internsym("*colors*")));
    r[11+2] = (r[2]);
    r[11+3] = (r[3]);
    r[11+4] = (r[4]);
    r[11+5] = (r[1]);
    r[11+6] = (r[5]);
    r[11+7] = (r[6]);
    r[11+8] = (r[7]);
    r[11+9] = (r[8]);
    r[11+10] = (r[9]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6640;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(324);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(325);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[5];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 316: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v6640: /* ek r q2c-check-list q2c-rename attr* r env r* k input* output* */
    r[11] = (car((r[10])));
    r[12] = (car((r[9])));
    r[13] = (cdr((r[9])));
    r[13] = (car((r[13])));
    r[14+0] = r[8];  
    r[14+1] = obj_from_fixnum(0);
    r[14+2] = r[7];  
    r[14+3] = r[6];  
    r[14+4] = r[2];  
    r[14+5] = (r[12]);
    r[14+6] = (r[13]);
    r[14+7] = r[3];  
    r[14+8] = (r[11]);
    r[14+9] = r[4];  
    r[14+10] = r[5];  
    r[14+11] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v6641;

case 317: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v6641: /* k c r* env q2c-check-list r-a r-b q2c-rename r-r attr* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(317);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = (r[10]);
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r[13+5] = r[4];  
    r[13+6] = r[5];  
    r[13+7] = r[6];  
    r[13+8] = r[7];  
    r[13+9] = r[8];  
    r[13+10] = r[9];  
    r[13+11] = (r[12]);
    r[13+12] = r[1];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v6642;
  }

case 318: /* clo k f op* r* env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7];
    r[1+12] = p[8]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v6642: /* k f op* r* env q2c-check-list r-a r-b q2c-rename r-r attr* c-loop c */
  if ((isnull((r[2])))) {
    r[13+0] = (r[11]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[12]) + (1));
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[13] = (car((r[2])));
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(318);
    r[14] = (hendblk(8+1));
    hreserve(hbsz(13+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[10]);
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = (r[14]);
    *--hp = r[9];  
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = obj_from_case(319);
    r[14] = (hendblk(13+1));
    r[15+0] = r[5];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = (r[13]);
    r[15+3] = obj_from_fixnum(2);
    r[15+4] = (cx__23569);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 319: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* ek  r-a env r-b q2c-rename c r-r f-loop op* f k r* attr* op */
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(320);
    r[15] = (hendblk(11+1));
    r[16+0] = r[5];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[3];  
    r[16+3] = r[2];  
    r[16+4] = (mksymbol(internsym("fermion")));
    r[16+5] = (r[6]);
    r[16+6] = (r[10]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 320: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k a env r-b q2c-rename c r-r f-loop op* f k r* attr* op */
    r[14] = (car((r[13])));
    r[15] = (cdr((r[13])));
    r[15] = (car((r[15])));
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = (r[14]);
    *--hp = obj_from_case(321);
    r[16] = (hendblk(11+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    /* r[2] */    
    /* r[3] */    
    r[4] = (mksymbol(internsym("projected-fermion")));
    r[5] = (r[5]);
    r[6] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 321: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k b env opcode q2c-rename c r-r f-loop op* f k r* attr* a */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(322);
    r[14] = (hendblk(12+1));
  if (((((r[3]) == (mksymbol(internsym("plus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-one"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-sub")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6650;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-one"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-add")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6650;
  } else {
  if (((((r[3]) == (mksymbol(internsym("plus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-i"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-sub-i")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6650;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-i"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-add-i")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6650;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    r[0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = (cx__23489);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }
  }

case 322: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
s_l_v6650: /* ek r q2c-rename c r-r env f-loop op* f k r* attr* b a */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(323);
    r[14] = (hendblk(9+1));
    r[15+0] = r[2];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[5];  
    r[15+3] = r[4];  
    r[15+4] = (mksymbol(internsym("fermion")));
    r[15+5] = (r[3]);
    r[15+6] = (r[8]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 323: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k r env f-loop op* f k r* r attr* b a */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[6];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[5]) + (1));
    r[13+3] = (cdr((r[4])));
    r[13+4] = (r[12]);
    r[13+5] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 324: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 325: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 326: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 327: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup")));
    r[3+3] = (cx__23454);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 328: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 329: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("attr-lookup")));
    r[1+3] = (cx__23445);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 330: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(8+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(331);
    r[8] = (hendblk(8+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__23735);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 331: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(332);
    r[10] = (hendblk(8+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(2);
    r[4] = (cx__23734);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 332: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(333);
    r[10] = (hendblk(8+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(347);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(348);
    r[12] = (hendblk(0+1));
    r[0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[4];  
    r[3] = (mksymbol(internsym("unproject")));
    r[4] = (r[11]);
    r[5] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 333: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(334);
    r[10] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("unproject")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(345);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(346);
    r[13] = (hendblk(1+1));
    r[14+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = r[5];  
    r[14+3] = (r[11]);
    r[14+4] = (r[12]);
    r[14+5] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 334: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(335);
    r[10] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = (mksymbol(internsym("*colors*")));
    r[11+2] = (r[2]);
    r[11+3] = (r[3]);
    r[11+4] = (r[4]);
    r[11+5] = (r[1]);
    r[11+6] = (r[5]);
    r[11+7] = (r[6]);
    r[11+8] = (r[7]);
    r[11+9] = (r[8]);
    r[11+10] = (r[9]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6510;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(343);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(344);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[5];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 335: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v6510: /* ek r q2c-check-list q2c-rename attr* r env r* k input* output* */
    r[11] = (car((r[10])));
    r[12] = (car((r[9])));
    r[13] = (cdr((r[9])));
    r[13] = (car((r[13])));
    r[14+0] = r[8];  
    r[14+1] = obj_from_fixnum(0);
    r[14+2] = r[7];  
    r[14+3] = r[6];  
    r[14+4] = r[2];  
    r[14+5] = (r[12]);
    r[14+6] = (r[13]);
    r[14+7] = r[3];  
    r[14+8] = (r[11]);
    r[14+9] = r[4];  
    r[14+10] = r[5];  
    r[14+11] = r[1];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v6511;

case 336: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7];
    r[1+11] = p[8]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v6511: /* k c r* env q2c-check-list r-a r-b q2c-rename r-r attr* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[11]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(8+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(336);
    r[12] = (hendblk(8+1));
    r[13+0] = r[0];  
    r[13+1] = obj_from_fixnum(0);
    r[13+2] = (r[10]);
    r[13+3] = r[2];  
    r[13+4] = r[3];  
    r[13+5] = r[4];  
    r[13+6] = r[5];  
    r[13+7] = r[6];  
    r[13+8] = r[7];  
    r[13+9] = r[8];  
    r[13+10] = r[9];  
    r[13+11] = (r[12]);
    r[13+12] = r[1];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v6512;
  }

case 337: /* clo k f op* r* env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7];
    r[1+12] = p[8]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v6512: /* k f op* r* env q2c-check-list r-a r-b q2c-rename r-r attr* c-loop c */
  if ((isnull((r[2])))) {
    r[13+0] = (r[11]);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[12]) + (1));
    r[13+3] = r[3];  
    r[13+4] = r[4];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[13] = (car((r[2])));
    hreserve(hbsz(8+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(337);
    r[14] = (hendblk(8+1));
    hreserve(hbsz(13+1), 15); /* 15 live regs */
    *--hp = (r[13]);
    *--hp = (r[10]);
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = (r[14]);
    *--hp = r[9];  
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = obj_from_case(338);
    r[14] = (hendblk(13+1));
    r[15+0] = r[5];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = (r[13]);
    r[15+3] = obj_from_fixnum(2);
    r[15+4] = (cx__23569);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 338: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13]; }
    r += 1; /* shift reg. wnd */
    /* ek  r-a env r-b q2c-rename c r-r f-loop op* f k r* attr* op */
    hreserve(hbsz(11+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(339);
    r[15] = (hendblk(11+1));
    r[16+0] = r[5];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[15]);
    r[16+2] = r[3];  
    r[16+3] = r[2];  
    r[16+4] = (mksymbol(internsym("fermion")));
    r[16+5] = (r[6]);
    r[16+6] = (r[10]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 339: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k a env r-b q2c-rename c r-r f-loop op* f k r* attr* op */
    r[14] = (car((r[13])));
    r[15] = (cdr((r[13])));
    r[15] = (car((r[15])));
    hreserve(hbsz(11+1), 16); /* 16 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = (r[14]);
    *--hp = obj_from_case(340);
    r[16] = (hendblk(11+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    /* r[2] */    
    /* r[3] */    
    r[4] = (mksymbol(internsym("projected-fermion")));
    r[5] = (r[5]);
    r[6] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 340: /* clo k b env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11]; }
    r += 1; /* shift reg. wnd */
    /* k b env opcode q2c-rename c r-r f-loop op* f k r* attr* a */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(341);
    r[14] = (hendblk(12+1));
  if (((((r[3]) == (mksymbol(internsym("plus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-one"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-add")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6520;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-one"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-sub")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6520;
  } else {
  if (((((r[3]) == (mksymbol(internsym("plus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-i"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-add-i")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6520;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-i"))))))) && (1))) {
    r[15+0] = obj_from_ktrap();
    r[15+1] = (mksymbol(internsym("complex-sub-i")));
    r[15+2] = (r[4]);
    r[15+3] = (r[5]);
    r[15+4] = (r[6]);
    r[15+5] = (r[2]);
    r[15+6] = (r[7]);
    r[15+7] = (r[8]);
    r[15+8] = (r[9]);
    r[15+9] = (r[10]);
    r[15+10] = (r[11]);
    r[15+11] = (r[12]);
    r[15+12] = (r[1]);
    r[15+13] = (r[13]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6520;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[15] = (hendblk(3)); }
    r[0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = (cx__23489);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }
  }

case 341: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
s_l_v6520: /* ek r q2c-rename c r-r env f-loop op* f k r* attr* b a */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(342);
    r[14] = (hendblk(9+1));
    r[15+0] = r[2];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[5];  
    r[15+3] = r[4];  
    r[15+4] = (mksymbol(internsym("fermion")));
    r[15+5] = (r[3]);
    r[15+6] = (r[8]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 342: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k r env f-loop op* f k r* r attr* b a */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[6];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[5]) + (1));
    r[13+3] = (cdr((r[4])));
    r[13+4] = (r[12]);
    r[13+5] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 343: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 344: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 345: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 346: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup")));
    r[3+3] = (cx__23454);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 347: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 348: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("attr-lookup")));
    r[1+3] = (cx__23607);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 349: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(8+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(350);
    r[8] = (hendblk(8+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__23877);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 350: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(351);
    r[10] = (hendblk(8+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__23876);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 351: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(352);
    r[10] = (hendblk(8+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(368);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(369);
    r[12] = (hendblk(0+1));
    r[0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[4];  
    r[3] = (mksymbol(internsym("unproject")));
    r[4] = (r[11]);
    r[5] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 352: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(353);
    r[10] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("unproject")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(366);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(367);
    r[13] = (hendblk(1+1));
    r[14+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = r[5];  
    r[14+3] = (r[11]);
    r[14+4] = (r[12]);
    r[14+5] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 353: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(354);
    r[10] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = (mksymbol(internsym("*colors*")));
    r[11+2] = (r[2]);
    r[11+3] = (r[3]);
    r[11+4] = (r[4]);
    r[11+5] = (r[1]);
    r[11+6] = (r[5]);
    r[11+7] = (r[6]);
    r[11+8] = (r[7]);
    r[11+9] = (r[8]);
    r[11+10] = (r[9]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6372;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(364);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(365);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[5];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 354: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v6372: /* ek r q2c-check-list q2c-rename attr* r env r* k input* output* */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(355);
    r[11] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*fermion-dim*")))) || (is_flonum_obj(mksymbol(internsym("*fermion-dim*")))))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = (mksymbol(internsym("*fermion-dim*")));
    r[12+2] = (r[2]);
    r[12+3] = (r[3]);
    r[12+4] = (r[4]);
    r[12+5] = (r[5]);
    r[12+6] = (r[1]);
    r[12+7] = (r[6]);
    r[12+8] = (r[7]);
    r[12+9] = (r[8]);
    r[12+10] = (r[9]);
    r[12+11] = (r[10]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6384;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*fermion-dim*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(362);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(363);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[6];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 355: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v6384: /* ek  q2c-check-list q2c-rename attr* r r env r* k input* output* */
    r[12] = (car((r[11])));
    r[13] = (car((r[10])));
    r[14+0] = r[9];  
    r[14+1] = obj_from_fixnum(0);
    r[14+2] = r[8];  
    r[14+3] = r[7];  
    r[14+4] = r[2];  
    r[14+5] = (r[13]);
    r[14+6] = r[3];  
    r[14+7] = (r[12]);
    r[14+8] = r[4];  
    r[14+9] = r[5];  
    r[14+10] = r[6];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v6385;

case 356: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v6385: /* k c r* env q2c-check-list r-a q2c-rename r-r attr* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[10]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(356);
    r[11] = (hendblk(7+1));
    r[12+0] = r[0];  
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = r[9];  
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r[12+5] = r[4];  
    r[12+6] = r[5];  
    r[12+7] = r[6];  
    r[12+8] = r[7];  
    r[12+9] = r[8];  
    r[12+10] = (r[11]);
    r[12+11] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_f_2Dloop_v6386;
  }

case 357: /* clo k f op* r* env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7]; }
    r += 1; /* shift reg. wnd */
s_f_2Dloop_v6386: /* k f op* r* env q2c-check-list r-a q2c-rename r-r attr* c-loop c */
  if ((isnull((r[2])))) {
    r[12+0] = (r[10]);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[12+3] = r[3];  
    r[12+4] = r[4];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[12] = (car((r[2])));
    hreserve(hbsz(7+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(357);
    r[13] = (hendblk(7+1));
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = r[9];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = obj_from_case(358);
    r[13] = (hendblk(12+1));
    r[14+0] = r[5];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[12]);
    r[14+3] = obj_from_fixnum(2);
    r[14+4] = (cx__23569);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 358: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  r-a env q2c-rename c r-r f-loop op* f k r* attr* op */
    r[14] = (car((r[13])));
    r[15] = (cdr((r[13])));
    r[15] = (car((r[15])));
    hreserve(hbsz(10+1), 16); /* 16 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = (r[14]);
    *--hp = obj_from_case(359);
    r[16] = (hendblk(10+1));
    r[17+0] = r[4];  
    pc = objptr_from_obj(r[17+0])[0];
    r[17+1] = (r[16]);
    r[17+2] = r[3];  
    r[17+3] = r[2];  
    r[17+4] = (mksymbol(internsym("projected-fermion")));
    r[17+5] = (r[5]);
    r[17+6] = (r[15]);
    r += 17; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 359: /* clo k a env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10]; }
    r += 1; /* shift reg. wnd */
    /* k a env opcode q2c-rename c r-r f-loop op* f k r* attr* */
    hreserve(hbsz(11+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(360);
    r[13] = (hendblk(11+1));
  if (((((r[3]) == (mksymbol(internsym("plus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-one"))))))) && (1))) {
    r[14+0] = obj_from_ktrap();
    r[14+1] = (mksymbol(internsym("complex-move")));
    r[14+2] = (r[4]);
    r[14+3] = (r[5]);
    r[14+4] = (r[6]);
    r[14+5] = (r[2]);
    r[14+6] = (r[7]);
    r[14+7] = (r[8]);
    r[14+8] = (r[9]);
    r[14+9] = (r[10]);
    r[14+10] = (r[11]);
    r[14+11] = (r[12]);
    r[14+12] = (r[1]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6392;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-one"))))))) && (1))) {
    r[14+0] = obj_from_ktrap();
    r[14+1] = (mksymbol(internsym("complex-neg")));
    r[14+2] = (r[4]);
    r[14+3] = (r[5]);
    r[14+4] = (r[6]);
    r[14+5] = (r[2]);
    r[14+6] = (r[7]);
    r[14+7] = (r[8]);
    r[14+8] = (r[9]);
    r[14+9] = (r[10]);
    r[14+10] = (r[11]);
    r[14+11] = (r[12]);
    r[14+12] = (r[1]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6392;
  } else {
  if (((((r[3]) == (mksymbol(internsym("plus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-i"))))))) && (1))) {
    r[14+0] = obj_from_ktrap();
    r[14+1] = (mksymbol(internsym("complex-times-plus-i")));
    r[14+2] = (r[4]);
    r[14+3] = (r[5]);
    r[14+4] = (r[6]);
    r[14+5] = (r[2]);
    r[14+6] = (r[7]);
    r[14+7] = (r[8]);
    r[14+8] = (r[9]);
    r[14+9] = (r[10]);
    r[14+10] = (r[11]);
    r[14+11] = (r[12]);
    r[14+12] = (r[1]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6392;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-i"))))))) && (1))) {
    r[14+0] = obj_from_ktrap();
    r[14+1] = (mksymbol(internsym("complex-times-minus-i")));
    r[14+2] = (r[4]);
    r[14+3] = (r[5]);
    r[14+4] = (r[6]);
    r[14+5] = (r[2]);
    r[14+6] = (r[7]);
    r[14+7] = (r[8]);
    r[14+8] = (r[9]);
    r[14+9] = (r[10]);
    r[14+10] = (r[11]);
    r[14+11] = (r[12]);
    r[14+12] = (r[1]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6392;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    r[0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = (cx__23489);
    r[3] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }
  }

case 360: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11]; }
    r += 1; /* shift reg. wnd */
s_l_v6392: /* ek r q2c-rename c r-r env f-loop op* f k r* attr* a */
    hreserve(hbsz(8+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(361);
    r[13] = (hendblk(8+1));
    r[14+0] = r[2];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = r[5];  
    r[14+3] = r[4];  
    r[14+4] = (mksymbol(internsym("fermion")));
    r[14+5] = (r[3]);
    r[14+6] = (r[8]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 361: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* k r env f-loop op* f k r* r attr* a */
    { /* vector */
    hreserve(hbsz(2+1), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[11] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[7];  
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = r[3];  
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[6];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[5]) + (1));
    r[12+3] = (cdr((r[4])));
    r[12+4] = (r[11]);
    r[12+5] = r[2];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 362: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 363: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23762);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 364: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 365: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 366: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 367: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup")));
    r[3+3] = (cx__23454);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 368: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 369: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("attr-lookup")));
    r[1+3] = (cx__23743);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 370: /* clo k attr* output* input* r* env */
    assert(rc == 7);
    { obj* p = objptr_from_obj(r[0]);
    r[1+6] = p[1];
    r[1+7] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k attr* output* input* r* env q2c-check-list q2c-rename */
    hreserve(hbsz(8+1), 8); /* 8 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(371);
    r[8] = (hendblk(8+1));
    r[9+0] = r[6];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r[9+3] = obj_from_fixnum(1);
    r[9+4] = (cx__231051);
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 371: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(372);
    r[10] = (hendblk(8+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[8];  
    r[3] = obj_from_fixnum(1);
    r[4] = (cx__231050);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 372: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek  q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(373);
    r[10] = (hendblk(8+1));
    hreserve(hbsz(0+1), 11); /* 11 live regs */
    *--hp = obj_from_case(390);
    r[11] = (hendblk(0+1));
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(391);
    r[12] = (hendblk(0+1));
    r[0] = (cx_attr_2Dsearch);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[4];  
    r[3] = (mksymbol(internsym("project")));
    r[4] = (r[11]);
    r[5] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 373: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(374);
    r[10] = (hendblk(8+1));
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("project")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(388);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(1+1), 13); /* 13 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(389);
    r[13] = (hendblk(1+1));
    r[14+0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[10]);
    r[14+2] = r[5];  
    r[14+3] = (r[11]);
    r[14+4] = (r[12]);
    r[14+5] = (r[13]);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 374: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8]; }
    r += 1; /* shift reg. wnd */
    /* ek r q2c-check-list q2c-rename attr* env r* k input* output* */
    hreserve(hbsz(9+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(375);
    r[10] = (hendblk(9+1));
  if (((is_fixnum_obj(mksymbol(internsym("*colors*")))) || (is_flonum_obj(mksymbol(internsym("*colors*")))))) {
    r[11+0] = obj_from_ktrap();
    r[11+1] = (mksymbol(internsym("*colors*")));
    r[11+2] = (r[2]);
    r[11+3] = (r[3]);
    r[11+4] = (r[4]);
    r[11+5] = (r[1]);
    r[11+6] = (r[5]);
    r[11+7] = (r[6]);
    r[11+8] = (r[7]);
    r[11+9] = (r[8]);
    r[11+10] = (r[9]);
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6226;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*colors*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    hreserve(hbsz(0+1), 12); /* 12 live regs */
    *--hp = obj_from_case(386);
    r[12] = (hendblk(0+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(387);
    r[13] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[10]);
    r[2] = r[5];  
    r[3] = (r[11]);
    r[4] = (r[12]);
    r[5] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 375: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
s_l_v6226: /* ek r q2c-check-list q2c-rename attr* r env r* k input* output* */
    hreserve(hbsz(10+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(376);
    r[11] = (hendblk(10+1));
  if (((is_fixnum_obj(mksymbol(internsym("*fermion-dim*")))) || (is_flonum_obj(mksymbol(internsym("*fermion-dim*")))))) {
    r[12+0] = obj_from_ktrap();
    r[12+1] = (mksymbol(internsym("*fermion-dim*")));
    r[12+2] = (r[2]);
    r[12+3] = (r[3]);
    r[12+4] = (r[4]);
    r[12+5] = (r[5]);
    r[12+6] = (r[1]);
    r[12+7] = (r[6]);
    r[12+8] = (r[7]);
    r[12+9] = (r[8]);
    r[12+10] = (r[9]);
    r[12+11] = (r[10]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6238;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("*fermion-dim*")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (mksymbol(internsym("const")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(384);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(0+1), 14); /* 14 live regs */
    *--hp = obj_from_case(385);
    r[14] = (hendblk(0+1));
    r[0] = (cx_lookup_2Dfmap);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[11]);
    r[2] = r[6];  
    r[3] = (r[12]);
    r[4] = (r[13]);
    r[5] = (r[14]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;
  }

case 376: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v6238: /* ek r q2c-check-list q2c-rename attr* r r env r* k input* output* */
    r[12] = (car((r[11])));
    r[13] = (car((r[10])));
    r[14+0] = r[9];  
    r[14+1] = obj_from_fixnum(0);
    r[14+2] = r[8];  
    r[14+3] = r[7];  
    r[14+4] = r[2];  
    r[14+5] = (r[13]);
    r[14+6] = r[3];  
    r[14+7] = (r[12]);
    r[14+8] = r[4];  
    r[14+9] = r[5];  
    r[14+10] = r[6];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_c_2Dloop_v6239;

case 377: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3];
    r[1+7] = p[4];
    r[1+8] = p[5];
    r[1+9] = p[6];
    r[1+10] = p[7]; }
    r += 1; /* shift reg. wnd */
s_c_2Dloop_v6239: /* k c r* env q2c-check-list r-a q2c-rename r-r attr* r r */
  if ((fixnum_from_obj(r[1]) == fixnum_from_obj(r[10]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(377);
    r[11] = (hendblk(7+1));
    r[12+0] = r[0];  
    r[12+1] = obj_from_fixnum(0);
    r[12+2] = r[9];  
    r[12+3] = r[2];  
    r[12+4] = r[3];  
    r[12+5] = r[4];  
    r[12+6] = r[5];  
    r[12+7] = r[6];  
    r[12+8] = r[7];  
    r[12+9] = r[8];  
    r[12+10] = (r[11]);
    r[12+11] = r[1];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_h_2Dloop;
  }

case 378: /* clo k h op* r* env */
    assert(rc == 6);
    { obj* p = objptr_from_obj(r[0]);
    r[1+5] = p[1];
    r[1+6] = p[2];
    r[1+7] = p[3];
    r[1+8] = p[4];
    r[1+9] = p[5];
    r[1+10] = p[6];
    r[1+11] = p[7]; }
    r += 1; /* shift reg. wnd */
s_h_2Dloop: /* k h op* r* env q2c-check-list r-a q2c-rename r-r attr* c-loop c */
  if ((isnull((r[2])))) {
    r[12+0] = (r[10]);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = obj_from_fixnum(fixnum_from_obj(r[11]) + (1));
    r[12+3] = r[3];  
    r[12+4] = r[4];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    r[12] = (car((r[2])));
    hreserve(hbsz(7+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(378);
    r[13] = (hendblk(7+1));
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[12]);
    *--hp = r[9];  
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[4];  
    *--hp = obj_from_case(379);
    r[13] = (hendblk(12+1));
    r[14+0] = r[5];  
    pc = objptr_from_obj(r[14+0])[0];
    r[14+1] = (r[13]);
    r[14+2] = (r[12]);
    r[14+3] = obj_from_fixnum(4);
    r[14+4] = (cx__231021);
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 379: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  env r-a q2c-rename c r-r h-loop op* h k r* attr* op */
    r[14] = (car((r[13])));
    r[15] = (cdr((r[13])));
    r[15] = (car((r[15])));
    hreserve(hbsz(12+1), 16); /* 16 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = (r[14]);
    *--hp = r[3];  
    *--hp = obj_from_case(380);
    r[16] = (hendblk(12+1));
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[16]);
    /* r[2] */    
    /* r[3] */    
    r[4] = (mksymbol(internsym("fermion")));
    r[5] = (r[5]);
    r[6] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 380: /* clo k a-0 env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k a-0 env r-a op-0 q2c-rename c r-r h-loop op* h k r* attr* op */
    r[15] = (cdr((r[14])));
    r[15] = (cdr((r[15])));
    r[15] = (car((r[15])));
    r[16] = (cdr((r[14])));
    r[16] = (cdr((r[16])));
    r[16] = (cdr((r[16])));
    r[16] = (car((r[16])));
    hreserve(hbsz(12+1), 17); /* 17 live regs */
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = (r[15]);
    *--hp = obj_from_case(381);
    r[17] = (hendblk(12+1));
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[17]);
    /* r[2] */    
    /* r[3] */    
    r[4] = (mksymbol(internsym("fermion")));
    r[5] = (r[6]);
    r[6] = (r[16]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 381: /* clo k a-1 env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9];
    r[1+12] = p[10];
    r[1+13] = p[11];
    r[1+14] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* k a-1 env op-1 op-0 q2c-rename c r-r h-loop op* h k r* attr* a-0 */
    hreserve(hbsz(12+1), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = r[1];  
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(382);
    r[15] = (hendblk(12+1));
  if (((((r[4]) == (mksymbol(internsym("plus-one")))) || ((is_flonum_obj(r[4])) && ((is_flonum_obj(mksymbol(internsym("plus-one")))) && (flonum_from_obj(r[4]) == flonum_from_obj(mksymbol(internsym("plus-one"))))))) && (1))) {
  if (((((r[3]) == (mksymbol(internsym("plus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-one"))))))) && (1))) {
    r[16+0] = obj_from_ktrap();
    r[16+1] = (mksymbol(internsym("complex-add")));
    r[16+2] = (r[5]);
    r[16+3] = (r[6]);
    r[16+4] = (r[7]);
    r[16+5] = (r[2]);
    r[16+6] = (r[8]);
    r[16+7] = (r[9]);
    r[16+8] = (r[10]);
    r[16+9] = (r[11]);
    r[16+10] = (r[12]);
    r[16+11] = (r[13]);
    r[16+12] = (r[1]);
    r[16+13] = (r[14]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6248;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-one")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-one")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-one"))))))) && (1))) {
    r[16+0] = obj_from_ktrap();
    r[16+1] = (mksymbol(internsym("complex-sub")));
    r[16+2] = (r[5]);
    r[16+3] = (r[6]);
    r[16+4] = (r[7]);
    r[16+5] = (r[2]);
    r[16+6] = (r[8]);
    r[16+7] = (r[9]);
    r[16+8] = (r[10]);
    r[16+9] = (r[11]);
    r[16+10] = (r[12]);
    r[16+11] = (r[13]);
    r[16+12] = (r[1]);
    r[16+13] = (r[14]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6248;
  } else {
  if (((((r[3]) == (mksymbol(internsym("plus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("plus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("plus-i"))))))) && (1))) {
    r[16+0] = obj_from_ktrap();
    r[16+1] = (mksymbol(internsym("complex-add-i")));
    r[16+2] = (r[5]);
    r[16+3] = (r[6]);
    r[16+4] = (r[7]);
    r[16+5] = (r[2]);
    r[16+6] = (r[8]);
    r[16+7] = (r[9]);
    r[16+8] = (r[10]);
    r[16+9] = (r[11]);
    r[16+10] = (r[12]);
    r[16+11] = (r[13]);
    r[16+12] = (r[1]);
    r[16+13] = (r[14]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6248;
  } else {
  if (((((r[3]) == (mksymbol(internsym("minus-i")))) || ((is_flonum_obj(r[3])) && ((is_flonum_obj(mksymbol(internsym("minus-i")))) && (flonum_from_obj(r[3]) == flonum_from_obj(mksymbol(internsym("minus-i"))))))) && (1))) {
    r[16+0] = obj_from_ktrap();
    r[16+1] = (mksymbol(internsym("complex-sub-i")));
    r[16+2] = (r[5]);
    r[16+3] = (r[6]);
    r[16+4] = (r[7]);
    r[16+5] = (r[2]);
    r[16+6] = (r[8]);
    r[16+7] = (r[9]);
    r[16+8] = (r[10]);
    r[16+9] = (r[11]);
    r[16+10] = (r[12]);
    r[16+11] = (r[13]);
    r[16+12] = (r[1]);
    r[16+13] = (r[14]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v6248;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    r[0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[15]);
    r[2] = (cx__23935);
    r[3] = (r[16]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }
  }
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 16); /* 16 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[16] = (hendblk(3)); }
    r[0] = (cx_s_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[15]);
    r[2] = (cx__23929);
    r[3] = (r[16]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 382: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
s_l_v6248: /* ek r q2c-rename c r-r env h-loop op* h k r* attr* a-1 a-0 */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = obj_from_case(383);
    r[14] = (hendblk(9+1));
    r[15+0] = r[2];  
    pc = objptr_from_obj(r[15+0])[0];
    r[15+1] = (r[14]);
    r[15+2] = r[5];  
    r[15+3] = r[4];  
    r[15+4] = (mksymbol(internsym("projected-fermion")));
    r[15+5] = (r[3]);
    r[15+6] = (r[8]);
    r += 15; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;

case 383: /* clo k r env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7];
    r[1+10] = p[8];
    r[1+11] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* k r env h-loop op* h k r* r attr* a-1 a-0 */
    { /* vector */
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = (r[11]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[13] = (hendblk(2+1)); }
    { /* vector */
    hreserve(hbsz(2+1), 14); /* 14 live regs */
    *--hp = (r[10]);
    *--hp = (mksymbol(internsym("reg")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[14] = (hendblk(2+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (mknull());
    *--hp = (r[14]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[14] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 15); /* 15 live regs */
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* vector */
    hreserve(hbsz(5+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-operation")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[12] = (hendblk(5+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = r[7];  
    *--hp = (r[12]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[3];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[6];  
    r[13+2] = obj_from_fixnum(fixnum_from_obj(r[5]) + (1));
    r[13+3] = (cdr((r[4])));
    r[13+4] = (r[12]);
    r[13+5] = r[2];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 6);
    goto jump;

case 384: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 385: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23762);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 386: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 387: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("ce-lookup-x")));
    r[1+3] = (cx__23461);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 388: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 389: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k r */
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[2] = (hendblk(3)); }
    r[3+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (mksymbol(internsym("ce-lookup")));
    r[3+3] = (cx__23891);
    r[3+4] = (r[2]);
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 390: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k x */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = r[1];  
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 391: /* clo k */
    assert(rc == 2);
    r += 1; /* shift reg. wnd */
    /* k */
    r[1+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[1+0])[0];
    r[1+1] = r[0];  
    r[1+2] = (mksymbol(internsym("attr-lookup")));
    r[1+3] = (cx__23885);
    r[1+4] = (mknull());
    r += 1; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 392: /* clo k ast env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k ast env q2c-decl */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (2))) {
    r[4] = (vectorref((r[1]), (0)));
    r[4] = obj_from_bool((r[4]) == (mksymbol(internsym("qa0-top"))));
  } else {
    r[4] = obj_from_bool(0);
  }
  } else {
    r[4] = obj_from_bool(0);
  }
  if (bool_from_obj(r[4])) {
    r[4] = (vectorref((r[1]), (1)));
    r[5+0] = r[0];  
    r[5+1] = (mknull());
    r[5+2] = r[4];  
    r[5+3] = r[2];  
    r[5+4] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v6162;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (mksymbol(internsym("variant-case")));
    r[5+3] = (cx__233181);
    r[5+4] = (r[4]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 393: /* clo k r* decl* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v6162: /* k r* decl* env q2c-decl */
  if ((isnull((r[2])))) {
    { fixnum_t v9541_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v9541_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v9541_tmp);
    hreserve(hbsz(3)*c, 5); /* 5 live regs */
    l = r[1];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[5] = (o); } }
    { /* vector */
    hreserve(hbsz(2+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = (mksymbol(internsym("qa0-top")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[5] = (hendblk(2+1)); }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(393);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = obj_from_case(394);
    r[5] = (hendblk(4+1));
    r[6+0] = r[4];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (car((r[2])));
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 394: /* clo k d e */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k d e loop decl* r* k */
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[6];  
    r[8+2] = r[7];  
    r[8+3] = (cdr((r[4])));
    r[8+4] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

s_q2c_2Dloop: /* k c attr* var low high code* r* env q2c-store* q2c-load* q2c-op* */
    hreserve(hbsz(6+1), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[7];  
    *--hp = r[0];  
    *--hp = obj_from_case(395);
    r[12] = (hendblk(6+1));
    r[0] = (r[12]);
    r[1] = r[6];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_q2c_2Dcode_2A;

case 395: /* clo k c* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* k c* env k r* high low var attr* */
    { /* vector */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (mksymbol(internsym("qa0-loop")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[9] = (hendblk(6+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[4];  
    *--hp = r[9];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[10+0] = r[3];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = obj_from_ktrap();
    r[10+2] = r[9];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_q2c_2Dif: /* k c var true-code* false-code* r* env q2c-store* q2c-load* q2c-op* */
    hreserve(hbsz(3+1), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = obj_from_case(399);
    r[10] = (hendblk(3+1));
    hreserve(hbsz(5+1), 11); /* 11 live regs */
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = (r[10]);
    *--hp = obj_from_case(396);
    r[11] = (hendblk(5+1));
    r[0] = (r[11]);
    r[1] = r[3];  
    r[2] = r[6];  
    r[3] = r[7];  
    r[4] = r[8];  
    r[5] = r[9];  
    goto s_q2c_2Dcode_2A;

case 396: /* clo k t* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k t* env q2c-code* false-code* k r* var */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(397);
    r[8] = (hendblk(4+1));
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[4];  
    r[9+3] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 397: /* clo k f* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k f* env k r* t* var */
    { /* vector */
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = (mksymbol(internsym("qa0-if")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[7] = (hendblk(4+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[4];  
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = obj_from_ktrap();
    r[8+2] = r[7];  
    r[8+3] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 398: /* clo k c r* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k c r* env q2c-store* q2c-load* q2c-op* */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-operation"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[6])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = r[2];  
    r[12+6] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-load"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[5])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = r[2];  
    r[12+6] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (5))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-store"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (objptr_from_obj(r[4])[0]);
    { /* assq */
    obj x = (r[8]), l = (r[11]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[11] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[11])) {
    r[12+0] = (cdr((r[11])));
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = r[7];  
    r[12+3] = r[9];  
    r[12+4] = (r[10]);
    r[12+5] = r[2];  
    r[12+6] = r[3];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 7);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = r[0];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = obj_from_ktrap();
    r[13+2] = (r[12]);
    r[13+3] = r[3];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (6))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-loop"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10] = (vectorref((r[1]), (4)));
    r[11] = (vectorref((r[1]), (5)));
    r[12+0] = r[0];  
    r[12+1] = r[1];  
    r[12+2] = r[7];  
    r[12+3] = r[8];  
    r[12+4] = r[9];  
    r[12+5] = (r[10]);
    r[12+6] = (r[11]);
    r[12+7] = r[2];  
    r[12+8] = r[3];  
    r[12+9] = r[4];  
    r[12+10] = r[5];  
    r[12+11] = r[6];  
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_q2c_2Dloop;
  } else {
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (4))) {
    r[7] = (vectorref((r[1]), (0)));
    r[7] = obj_from_bool((r[7]) == (mksymbol(internsym("qa0-if"))));
  } else {
    r[7] = obj_from_bool(0);
  }
  } else {
    r[7] = obj_from_bool(0);
  }
  if (bool_from_obj(r[7])) {
    r[7] = (vectorref((r[1]), (1)));
    r[8] = (vectorref((r[1]), (2)));
    r[9] = (vectorref((r[1]), (3)));
    r[10+0] = r[0];  
    r[10+1] = r[1];  
    r[10+2] = r[7];  
    r[10+3] = r[8];  
    r[10+4] = r[9];  
    r[10+5] = r[2];  
    r[10+6] = r[3];  
    r[10+7] = r[4];  
    r[10+8] = r[5];  
    r[10+9] = r[6];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_q2c_2Dif;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = (cx_ic_2Derror_2A);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = (mksymbol(internsym("variant-case")));
    r[8+3] = (cx__233181);
    r[8+4] = (r[7]);
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  }
  }
  }
  }

case 399: /* clo k code* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
s_q2c_2Dcode_2A: /* k code* env q2c-store* q2c-load* q2c-op* */
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(398);
    r[6] = (hendblk(3+1));
    r[7+0] = r[0];  
    r[7+1] = (mknull());
    r[7+2] = r[1];  
    r[7+3] = r[2];  
    r[7+4] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v5979;

case 400: /* clo k r* code* env */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1]; }
    r += 1; /* shift reg. wnd */
s_loop_v5979: /* k r* code* env q2c-code */
  if ((isnull((r[2])))) {
    { fixnum_t v9540_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v9540_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v9540_tmp);
    hreserve(hbsz(3)*c, 5); /* 5 live regs */
    l = r[1];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[5] = (o); } }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r[6+3] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = obj_from_case(400);
    r[5] = (hendblk(1+1));
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[5];  
    *--hp = obj_from_case(401);
    r[5] = (hendblk(3+1));
    r[6+0] = r[4];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = (car((r[2])));
    r[6+3] = r[1];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 401: /* clo k r* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k r* env loop code* k */
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = (cdr((r[4])));
    r[6+4] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

s_q2c_2Dproc: /* k attr* name arg-name* arg-type* arg-c-name* arg-c-type* code* env q2c-store* q2c-load* q2c-op* */
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = obj_from_case(402);
    r[12] = (hendblk(7+1));
    r[0] = (r[12]);
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_q2c_2Dcode_2A;

case 402: /* clo k c* env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6];
    r[1+9] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* k c* env k arg-c-type* arg-c-name* arg-type* arg-name* name attr* */
    { /* vector */
    hreserve(hbsz(8+1), 10); /* 10 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (mksymbol(internsym("qa0-proc")));
    *--hp = obj_from_size(VECTOR_BTAG);
    r[10] = (hendblk(8+1)); }
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = obj_from_ktrap();
    r[11+2] = (r[10]);
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 403: /* clo k decl env */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k decl env q2c-store* q2c-load* q2c-op* */
  if ((isvector((r[1])))) {
  if (((vectorlen((r[1]))) == (8))) {
    r[6] = (vectorref((r[1]), (0)));
    r[6] = obj_from_bool((r[6]) == (mksymbol(internsym("qa0-proc"))));
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[6] = (vectorref((r[1]), (1)));
    r[7] = (vectorref((r[1]), (2)));
    r[8] = (vectorref((r[1]), (3)));
    r[9] = (vectorref((r[1]), (4)));
    r[10] = (vectorref((r[1]), (5)));
    r[11] = (vectorref((r[1]), (6)));
    r[12] = (vectorref((r[1]), (7)));
    r[13+0] = r[0];  
    r[13+1] = r[6];  
    r[13+2] = r[7];  
    r[13+3] = r[8];  
    r[13+4] = r[9];  
    r[13+5] = (r[10]);
    r[13+6] = (r[11]);
    r[13+7] = (r[12]);
    r[13+8] = r[2];  
    r[13+9] = r[3];  
    r[13+10] = r[4];  
    r[13+11] = r[5];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_q2c_2Dproc;
  } else {
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
