/* read.ss */
/* Generated by #F $Id: c.sf 22 2008-04-26 19:28:22Z esl@acm.org $ */
#ifdef PROFILE
#define host host_module_read
#endif
#define MODULE module_read
#define LOAD() module_error(); module_sfc(); 
extern void module_sfc(void); /* sfc.sf */
extern void module_error(void); /* error.ss */

/* standard includes */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <assert.h>
/* extra includes */
#include <math.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>

/* standard definitions */
#define REGS_SIZE 5000

typedef ptrdiff_t obj;        /* pointers are this size, lower bit zero */
typedef ptrdiff_t cxoint_t;   /* same thing, used as integer */
typedef struct {              /* type descriptor */
  const char *tname;          /* name (debug) */
  void (*free)(void*);        /* deallocator */
} cxtype_t;

#define notobjptr(o)          (((char*)(o) - (char*)cxg_heap) & cxg_hmask)
#define isobjptr(o)           (!notobjptr(o))
#define notaptr(o)            ((o) & 1)
#define isaptr(o)             (!notaptr(o))

#define obj_from_obj(o)       (o)
#define obj_from_objptr(p)    ((obj)(p))
#define obj_from_size(n)      (((cxoint_t)(n) << 1) | 1)

#define objptr_from_objptr(p) (p)
#define objptr_from_obj(o)    ((obj*)(o))

#define size_from_obj(o)      ((int)((o) >> 1))

#define obj_from_case(n)      obj_from_objptr(cases+(n))
#define case_from_obj(o)      (objptr_from_obj(o)-cases)
#define obj_from_ktrap()      obj_from_size(0x5D56F806)
#define obj_from_void(v)      ((void)(v), obj_from_size(0x6F56DF77))

#define bool_from_obj(o)      (o)
#define bool_from_bool(b)     (b)
#define bool_from_size(s)     (s)

#define void_from_void(v)     (void)(v)
#define void_from_obj(o)      (void)(o)

#define rreserve(m)           if (r > cxg_regs + REGS_SIZE - 2*(m)) r = cxm_rgc(r, r+(m))
#define hpushptr(p, pt, l)    (hreserve(2, l), *--hp = (obj)(p), *--hp = (obj)(pt), (obj)(hp+1))   
#define hbsz(s)               ((s) + 1) /* 1 extra word to store block size */
#define hreserve(n, l)        ((hp < cxg_heap + (n)) ? hp = cxm_hgc(r, r+(l), hp, n) : hp)
#define hendblk(n)            (*--hp = obj_from_size(n), (obj)(hp+1))
#define hblklen(p)            size_from_obj(((obj*)(p))[-1])
#define hblkref(p, i)         (((obj*)(p))[i])

typedef obj (*cxhost_t)(obj);
typedef struct cxroot_tag {
  int globc; obj **globv;
  struct cxroot_tag *next;
} cxroot_t;

extern obj *cxg_heap;
extern obj *cxg_hp;
extern cxoint_t cxg_hmask;
extern cxroot_t *cxg_rootp;
extern obj *cxm_rgc(obj *regs, obj *regp);
extern obj *cxm_hgc(obj *regs, obj *regp, obj *hp, size_t needs);
extern obj cxg_regs[REGS_SIZE];
extern void *cxm_cknull(void *p, char *msg);
#ifndef NDEBUG
extern int cxg_rc;
#endif

/* extra definitions */
/* basic object representation */
#define isimm(o, t) (((o) & 0xff) == (((t) << 1) | 1))
#ifdef NDEBUG
  #define getimmu(o, t) (int)(((o) >> 8) & 0xffffff)
  #define getimms(o, t) (int)(((((o) >> 8) & 0xffffff) ^ 0x800000) - 0x800000)
#else
  extern int getimmu(obj o, int t);
  extern int getimms(obj o, int t);
#endif
#define mkimm(o, t) ((((o) & 0xffffff) << 8) | ((t) << 1) | 1)
#ifdef NDEBUG
   static int isnative(obj o, cxtype_t *tp) 
     { return isobjptr(o) && objptr_from_obj(o)[-1] == (obj)tp;  }
   #define getnative(o, t) ((void*)(*objptr_from_obj(o)))
#else
  extern int isnative(obj o, cxtype_t *tp);
  extern void *getnative(obj o, cxtype_t *tp);
#endif
extern int istagged(obj o, int t);
#ifdef NDEBUG
  #define cktagged(o, t) (o)
  #define taggedlen(o, t) (hblklen(o)-1) 
  #define taggedref(o, t, i) (&hblkref(o, (i)+1))
#else
  extern obj cktagged(obj o, int t);
  extern int taggedlen(obj o, int t);
  extern obj* taggedref(obj o, int t, int i); 
#endif
/* booleans */
#define TRUE_ITAG 0
typedef int bool_t;
#define is_bool_obj(o) (!((o) & ~(obj)1))
#define is_bool_bool(b) ((void)(b), 1)
#define void_from_bool(b) (void)(b)
#define obj_from_bool(b) ((b) ? mkimm(0, TRUE_ITAG) : 0)
/* fixnums */
#define FIXNUM_ITAG 1
typedef int fixnum_t;
#define is_fixnum_obj(o) (isimm(o, FIXNUM_ITAG))
#define is_fixnum_fixnum(i) ((void)(i), 1)
#define fixnum_from_obj(o) (getimms(o, FIXNUM_ITAG))
#define fixnum_from_fixnum(i) (i)
#define void_from_fixnum(i) (void)(i)
#define obj_from_fixnum(i) mkimm(i, FIXNUM_ITAG)
#define FIXNUM_MIN -8388608
#define FIXNUM_MAX 8388607
/* flonums */
extern cxtype_t *FLONUM_NTAG;
typedef double flonum_t;
#define is_flonum_obj(o) (isnative(o, FLONUM_NTAG))
#define is_flonum_flonum(f) ((void)(f), 1)
#define flonum_from_obj(o) (*(flonum_t*)getnative(o, FLONUM_NTAG))
#define flonum_from_flonum(l, f) (f)
#define void_from_flonum(l, f) (void)(f)
#define obj_from_flonum(l, f) hpushptr(dupflonum(f), FLONUM_NTAG, l)
extern flonum_t *dupflonum(flonum_t f);
/* characters */
#define CHAR_ITAG 2
typedef int char_t;
#define is_char_obj(o) (isimm(o, CHAR_ITAG))
#define is_char_char(i) ((i), 1)
#define char_from_obj(o) (getimms(o, CHAR_ITAG))
#define char_from_char(i) (i)
#define void_from_char(i) (void)(i)
#define obj_from_char(i) mkimm(i, CHAR_ITAG)
/* strings */
extern cxtype_t *STRING_NTAG;
#define isstring(o) (isnative(o, STRING_NTAG))
#define stringdata(o) ((int*)getnative(o, STRING_NTAG))
#define stringlen(o) (*stringdata(o))
#define stringchars(o) ((char*)(stringdata(o)+1))
#define hpushstr(l, s) hpushptr(s, STRING_NTAG, l)
#ifdef NDEBUG
  #define stringref(o, i) (stringchars(o)+(i))
#else
  extern char* stringref(obj o, int i);
#endif
extern int *newstring(char *s);
extern int *allocstring(int n, int c);
extern int *substring(int *d, int from, int to);
extern int *stringcat(int *d0, int *d1);
extern int *dupstring(int *d);
extern void stringfill(int *d, int c);
extern int strcmp_ci(char *s1, char*s2);
/* vectors */
#define VECTOR_BTAG 1
#define isvector(o) istagged(o, VECTOR_BTAG)
#define vectorref(v, i) *taggedref(v, VECTOR_BTAG, i)
#define vectorlen(v) taggedlen(v, VECTOR_BTAG)
/* boxes */
#define BOX_BTAG 2
#define isbox(o) istagged(o, BOX_BTAG)
#define boxref(o) *taggedref(o, BOX_BTAG, 0)
/* null */
#define NULL_ITAG 2
#define mknull() mkimm(0, NULL_ITAG)
#define isnull(o) ((o) == mkimm(0, NULL_ITAG))
/* pairs and lists */
#define PAIR_BTAG 3
#define ispair(o) istagged(o, PAIR_BTAG)
#define car(o) *taggedref(o, PAIR_BTAG, 0)
#define cdr(o) *taggedref(o, PAIR_BTAG, 1)
/* symbols */
#define SYMBOL_ITAG 3
#define issymbol(o) (isimm(o, SYMBOL_ITAG))
#define mksymbol(i) mkimm(i, SYMBOL_ITAG)
#define getsymbol(o) getimmu(o, SYMBOL_ITAG)
extern char *symbolname(int sym);
extern int internsym(char *name);
/* eof */
#define EOF_ITAG 127
#define mkeof() mkimm(-1, EOF_ITAG)
#define iseof(o) ((o) == mkimm(-1, EOF_ITAG))
/* input ports */
extern cxtype_t *IPORT_NTAG;
#define isiport(o) (isnative(o, IPORT_NTAG))
#define iportdata(o) ((FILE*)getnative(o, IPORT_NTAG))
#define mkiport(l, fp) hpushptr(fp, IPORT_NTAG, l)
/* output ports */
extern cxtype_t *OPORT_NTAG;
#define isoport(o) (isnative(o, OPORT_NTAG))
#define oportdata(o) ((FILE*)getnative(o, OPORT_NTAG))
#define mkoport(l, fp) hpushptr(fp, OPORT_NTAG, l)

/* cx globals */
extern obj cx_member; /* member */
extern obj cx_r_2Derror_2A; /* r-error* */
extern obj cx_string_2D_3Efixnum; /* string->fixnum */
extern obj cx_string_2D_3Eflonum; /* string->flonum */
obj cx_q_2Dread_2F1; /* q-read/1 */
static obj cx__23113; /* constant #113 */
static obj cx__23125; /* constant #125 */
static obj cx__23159; /* constant #159 */
static obj cx__23169; /* constant #169 */
static obj cx__23277; /* constant #277 */
static obj cx__23283; /* constant #283 */
static obj cx__23307; /* constant #307 */
static obj cx__23308; /* constant #308 */
static obj cx__23334; /* constant #334 */
static obj cx__23378; /* constant #378 */
static obj cx__23387; /* constant #387 */
static obj cx__23394; /* constant #394 */
static obj cx__23410; /* constant #410 */
static obj cx__23438; /* constant #438 */
static obj cx__23439; /* constant #439 */
static obj cx__23440; /* constant #440 */
static obj cx__23459; /* constant #459 */
static obj cx__23462; /* constant #462 */
static obj cx__23472; /* constant #472 */
static obj cx__23475; /* constant #475 */
static obj cx__23480; /* constant #480 */
static obj cx__23487; /* constant #487 */
static obj cx__23488; /* constant #488 */
static obj cx__23499; /* constant #499 */
static obj cx__23522; /* constant #522 */
static obj cx__23555; /* constant #555 */
static obj cx__23593; /* constant #593 */
static obj cx__23609; /* constant #609 */
static obj cx__23614; /* constant #614 */
static obj cx__23620; /* constant #620 */
static obj cx__23638; /* constant #638 */
static obj cx__23664; /* constant #664 */
static obj cx__23677; /* constant #677 */
static obj cx__23713; /* constant #713 */
static obj cx__23723; /* constant #723 */
static obj cx__23794; /* constant #794 */
static obj cx__23795; /* constant #795 */
static obj cx__23813; /* constant #813 */
static obj cx__2395; /* constant #95 */

/* gc roots */
static obj *globv[] = {
  &cx_q_2Dread_2F1,
  &cx__23113,
  &cx__23125,
  &cx__23159,
  &cx__23169,
  &cx__23277,
  &cx__23283,
  &cx__23307,
  &cx__23308,
  &cx__23334,
  &cx__23378,
  &cx__23387,
  &cx__23394,
  &cx__23410,
  &cx__23438,
  &cx__23439,
  &cx__23440,
  &cx__23459,
  &cx__23462,
  &cx__23472,
  &cx__23475,
  &cx__23480,
  &cx__23487,
  &cx__23488,
  &cx__23499,
  &cx__23522,
  &cx__23555,
  &cx__23593,
  &cx__23609,
  &cx__23614,
  &cx__23620,
  &cx__23638,
  &cx__23664,
  &cx__23677,
  &cx__23713,
  &cx__23723,
  &cx__23794,
  &cx__23795,
  &cx__23813,
  &cx__2395,
};

static cxroot_t root = {
  sizeof(globv)/sizeof(obj *), globv, NULL
};

/* entry points */
static obj host(obj);
static obj cases[127] = {
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,  (obj)host,  (obj)host,  (obj)host,
  (obj)host,  (obj)host,
};

/* host procedure */
#define MAX_LIVEREGS 56
static obj host(obj pc)
{
  register obj *r = cxg_regs;
  register obj *hp = cxg_hp;
#ifndef NDEBUG
  register int rc = cxg_rc;
#endif
  jump: 
  switch (case_from_obj(pc)) {

case 0: /* load module */
    r[0] = (hpushstr(0, newstring("...")));
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = (mknull());
    *--hp = r[0];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    r[1] = (hpushstr(1, newstring("-")));
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    r[1] = (hpushstr(1, newstring("+")));
    { /* cons */ 
    hreserve(hbsz(3), 2); /* 2 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    cx__2395 = (hendblk(3)); }
    cx__23113 = (hpushstr(0, newstring("unsupported number syntax")));
    cx__23125 = (hpushstr(0, newstring(".")));
    cx__23159 = (hpushstr(0, newstring("symbol literal")));
    cx__23169 = (hpushstr(0, newstring("invalid escape sequence in a symbol")));
    cx__23277 = (hpushstr(0, newstring("invalid hex digit in a ")));
    cx__23283 = (hpushstr(0, newstring("premature end of a scalar-value literal within a ")));
    cx__23307 = (hpushstr(0, newstring("invalid escaped character in string")));
    cx__23308 = (hpushstr(0, newstring("string literal")));
    cx__23334 = (hpushstr(0, newstring("end of file within a string")));
    cx__23378 = (hpushstr(0, newstring("randomness after form after dot")));
    cx__23387 = (hpushstr(0, newstring("eof inside list -- unbalanced parentheses")));
    cx__23394 = (hpushstr(0, newstring("missing car -- ( immediately followed by .")));
    cx__23410 = (hpushstr(0, newstring("illegal character read")));
    { static char s[] = { 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 34, 32, 46, 32, 34, 0 };
    cx__23438 = (hpushstr(0, newstring(s))); }
    cx__23439 = (hpushstr(0, newstring("unexpected right bracket")));
    cx__23440 = (hpushstr(0, newstring("unexpected right parenthesis")));
    cx__23459 = (hpushstr(0, newstring("unexpected token")));
    cx__23462 = (hpushstr(0, newstring("unexpected end of file")));
    cx__23472 = (hpushstr(0, newstring("unexpected datum")));
    cx__23475 = (hpushstr(0, newstring("discarding extraneous right bracket")));
    cx__23480 = (hpushstr(0, newstring("extraneous right parenthesis")));
    { /* vector */
    hreserve(hbsz(7+1), 0); /* 0 live regs */
    *--hp = obj_from_fixnum(160);
    *--hp = obj_from_fixnum(32);
    *--hp = obj_from_fixnum(13);
    *--hp = obj_from_fixnum(12);
    *--hp = obj_from_fixnum(11);
    *--hp = obj_from_fixnum(10);
    *--hp = obj_from_fixnum(9);
    *--hp = obj_from_size(VECTOR_BTAG);
    cx__23487 = (hendblk(7+1)); }
    { /* vector */
    hreserve(hbsz(36+1), 0); /* 0 live regs */
    *--hp = obj_from_fixnum(187);
    *--hp = obj_from_fixnum(173);
    *--hp = obj_from_fixnum(171);
    *--hp = obj_from_fixnum(160);
    *--hp = obj_from_fixnum(159);
    *--hp = obj_from_fixnum(158);
    *--hp = obj_from_fixnum(157);
    *--hp = obj_from_fixnum(156);
    *--hp = obj_from_fixnum(155);
    *--hp = obj_from_fixnum(154);
    *--hp = obj_from_fixnum(153);
    *--hp = obj_from_fixnum(152);
    *--hp = obj_from_fixnum(151);
    *--hp = obj_from_fixnum(150);
    *--hp = obj_from_fixnum(149);
    *--hp = obj_from_fixnum(148);
    *--hp = obj_from_fixnum(147);
    *--hp = obj_from_fixnum(146);
    *--hp = obj_from_fixnum(145);
    *--hp = obj_from_fixnum(144);
    *--hp = obj_from_fixnum(143);
    *--hp = obj_from_fixnum(142);
    *--hp = obj_from_fixnum(141);
    *--hp = obj_from_fixnum(140);
    *--hp = obj_from_fixnum(139);
    *--hp = obj_from_fixnum(138);
    *--hp = obj_from_fixnum(137);
    *--hp = obj_from_fixnum(136);
    *--hp = obj_from_fixnum(135);
    *--hp = obj_from_fixnum(134);
    *--hp = obj_from_fixnum(133);
    *--hp = obj_from_fixnum(132);
    *--hp = obj_from_fixnum(131);
    *--hp = obj_from_fixnum(130);
    *--hp = obj_from_fixnum(129);
    *--hp = obj_from_fixnum(128);
    *--hp = obj_from_size(VECTOR_BTAG);
    cx__23488 = (hendblk(36+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 0); /* 0 live regs */
    *--hp = (mknull());
    *--hp = obj_from_char(101);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(105);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(120);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(100);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(111);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(98);
    *--hp = obj_from_size(PAIR_BTAG); 
    cx__23499 = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 0); /* 0 live regs */
    *--hp = (mknull());
    *--hp = obj_from_char(57);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(56);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(55);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(54);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(53);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(52);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(51);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(50);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(49);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_char(48);
    *--hp = obj_from_size(PAIR_BTAG); 
    cx__23522 = (hendblk(3)); }
    { static char s[] = { 117, 110, 107, 110, 111, 119, 110, 32, 35, 92, 60, 100, 105, 103, 105, 116, 115, 62, 32, 109, 97, 99, 114, 111, 0 };
    cx__23555 = (hpushstr(0, newstring(s))); }
    cx__23593 = (hpushstr(0, newstring("dot in #(...)")));
    { static char s[] = { 117, 110, 107, 110, 111, 119, 110, 32, 35, 92, 32, 110, 97, 109, 101, 0 };
    cx__23609 = (hpushstr(0, newstring(s))); }
    cx__23614 = (hpushstr(0, newstring("char literal")));
    { static char s[] = { 101, 110, 100, 32, 111, 102, 32, 102, 105, 108, 101, 32, 97, 102, 116, 101, 114, 32, 35, 92, 0 };
    cx__23620 = (hpushstr(0, newstring(s))); }
    cx__23638 = (hpushstr(0, newstring("end of file in #| comment")));
    cx__23664 = (hpushstr(0, newstring("end of file after &")));
    cx__23677 = (hpushstr(0, newstring("end of file after ,")));
    cx__23713 = (hpushstr(0, newstring("end of file after #")));
    cx__23723 = (hpushstr(0, newstring("unknown # syntax")));
    cx__23794 = (hpushstr(0, newstring("NOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")));
    { static char s[] = { 33, 36, 37, 38, 42, 43, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 60, 61, 62, 63, 64, 94, 95, 126, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 0 };
    cx__23795 = (hpushstr(0, newstring(s))); }
    { /* cons */ 
    hreserve(hbsz(3), 0); /* 0 live regs */
    *--hp = (mknull());
    *--hp = obj_from_fixnum(13);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_fixnum(12);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_fixnum(11);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_fixnum(10);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_fixnum(9);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[0] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 1); /* 1 live regs */
    *--hp = r[0];  
    *--hp = obj_from_fixnum(32);
    *--hp = obj_from_size(PAIR_BTAG); 
    cx__23813 = (hendblk(3)); }
    hreserve(hbsz(0+1), 0); /* 0 live regs */
    *--hp = obj_from_case(1);
    r[0] = (hendblk(0+1));
    hreserve(hbsz(0+1), 1); /* 1 live regs */
    *--hp = obj_from_case(2);
    r[1] = (hendblk(0+1));
    hreserve(hbsz(0+1), 2); /* 2 live regs */
    *--hp = obj_from_case(3);
    r[2] = (hendblk(0+1));
    hreserve(hbsz(1), 3); /* 3 live regs */
    *--hp = obj_from_void(0);
    r[3] = (hendblk(1));
    hreserve(hbsz(1), 4); /* 4 live regs */
    *--hp = obj_from_void(0);
    r[4] = (hendblk(1));
    hreserve(hbsz(1), 5); /* 5 live regs */
    *--hp = obj_from_void(0);
    r[5] = (hendblk(1));
    hreserve(hbsz(1), 6); /* 6 live regs */
    *--hp = obj_from_void(0);
    r[6] = (hendblk(1));
    hreserve(hbsz(1), 7); /* 7 live regs */
    *--hp = obj_from_void(0);
    r[7] = (hendblk(1));
    hreserve(hbsz(1), 8); /* 8 live regs */
    *--hp = obj_from_void(0);
    r[8] = (hendblk(1));
    hreserve(hbsz(1), 9); /* 9 live regs */
    *--hp = obj_from_void(0);
    r[9] = (hendblk(1));
    hreserve(hbsz(1), 10); /* 10 live regs */
    *--hp = obj_from_void(0);
    r[10] = (hendblk(1));
    hreserve(hbsz(1+1), 11); /* 11 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(4);
    r[11] = (hendblk(1+1));
    hreserve(hbsz(1+1), 12); /* 12 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(5);
    r[12] = (hendblk(1+1));
    hreserve(hbsz(0+1), 13); /* 13 live regs */
    *--hp = obj_from_case(7);
    r[13] = (hendblk(0+1));
    hreserve(hbsz(1+1), 14); /* 14 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(12);
    r[14] = (hendblk(1+1));
    hreserve(hbsz(5+1), 15); /* 15 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = (r[13]);
    *--hp = r[8];  
    *--hp = r[1];  
    *--hp = obj_from_case(13);
    r[15] = (hendblk(5+1));
    hreserve(hbsz(2+1), 16); /* 16 live regs */
    *--hp = r[6];  
    *--hp = (r[15]);
    *--hp = obj_from_case(19);
    r[16] = (hendblk(2+1));
    hreserve(hbsz(2+1), 17); /* 17 live regs */
    *--hp = r[7];  
    *--hp = (r[16]);
    *--hp = obj_from_case(24);
    r[17] = (hendblk(2+1));
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[12]);
    *--hp = (r[17]);
    *--hp = obj_from_case(25);
    r[18] = (hendblk(2+1));
    hreserve(hbsz(3+1), 19); /* 19 live regs */
    *--hp = r[6];  
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = obj_from_case(28);
    r[19] = (hendblk(3+1));
    hreserve(hbsz(1+1), 20); /* 20 live regs */
    *--hp = r[9];  
    *--hp = obj_from_case(11);
    r[20] = (hendblk(1+1));
    hreserve(hbsz(0+1), 21); /* 21 live regs */
    *--hp = obj_from_case(126);
    r[21] = (hendblk(0+1));
    hreserve(hbsz(2+1), 22); /* 22 live regs */
    *--hp = r[4];  
    *--hp = (r[19]);
    *--hp = obj_from_case(35);
    r[22] = (hendblk(2+1));
    hreserve(hbsz(1+1), 23); /* 23 live regs */
    *--hp = (r[14]);
    *--hp = obj_from_case(17);
    r[23] = (hendblk(1+1));
    hreserve(hbsz(2+1), 24); /* 24 live regs */
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = obj_from_case(6);
    r[24] = (hendblk(2+1));
    hreserve(hbsz(25+1), 25); /* 25 live regs */
    *--hp = obj_from_char((char_t)(10));
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[9];  
    *--hp = (r[10]);
    *--hp = (r[12]);
    *--hp = (r[17]);
    *--hp = (r[15]);
    *--hp = (r[20]);
    *--hp = (r[18]);
    *--hp = (r[21]);
    *--hp = (r[22]);
    *--hp = (r[23]);
    *--hp = (r[13]);
    *--hp = (r[24]);
    *--hp = (r[14]);
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = (r[19]);
    *--hp = (r[16]);
    *--hp = (r[11]);
    *--hp = obj_from_case(36);
    r[20] = (hendblk(25+1));
    r[0] = (r[20]);
    r[1] = (cx__23438);
    r[2] = r[3];  
    goto s_l_v2693;

case 1: /* clo k c */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
    /* k c */
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = obj_from_bool((is_char_obj(r[1])) && (char_from_obj(r[1]) == (59)));
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 2: /* clo k vec val */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k vec val */
    r[3+0] = r[0];  
    r[3+1] = obj_from_fixnum(0);
    r[3+2] = obj_from_fixnum(vectorlen((r[1])));
    r[3+3] = r[2];  
    r[3+4] = r[1];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop;

s_loop: /* k low high val vec */
  if ((fixnum_from_obj(r[1]) < (fixnum_from_obj(r[2]) - (1)))) {
    r[5] = obj_from_fixnum((fixnum_from_obj(r[1]) + fixnum_from_obj(r[2])) / (2));
    r[6] = (vectorref((r[4]), fixnum_from_obj(r[5])));
  if ((fixnum_from_obj(r[3]) == fixnum_from_obj(r[6]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((fixnum_from_obj(r[3]) < fixnum_from_obj(r[6]))) {
    /* r[0] */    
    /* r[1] */    
    r[2] = r[5];  
    /* r[3] */    
    /* r[4] */    
    goto s_loop;
  } else {
    /* r[0] */    
    r[1] = r[5];  
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    goto s_loop;
  }
  }
  } else {
  if ((fixnum_from_obj(r[1]) < fixnum_from_obj(r[2]))) {
    r[5] = (vectorref((r[4]), fixnum_from_obj(r[1])));
    r[5] = obj_from_bool(fixnum_from_obj(r[3]) == fixnum_from_obj(r[5]));
  if (bool_from_obj(r[5])) {
    r[5] = r[1];  
  } else {
    r[5] = obj_from_bool(0);
  }
  } else {
    r[5] = obj_from_bool(0);
  }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 3: /* clo k l n */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k l n */
    { fixnum_t v2739_tmp;
    { /* length */
    int n; obj l = r[1];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v2739_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v2739_tmp);
    hreserve(hbsz(3)*c, 3); /* 3 live regs */
    l = r[1];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[3] = (o); } }
    { fixnum_t v2740_tmp;
    { /* length */
    int n; obj l = r[3];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v2740_tmp = (n); }
    { /* list->string */
    int i, c = (v2740_tmp); 
    obj o = hpushstr(4, allocstring(c, ' ')); /* 4 live regs */
    obj l = r[3];   /* gc-safe */
    char *s = stringchars(o);
    for (i = 0; i < c; ++i, l = cdr(l)) s[i] = char_from_obj(car(l));
    r[3] = (o); } }
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 4: /* clo k message */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
s_l_v2693: /* k message reader-token-marker */
    r[3] = (objptr_from_obj(r[2])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 5: /* clo k form */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k form reader-token-marker */
  if ((ispair((r[1])))) {
    r[3] = (car((r[1])));
    r[4] = (objptr_from_obj(r[2])[0]);
    r[3] = obj_from_bool((r[3]) == (r[4]));
  } else {
    r[3] = obj_from_bool(0);
  }
    r[4+0] = r[0];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 6: /* clo k char terminating? reader */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k char terminating? reader read-terminating?-vector read-dispatch-vector */
    { const char_t v2738_char = char_from_obj(r[1]);
    r[6] = (objptr_from_obj(r[5])[0]);
    (void)(vectorref((r[6]), ((fixnum_t)(v2738_char))) = (r[3]));
    r[6] = (objptr_from_obj(r[4])[0]);
    r[6] = obj_from_void(vectorref((r[6]), ((fixnum_t)(v2738_char))) = (r[2]));
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump; } 

case 7: /* clo k port delimiter? desc */
    assert(rc == 5);
    r += 1; /* shift reg. wnd */
    /* k port delimiter? desc */
    r[4+0] = r[0];  
    r[4+1] = (mknull());
    r[4+2] = r[2];  
    r[4+3] = r[3];  
    r[4+4] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v2651;

case 8: /* clo k rev-digits */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_loop_v2651: /* k rev-digits delimiter? desc port */
    { FILE *p = iportdata((r[4])); int c = fgetc(p); ungetc(c, p);
    r[5] = (c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(8);
    r[6] = (hendblk(3+1));
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[5];  
    *--hp = r[3];  
    *--hp = r[4];  
    *--hp = r[6];  
    *--hp = obj_from_case(9);
    r[6] = (hendblk(6+1));
    r[7+0] = r[2];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[5];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 9: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop port desc c rev-digits k */
  if (bool_from_obj(r[1])) {
    hreserve(hbsz(1+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(10);
    r[8] = (hendblk(1+1));
    { fixnum_t v2736_tmp;
    { /* length */
    int n; obj l = r[6];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v2736_tmp = (n); }
    { /* reverse */
    obj l, o = mknull(); int c = (v2736_tmp);
    hreserve(hbsz(3)*c, 9); /* 9 live regs */
    l = r[6];   /* gc-safe */
    for (; l != mknull(); l = cdr(l)) { *--hp = o; *--hp = car(l);
    *--hp = obj_from_size(PAIR_BTAG); o = hendblk(3); }  
    r[9] = (o); } }
    { fixnum_t v2737_tmp;
    { /* length */
    int n; obj l = r[9];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v2737_tmp = (n); }
    { /* list->string */
    int i, c = (v2737_tmp); 
    obj o = hpushstr(10, allocstring(c, ' ')); /* 10 live regs */
    obj l = r[9];   /* gc-safe */
    char *s = stringchars(o);
    for (i = 0; i < c; ++i, l = cdr(l)) s[i] = char_from_obj(car(l));
    r[9] = (o); } }
    r[0] = (cx_string_2D_3Efixnum);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[9];  
    r[3] = obj_from_fixnum(16);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((iseof((r[5])))) {
    { /* string-append */
    int *d = stringcat(stringdata((cx__23283)), stringdata((r[4])));
    r[8] = (hpushstr(8, d)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { const fixnum_t v2735_scalar_2Dvalue = ((fixnum_t)char_from_obj(r[5]));
    r[8] = obj_from_bool(((v2735_scalar_2Dvalue) >= (48)) && ((v2735_scalar_2Dvalue) <= (57)));
  if (bool_from_obj(r[8])) {
    /* r[8] */    
  } else {
    r[9] = obj_from_bool(((v2735_scalar_2Dvalue) >= (65)) && ((v2735_scalar_2Dvalue) <= (70)));
    r[8] = (bool_from_obj(r[9]) ? (r[9]) : obj_from_bool(((v2735_scalar_2Dvalue) >= (97)) && ((v2735_scalar_2Dvalue) <= (102))));
  } } 
    r[8] = obj_from_bool(!bool_from_obj(r[8]));
  if (bool_from_obj(r[8])) {
    { /* string-append */
    int *d = stringcat(stringdata((cx__23277)), stringdata((r[4])));
    r[8] = (hpushstr(8, d)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 10); /* 10 live regs */
    *--hp = r[9];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { int c = fgetc(iportdata((r[3])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[7];  
    r[2] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }
  }

case 10: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    r[3+0] = r[2];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = obj_from_char((char_t)fixnum_from_obj(r[1]));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 11: /* clo k c proc */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c proc *sharp-macros* */
    r[4] = (objptr_from_obj(r[3])[0]);
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[4] = (objptr_from_obj(r[3])[0] = (r[4]));
    r[5+0] = r[0];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 12: /* clo k c */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c binary-search */
    r[3+0] = r[2];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = (cx__23487);
    r[3+3] = obj_from_fixnum((fixnum_t)char_from_obj(r[1]));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 13: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k c port binary-search read-terminating?-vector decode-hex-digits char-semicolon? reverse-list->string */
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[9+0] = r[0];  
    r[9+1] = r[8];  
    r[9+2] = obj_from_fixnum(1);
    r[9+3] = r[3];  
    r[9+4] = r[4];  
    r[9+5] = r[5];  
    r[9+6] = r[6];  
    r[9+7] = r[7];  
    r[9+8] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v2610;

case 14: /* clo k l n */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
s_loop_v2610: /* k l n binary-search read-terminating?-vector decode-hex-digits char-semicolon? reverse-list->string port */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(14);
    r[9] = (hendblk(6+1));
    { FILE *p = iportdata((r[8])); int c = fgetc(p); ungetc(c, p);
    r[10] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[10])))) {
    r[11+0] = r[7];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[0];  
    r[11+2] = r[1];  
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[10]) == (92))) {
    { int c = fgetc(iportdata((r[8])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { FILE *p = iportdata((r[8])); int c = fgetc(p); ungetc(c, p);
    r[11] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if (((iseof((r[11]))) || (!((120) == char_from_obj(r[11]))))) {
    { /* cons */ 
    hreserve(hbsz(3), 12); /* 12 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[12] = (hendblk(3)); }
    r[13+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = r[0];  
    r[13+2] = (cx__23169);
    r[13+3] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { int c = fgetc(iportdata((r[8])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(5+1), 12); /* 12 live regs */
    *--hp = r[8];  
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[9];  
    *--hp = obj_from_case(15);
    r[12] = (hendblk(5+1));
    r[13+0] = r[5];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[12]);
    r[13+2] = r[8];  
    r[13+3] = r[6];  
    r[13+4] = (cx__23159);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }
  } else {
    r[11] = obj_from_fixnum((fixnum_t)char_from_obj(r[10]));
    hreserve(hbsz(7+1), 12); /* 12 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = obj_from_case(16);
    r[12] = (hendblk(7+1));
  if ((fixnum_from_obj(r[11]) < (128))) {
    r[13] = (objptr_from_obj(r[4])[0]);
    r[13] = (vectorref((r[13]), fixnum_from_obj(r[11])));
    r[14+0] = obj_from_ktrap();
    r[14+1] = (r[13]);
    r[14+2] = r[9];  
    r[14+3] = (r[10]);
    r[14+4] = r[8];  
    r[14+5] = r[7];  
    r[14+6] = r[2];  
    r[14+7] = r[1];  
    r[14+8] = r[0];  
    r += 14; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v2612;
  } else {
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = (cx__23488);
    r[3] = (r[11]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }

case 15: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop n l k port */
    { int c = fgetc(iportdata((r[6])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[5];  
    r[8+2] = r[7];  
    r[8+3] = obj_from_fixnum(fixnum_from_obj(r[3]) + (1));
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 16: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
s_l_v2612: /* ek r loop c port reverse-list->string n l k */
  if (bool_from_obj(r[1])) {
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[7];  
    r[3] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { int c = fgetc(iportdata((r[4])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[7];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[9] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[8];  
    r[2] = r[9];  
    r[3] = obj_from_fixnum(fixnum_from_obj(r[6]) + (1));
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 17: /* clo k c */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c char-unicode-whitespace? */
    hreserve(hbsz(2+1), 3); /* 3 live regs */
    *--hp = r[1];  
    *--hp = r[0];  
    *--hp = obj_from_case(18);
    r[3] = (hendblk(2+1));
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[3];  
    r[4+2] = r[1];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 18: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k c */
    { const char_t v2734_c = char_from_obj(r[3]);
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = (bool_from_obj(r[1]) ? (r[1]) : obj_from_bool(((v2734_c) == (41)) || (((v2734_c) == (40)) || (((v2734_c) == (93)) || (((v2734_c) == (91)) || (((v2734_c) == (34)) || ((v2734_c) == (59))))))));
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump; } 

case 19: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-token dot */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = obj_from_case(20);
    r[5] = (hendblk(3+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 20: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r port dot k */
    { const char_t v2733_c = (*stringref((r[1]), (0)));
    r[5] = obj_from_bool((isdigit((v2733_c))) || (((v2733_c) == (43)) || (((v2733_c) == (45)) || ((v2733_c) == (46))))); } 
  if (bool_from_obj(r[5])) {
    hreserve(hbsz(4+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(21);
    r[5] = (hendblk(4+1));
    r[6+0] = (cx_string_2D_3Efixnum);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = obj_from_fixnum(10);
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[5+0] = r[4];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = (mksymbol(internsym(stringchars((r[1])))));
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 21: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r port dot r k */
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(22);
    r[6] = (hendblk(4+1));
  if (bool_from_obj(r[1])) {
    r[0] = obj_from_ktrap();
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    goto s_l_v2571;
  } else {
    r[0] = (cx_string_2D_3Eflonum);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 22: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
s_l_v2571: /* ek r port dot r k */
  if (bool_from_obj(r[1])) {
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[5];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(23);
    r[6] = (hendblk(4+1));
    r[0] = (cx_member);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = r[4];  
    r[3] = (cx__2395);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 23: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r port dot k r */
  if (bool_from_obj(r[1])) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (mksymbol(internsym(stringchars((r[5])))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((strcmp(stringchars((r[5])), stringchars((cx__23125))) == 0)) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if (((stringlen((r[5]))) >= (2))) {
    { const char_t v2732_tmp = (*stringref((r[5]), (0)));
    r[6] = obj_from_bool((v2732_tmp) == (45)); } 
  if (bool_from_obj(r[6])) {
    { const char_t v2731_tmp = (*stringref((r[5]), (1)));
    r[6] = obj_from_bool((v2731_tmp) == (62)); } 
  } else {
    r[6] = obj_from_bool(0);
  }
  } else {
    r[6] = obj_from_bool(0);
  }
  if (bool_from_obj(r[6])) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (mksymbol(internsym(stringchars((r[5])))));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[4];  
    r[7+2] = (cx__23113);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }

case 24: /* clo k port */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k port sub-read-constituent read-dispatch-vector */
    { int c = fgetc(iportdata((r[1])));
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[4])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((((fixnum_t)char_from_obj(r[4])) < (128))) {
    r[5] = (objptr_from_obj(r[3])[0]);
    r[5] = (vectorref((r[5]), ((fixnum_t)char_from_obj(r[4]))));
    r[6+0] = r[5];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = r[4];  
    r[6+3] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((isalpha(char_from_obj(r[4])))) {
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = r[4];  
    r[5+3] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23410);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }

case 25: /* clo k port */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k port sub-read reader-token? */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_case(26);
    r[4] = (hendblk(3+1));
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 26: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r reader-token? port k */
  if ((iseof((r[1])))) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cx__23462);
    r[3] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_case(27);
    r[5] = (hendblk(3+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 27: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r r port k */
  if (bool_from_obj(r[1])) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6] = (cdr((r[2])));
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (cx__23459);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 28: /* clo k c port close-token */
    assert(rc == 5);
    { obj* p = objptr_from_obj(r[0]);
    r[1+4] = p[1];
    r[1+5] = p[2];
    r[1+6] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* k c port close-token sub-read-carefully sub-read dot */
    hreserve(hbsz(6+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(29);
    r[7] = (hendblk(6+1));
    r[8+0] = r[5];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 29: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek r sub-read-carefully sub-read close-token port k dot */
    r[8] = (objptr_from_obj(r[7])[0]);
    r[8] = obj_from_bool((r[1]) == (r[8]));
  if (bool_from_obj(r[8])) {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = (cx__23394);
    r[3] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[8+0] = r[6];  
    r[8+1] = r[1];  
    r[8+2] = r[2];  
    r[8+3] = r[3];  
    r[8+4] = r[7];  
    r[8+5] = r[4];  
    r[8+6] = r[5];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_recur;
  }

case 30: /* clo k form */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
s_recur: /* k form sub-read-carefully sub-read dot close-token port */
  if ((iseof((r[1])))) {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[6];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[0];  
    r[8+2] = (cx__23387);
    r[8+3] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if (((r[1]) == (r[5]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (mknull());
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[7] = (objptr_from_obj(r[4])[0]);
    r[7] = obj_from_bool((r[1]) == (r[7]));
  if (bool_from_obj(r[7])) {
    hreserve(hbsz(4+1), 7); /* 7 live regs */
    *--hp = r[5];  
    *--hp = r[0];  
    *--hp = r[6];  
    *--hp = r[3];  
    *--hp = obj_from_case(31);
    r[7] = (hendblk(4+1));
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[6];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(30);
    r[7] = (hendblk(5+1));
    hreserve(hbsz(3+1), 8); /* 8 live regs */
    *--hp = r[1];  
    *--hp = r[0];  
    *--hp = r[7];  
    *--hp = obj_from_case(33);
    r[7] = (hendblk(3+1));
    r[8+0] = r[3];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[6];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }
  }

case 31: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r sub-read port k close-token */
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(32);
    r[6] = (hendblk(4+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[6];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 32: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r port k r close-token */
  if (((r[1]) == (r[5]))) {
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[3];  
    r[7+2] = (cx__23378);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 33: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r recur k form */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(34);
    r[5] = (hendblk(2+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 34: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k form */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[1];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 35: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-list close-paren */
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = r[1];  
    r[5+3] = r[2];  
    r[5+4] = (objptr_from_obj(r[4])[0]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 36: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19];
    r[1+21] = p[20];
    r[1+22] = p[21];
    r[1+23] = p[22];
    r[1+24] = p[23];
    r[1+25] = p[24];
    r[1+26] = p[25]; }
    r += 1; /* shift reg. wnd */
    /* ek r make-reader-token sub-read-constituent sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? set-standard-syntax! decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? *char-name-table* *sharp-macros* read-terminating?-vector read-dispatch-vector dot close-bracket close-paren reader-token-marker *linefeed* */
    hreserve(hbsz(26+1), 27); /* 27 live regs */
    *--hp = (r[26]);
    *--hp = (r[25]);
    *--hp = (r[24]);
    *--hp = (r[23]);
    *--hp = r[1];  
    *--hp = (r[22]);
    *--hp = (r[21]);
    *--hp = (r[20]);
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(37);
    r[27] = (hendblk(26+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[27]);
    r[2] = (cx__23439);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 37: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19];
    r[1+21] = p[20];
    r[1+22] = p[21];
    r[1+23] = p[22];
    r[1+24] = p[23];
    r[1+25] = p[24];
    r[1+26] = p[25];
    r[1+27] = p[26]; }
    r += 1; /* shift reg. wnd */
    /* ek r make-reader-token sub-read-constituent sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? set-standard-syntax! decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? *char-name-table* *sharp-macros* read-terminating?-vector read-dispatch-vector dot r close-bracket close-paren reader-token-marker *linefeed* */
    hreserve(hbsz(26+1), 28); /* 28 live regs */
    *--hp = (r[27]);
    *--hp = (r[26]);
    *--hp = (r[25]);
    *--hp = r[1];  
    *--hp = (r[24]);
    *--hp = (r[23]);
    *--hp = (r[22]);
    *--hp = (r[21]);
    *--hp = (r[20]);
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(38);
    r[28] = (hendblk(26+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[28]);
    r[2] = (cx__23440);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 38: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19];
    r[1+21] = p[20];
    r[1+22] = p[21];
    r[1+23] = p[22];
    r[1+24] = p[23];
    r[1+25] = p[24];
    r[1+26] = p[25];
    r[1+27] = p[26]; }
    r += 1; /* shift reg. wnd */
    /* ek r sub-read-constituent sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? set-standard-syntax! decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? *char-name-table* *sharp-macros* read-terminating?-vector read-dispatch-vector dot r close-bracket r close-paren reader-token-marker *linefeed* */
    { /* cons */ 
    hreserve(hbsz(3), 28); /* 28 live regs */
    *--hp = (mknull());
    *--hp = (mksymbol(internsym("reader-token")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[28] = (hendblk(3)); }
    hreserve(hbsz(0+1), 29); /* 29 live regs */
    *--hp = obj_from_case(39);
    r[29] = (hendblk(0+1));
    { /* make-vector */
    obj o; int i = 0, c = (128);
    hreserve(hbsz(c+1), 30); /* 30 live regs */
    o = (r[29]); /* gc-safe */
    while (i++ < c) *--hp = o;
    *--hp = obj_from_size(VECTOR_BTAG);
    r[29] = (hendblk(c+1)); }
    { /* make-vector */
    obj o; int i = 0, c = (128);
    hreserve(hbsz(c+1), 30); /* 30 live regs */
    o = obj_from_bool(1); /* gc-safe */
    while (i++ < c) *--hp = o;
    *--hp = obj_from_size(VECTOR_BTAG);
    r[30] = (hendblk(c+1)); }
    { /* cons */ 
    hreserve(hbsz(3), 31); /* 31 live regs */
    *--hp = obj_from_char((char_t)(127));
    *--hp = (mksymbol(internsym("delete")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = (mknull());
    *--hp = (r[31]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(27));
    *--hp = (mksymbol(internsym("esc")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(12));
    *--hp = (mksymbol(internsym("page")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(11));
    *--hp = (mksymbol(internsym("vtab")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = (r[27]);
    *--hp = (mksymbol(internsym("linefeed")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = (r[27]);
    *--hp = (mksymbol(internsym("newline")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(9));
    *--hp = (mksymbol(internsym("tab")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(8));
    *--hp = (mksymbol(internsym("backspace")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(7));
    *--hp = (mksymbol(internsym("alarm")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char((char_t)(0));
    *--hp = (mksymbol(internsym("nul")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 32); /* 32 live regs */
    *--hp = obj_from_char(32);
    *--hp = (mksymbol(internsym("space")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[32] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 33); /* 33 live regs */
    *--hp = (r[31]);
    *--hp = (r[32]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[31] = (hendblk(3)); }
    (void)(objptr_from_obj(r[26])[0] = (r[28]));
    (void)(objptr_from_obj(r[25])[0] = (r[1]));
    (void)(objptr_from_obj(r[23])[0] = (r[24]));
    (void)(objptr_from_obj(r[21])[0] = (r[22]));
    (void)(objptr_from_obj(r[20])[0] = (r[29]));
    (void)(objptr_from_obj(r[19])[0] = (r[30]));
    (void)(objptr_from_obj(r[18])[0] = (mknull()));
    (void)(objptr_from_obj(r[17])[0] = (r[31]));
    hreserve(hbsz(20+1), 32); /* 32 live regs */
    *--hp = (r[25]);
    *--hp = (r[23]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = (r[17]);
    *--hp = (r[18]);
    *--hp = r[7];  
    *--hp = (r[27]);
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(41);
    r[32] = (hendblk(20+1));
    r[0] = (r[32]);
    r[1] = (cx__23813);
    r[2] = (r[15]);
    r[3] = (r[20]);
    goto s_loop_v2452;

case 39: /* clo k c port */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k c port */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    r[4+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = (cx__23410);
    r[4+3] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

s_loop_v2452: /* k id sub-read read-dispatch-vector */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[4] = (car((r[1])));
    r[5] = (objptr_from_obj(r[3])[0]);
    hreserve(hbsz(1+1), 6); /* 6 live regs */
    *--hp = r[2];  
    *--hp = obj_from_case(40);
    r[6] = (hendblk(1+1));
    (void)(vectorref((r[5]), fixnum_from_obj(r[4])) = (r[6]));
    r[4] = (cdr((r[1])));
    /* r[0] */    
    r[1] = r[4];  
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v2452;
  }

case 40: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read */
    r[4+0] = r[3];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = r[0];  
    r[4+2] = r[2];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 41: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19];
    r[1+21] = p[20]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read-constituent sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    { /* string-append */
    int *d = stringcat(stringdata((cx__23795)), stringdata((cx__23794)));
    r[22] = (hpushstr(22, d)); }
    { /* string->list */
    int c = (stringlen((r[22])));
    char *s; obj l = mknull();
    hreserve(hbsz(3)*c, 23); /* 23 live regs */
    s = stringchars((r[22])); /* gc-safe */
    while (c-- > 0) { *--hp = l; *--hp = obj_from_char(s[c]);
    *--hp = obj_from_size(PAIR_BTAG); l = hendblk(3); }
    r[22] = (l); }
    hreserve(hbsz(19+1), 23); /* 23 live regs */
    *--hp = (r[21]);
    *--hp = (r[20]);
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(44);
    r[23] = (hendblk(19+1));
    r[24+0] = (r[23]);
    r[24+1] = (r[22]);
    r[24+2] = r[8];  
    r[24+3] = r[2];  
    r += 24; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v2437;

case 42: /* clo k id */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v2437: /* k id set-standard-syntax! sub-read-constituent */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(42);
    r[4] = (hendblk(2+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(43);
    r[4] = (hendblk(3+1));
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = (car((r[1])));
    r[5+3] = obj_from_bool(0);
    r[5+4] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 43: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop id k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 44: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(19+1), 21); /* 21 live regs */
    *--hp = (r[20]);
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(45);
    r[21] = (hendblk(19+1));
    r[0] = r[7];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[21]);
    r[2] = obj_from_char(40);
    r[3] = obj_from_bool(1);
    r[4] = (r[12]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 45: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18];
    r[1+20] = p[19]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read-list reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 21); /* 21 live regs */
    *--hp = (r[20]);
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(46);
    r[21] = (hendblk(18+1));
    hreserve(hbsz(2+1), 22); /* 22 live regs */
    *--hp = (r[19]);
    *--hp = r[2];  
    *--hp = obj_from_case(125);
    r[22] = (hendblk(2+1));
    r[23+0] = r[7];  
    pc = objptr_from_obj(r[23+0])[0];
    r[23+1] = (r[21]);
    r[23+2] = obj_from_char(91);
    r[23+3] = obj_from_bool(1);
    r[23+4] = (r[22]);
    r += 23; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 46: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(47);
    r[20] = (hendblk(18+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = (r[19]);
    *--hp = obj_from_case(124);
    r[21] = (hendblk(1+1));
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[20]);
    r[2] = obj_from_char(41);
    r[3] = obj_from_bool(1);
    r[4] = (r[21]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 47: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(48);
    r[20] = (hendblk(18+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = (r[18]);
    *--hp = obj_from_case(123);
    r[21] = (hendblk(1+1));
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[20]);
    r[2] = obj_from_char(93);
    r[3] = obj_from_bool(1);
    r[4] = (r[21]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 48: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(49);
    r[20] = (hendblk(18+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(121);
    r[21] = (hendblk(1+1));
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[20]);
    r[2] = obj_from_char(39);
    r[3] = obj_from_bool(1);
    r[4] = (r[21]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 49: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(50);
    r[20] = (hendblk(18+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(119);
    r[21] = (hendblk(1+1));
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[20]);
    r[2] = obj_from_char(96);
    r[3] = obj_from_bool(1);
    r[4] = (r[21]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 50: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(18+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(51);
    r[20] = (hendblk(18+1));
    hreserve(hbsz(1+1), 21); /* 21 live regs */
    *--hp = (r[13]);
    *--hp = obj_from_case(116);
    r[21] = (hendblk(1+1));
    r[0] = r[6];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[20]);
    r[2] = obj_from_char(44);
    r[3] = obj_from_bool(1);
    r[4] = (r[21]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 51: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15];
    r[1+17] = p[16];
    r[1+18] = p[17];
    r[1+19] = p[18]; }
    r += 1; /* shift reg. wnd */
    /* ek  reverse-list->string char-semicolon? char-unicode-whitespace? *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(15+1), 20); /* 20 live regs */
    *--hp = (r[19]);
    *--hp = (r[18]);
    *--hp = (r[17]);
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(52);
    r[20] = (hendblk(15+1));
    hreserve(hbsz(5+1), 21); /* 21 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[9];  
    *--hp = r[2];  
    *--hp = obj_from_case(109);
    r[21] = (hendblk(5+1));
    r[22+0] = r[6];  
    pc = objptr_from_obj(r[22+0])[0];
    r[22+1] = (r[20]);
    r[22+2] = obj_from_char(34);
    r[22+3] = obj_from_bool(1);
    r[22+4] = (r[21]);
    r += 22; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 52: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14];
    r[1+16] = p[15]; }
    r += 1; /* shift reg. wnd */
    /* ek  *linefeed* set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(14+1), 17); /* 17 live regs */
    *--hp = (r[16]);
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(53);
    r[17] = (hendblk(14+1));
    hreserve(hbsz(2+1), 18); /* 18 live regs */
    *--hp = (r[13]);
    *--hp = r[2];  
    *--hp = obj_from_case(107);
    r[18] = (hendblk(2+1));
    r[19+0] = r[3];  
    pc = objptr_from_obj(r[19+0])[0];
    r[19+1] = (r[17]);
    r[19+2] = obj_from_char(59);
    r[19+3] = obj_from_bool(1);
    r[19+4] = (r[18]);
    r += 19; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 53: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12];
    r[1+14] = p[13];
    r[1+15] = p[14]; }
    r += 1; /* shift reg. wnd */
    /* ek  set-standard-syntax! *sharp-macros* *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 16); /* 16 live regs */
    *--hp = (r[15]);
    *--hp = (r[14]);
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(54);
    r[16] = (hendblk(12+1));
    hreserve(hbsz(1+1), 17); /* 17 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(105);
    r[17] = (hendblk(1+1));
    r[18+0] = r[2];  
    pc = objptr_from_obj(r[18+0])[0];
    r[18+1] = (r[16]);
    r[18+2] = obj_from_char(35);
    r[18+3] = obj_from_bool(0);
    r[18+4] = (r[17]);
    r += 18; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 54: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(55);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(104);
    r[15] = (hendblk(0+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(102);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 55: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(56);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(0+1), 15); /* 15 live regs */
    *--hp = obj_from_case(103);
    r[15] = (hendblk(0+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(116);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 56: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(57);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(1+1), 15); /* 15 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(101);
    r[15] = (hendblk(1+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(39);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 57: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(58);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(1+1), 15); /* 15 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(99);
    r[15] = (hendblk(1+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(96);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 58: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(59);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(1+1), 15); /* 15 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(96);
    r[15] = (hendblk(1+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(44);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 59: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(60);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(1+1), 15); /* 15 live regs */
    *--hp = r[7];  
    *--hp = obj_from_case(94);
    r[15] = (hendblk(1+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(38);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 60: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(61);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(1+1), 15); /* 15 live regs */
    *--hp = (r[10]);
    *--hp = obj_from_case(90);
    r[15] = (hendblk(1+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(124);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 61: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(12+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(62);
    r[14] = (hendblk(12+1));
    hreserve(hbsz(2+1), 15); /* 15 live regs */
    *--hp = (r[10]);
    *--hp = r[7];  
    *--hp = obj_from_case(88);
    r[15] = (hendblk(2+1));
    r[0] = r[8];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[14]);
    r[2] = obj_from_char(59);
    r[3] = (r[15]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 62: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10];
    r[1+12] = p[11];
    r[1+13] = p[12]; }
    r += 1; /* shift reg. wnd */
    /* ek  *char-name-table* decode-hex-digits delimiter? sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(9+1), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = (r[12]);
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(63);
    r[14] = (hendblk(9+1));
    hreserve(hbsz(4+1), 15); /* 15 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[7];  
    *--hp = obj_from_case(84);
    r[15] = (hendblk(4+1));
    r[16+0] = r[8];  
    pc = objptr_from_obj(r[16+0])[0];
    r[16+1] = (r[14]);
    r[16+2] = obj_from_char(92);
    r[16+3] = (r[15]);
    r += 16; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 63: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read-list-paren proper-list? sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(7+1), 11); /* 11 live regs */
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(64);
    r[11] = (hendblk(7+1));
    hreserve(hbsz(2+1), 12); /* 12 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(81);
    r[12] = (hendblk(2+1));
    r[13+0] = r[5];  
    pc = objptr_from_obj(r[13+0])[0];
    r[13+1] = (r[11]);
    r[13+2] = obj_from_char(40);
    r[13+3] = (r[12]);
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 64: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read-carefully set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(70);
    r[9] = (hendblk(6+1));
    r[10+0] = r[9];  
    r[10+1] = (cx__23522);
    r[10+2] = r[3];  
    r[10+3] = r[2];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v2308;

case 65: /* clo k id */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v2308: /* k id set-sharp-macro! sub-read-carefully */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(65);
    r[4] = (hendblk(2+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(66);
    r[4] = (hendblk(3+1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(67);
    r[5] = (hendblk(1+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (car((r[1])));
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 66: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop id k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 67: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { int c = fgetc(iportdata((r[2])));
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
    r[5+0] = r[0];  
    r[5+1] = obj_from_fixnum(0);
    r[5+2] = r[4];  
    r[5+3] = r[3];  
    r[5+4] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v2311;

s_loop_v2311: /* k n c sub-read-carefully port */
    { const char_t v2730_c = char_from_obj(r[2]);
  if ((isdigit((v2730_c)))) {
    { int c = fgetc(iportdata((r[4])));
    r[5] = (c == EOF ? mkeof() : obj_from_char(c)); }
    /* r[0] */    
    r[1] = obj_from_fixnum((fixnum_from_obj(r[1]) * (10)) + (((fixnum_t)(v2730_c)) - ((fixnum_t)(48))));
    r[2] = r[5];  
    /* r[3] */    
    /* r[4] */    
    goto s_loop_v2311;
  } else {
  if (((v2730_c) == (39))) {
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = obj_from_case(68);
    r[5] = (hendblk(2+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[4];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[4];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23555);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  } } 

case 68: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r n k */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(69);
    r[5] = (hendblk(2+1));
    r[0] = r[5];  
    r[1] = r[2];  
    r[2] = (mknull());
    goto s_loop_v2320;

s_loop_v2320: /* k i l */
    { const fixnum_t v2729_i = fixnum_from_obj(r[1]);
  if (((v2729_i) == 0)) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = r[2];  
    *--hp = (mksymbol(internsym("?")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    /* r[0] */    
    r[1] = obj_from_fixnum((v2729_i) - (1));
    r[2] = r[3];  
    goto s_loop_v2320;
  } } 

case 69: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = (mksymbol(internsym("function")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 70: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6]; }
    r += 1; /* shift reg. wnd */
    /* ek  set-sharp-macro! sub-read-token sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(77);
    r[8] = (hendblk(4+1));
    r[0] = r[8];  
    r[1] = (cx__23499);
    /* r[2] */    
    /* r[3] */    
    goto s_loop_v2267;

case 71: /* clo k id */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v2267: /* k id set-sharp-macro! sub-read-token */
  if ((isnull((r[1])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = ((0) ? obj_from_bool(0) : obj_from_void(0));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(71);
    r[4] = (hendblk(2+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(72);
    r[4] = (hendblk(3+1));
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(73);
    r[5] = (hendblk(1+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (car((r[1])));
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 72: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  loop id k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = (cdr((r[3])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 73: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-token */
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = obj_from_case(74);
    r[4] = (hendblk(2+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = obj_from_char(35);
    r[5+3] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 74: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r port k */
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_case(75);
    r[4] = (hendblk(3+1));
    r[5+0] = (cx_string_2D_3Efixnum);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[1];  
    r[5+3] = obj_from_fixnum(10);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 75: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r r port k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(76);
    r[5] = (hendblk(3+1));
  if (bool_from_obj(r[1])) {
    r[0] = obj_from_ktrap();
    /* r[1] */    
    /* r[2] */    
    /* r[3] */    
    /* r[4] */    
    goto s_l_v2275;
  } else {
    r[0] = (cx_string_2D_3Eflonum);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    /* r[2] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 76: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_l_v2275: /* ek r r port k */
  if (bool_from_obj(r[1])) {
    r[5+0] = r[4];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[1];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[4];  
    r[6+2] = (cx__23113);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 77: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(4+1), 6); /* 6 live regs */
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = r[2];  
    *--hp = obj_from_case(78);
    cx_q_2Dread_2F1 = (hendblk(4+1));
    r[6+0] = r[0];
    pc = 0; /* exit from module init */
    r[6+1] = obj_from_void(0);
    r += 6; /* shift reg wnd */
    assert(rc = 2);
    goto jump;

case 78: /* clo k port */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k port sub-read reader-token? close-bracket close-paren */
    hreserve(hbsz(5+1), 6); /* 6 live regs */
    *--hp = r[0];  
    *--hp = r[5];  
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(79);
    r[6] = (hendblk(5+1));
    r[7+0] = r[2];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[6];  
    r[7+2] = r[1];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 79: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r reader-token? close-bracket port close-paren k */
    hreserve(hbsz(5+1), 7); /* 7 live regs */
    *--hp = r[1];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(80);
    r[7] = (hendblk(5+1));
    r[8+0] = r[2];  
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[7];  
    r[8+2] = r[1];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 80: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r close-bracket port close-paren k r */
  if ((!bool_from_obj(r[1]))) {
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[7] = (objptr_from_obj(r[4])[0]);
    r[7] = obj_from_bool((r[6]) == (r[7]));
  if (bool_from_obj(r[7])) {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cx__23480);
    r[3] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[7] = (objptr_from_obj(r[2])[0]);
    r[7] = obj_from_bool((r[6]) == (r[7]));
  if (bool_from_obj(r[7])) {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cx__23475);
    r[3] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8] = (cdr((r[6])));
    { /* cons */ 
    hreserve(hbsz(3), 9); /* 9 live regs */
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = (cx__23472);
    r[3] = r[7];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }

case 81: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-list-paren proper-list? */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(82);
    r[5] = (hendblk(3+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;

case 82: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r proper-list? port k */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(83);
    r[5] = (hendblk(3+1));
    r[6+0] = r[2];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[1];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 83: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r port k r */
  if (bool_from_obj(r[1])) {
    { fixnum_t v2728_tmp;
    { /* length */
    int n; obj l = r[4];  
    for (n = 0; l != mknull(); ++n, l = cdr(l)) ;
    v2728_tmp = (n); }
    { /* list->vector */
    obj l; int i, c = (v2728_tmp);
    hreserve(hbsz(c+1), 5); /* 5 live regs */
    l = r[4];   /* gc-safe */
    for (i = 0; i < c; ++i, l = cdr(l)) hp[i-c] = car(l);
    hp -= c; *--hp = obj_from_size(VECTOR_BTAG);
    r[5] = (hendblk(c+1)); } }
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = (cx__23593);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 84: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully *char-name-table* decode-hex-digits delimiter? */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[7] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[7])))) {
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[8] = (hendblk(3)); }
    r[9+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[0];  
    r[9+2] = (cx__23620);
    r[9+3] = r[8];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if (((120) == char_from_obj(r[7]))) {
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(5+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = obj_from_case(85);
    r[8] = (hendblk(5+1));
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[9] = (c == EOF ? mkeof() : obj_from_char(c)); }
    r[10+0] = r[6];  
    pc = objptr_from_obj(r[10+0])[0];
    r[10+1] = r[8];  
    r[10+2] = r[9];  
    r += 10; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((isalpha(char_from_obj(r[7])))) {
    hreserve(hbsz(4+1), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = r[2];  
    *--hp = obj_from_case(87);
    r[8] = (hendblk(4+1));
    r[9+0] = r[3];  
    pc = objptr_from_obj(r[9+0])[0];
    r[9+1] = r[8];  
    r[9+2] = r[2];  
    r += 9; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[8] = r[7];  
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[8];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }
  }

case 85: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* ek r decode-hex-digits delimiter? port k c */
  if (bool_from_obj(r[1])) {
    r[0] = r[5];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[6];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 7); /* 7 live regs */
    *--hp = r[3];  
    *--hp = obj_from_case(86);
    r[7] = (hendblk(1+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[4];  
    r[3] = r[7];  
    r[4] = (cx__23614);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  }

case 86: /* clo k c */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c delimiter? */
  if ((iseof((r[1])))) {
    r[3+0] = r[0];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = obj_from_ktrap();
    r[3+2] = obj_from_bool(iseof((r[1])));
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[3+0] = r[2];  
    pc = objptr_from_obj(r[3+0])[0];
    r[3+1] = r[0];  
    r[3+2] = r[1];  
    r += 3; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 87: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
    /* ek r port *char-name-table* k c */
    { fixnum_t v2727_tmp;
    r[6] = (hpushstr(6, newstring(symbolname(getsymbol((r[1]))))));
    v2727_tmp = (stringlen((r[6])));
    r[6] = obj_from_bool((v2727_tmp) == (1)); }
  if (bool_from_obj(r[6])) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    r[6] = (objptr_from_obj(r[3])[0]);
    { /* assq */
    obj x = (r[1]), l = (r[6]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[6] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[6])) {
    r[0] = r[4];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (cdr((r[6])));
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 8); /* 8 live regs */
    *--hp = r[7];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[7] = (hendblk(3)); }
    r[8+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[8+0])[0];
    r[8+1] = r[4];  
    r[8+2] = (cx__23609);
    r[8+3] = r[7];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }

case 88: /* clo k char port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k char port sub-read-carefully sub-read */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(89);
    r[5] = (hendblk(3+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 89: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read port k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 90: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(93);
    r[4] = (hendblk(3+1));
    r[0] = r[4];  
    r[1] = r[2];  
    goto s_recur_v2158;

case 91: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1]; }
    r += 1; /* shift reg. wnd */
s_recur_v2158: /* k port */
    hreserve(hbsz(1+1), 2); /* 2 live regs */
    *--hp = r[1];  
    *--hp = obj_from_case(91);
    r[2] = (hendblk(1+1));
    { int c = fgetc(iportdata((r[1])));
    r[3] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[3])))) {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (cx__23638);
    r[5+3] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[3]) == (124))) {
    { FILE *p = iportdata((r[1])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23638);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[4]) == (35))) {
    { int c = fgetc(iportdata((r[1])));
    r[5] = (c == EOF ? mkeof() : obj_from_char(c)); }
    r[6+0] = r[0];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = obj_from_ktrap();
    r[6+2] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    /* r[0] */    
    /* r[1] */    
    goto s_recur_v2158;
  }
  }
  } else {
  if ((char_from_obj(r[3]) == (35))) {
    { FILE *p = iportdata((r[1])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23638);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[4]) == (124))) {
    { int c = fgetc(iportdata((r[1])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = obj_from_case(92);
    r[5] = (hendblk(2+1));
    r[0] = r[5];  
    /* r[1] */    
    goto s_recur_v2158;
  } else {
    /* r[0] */    
    /* r[1] */    
    goto s_recur_v2158;
  }
  }
  } else {
    /* r[0] */    
    /* r[1] */    
    goto s_recur_v2158;
  }
  }
  }

case 92: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek  recur k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;

case 93: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read port k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 94: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[6+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[0];  
    r[6+2] = (cx__23664);
    r[6+3] = r[5];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(1+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(95);
    r[5] = (hendblk(1+1));
    r[6+0] = r[3];  
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[5];  
    r[6+2] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 95: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* box */ 
    hreserve(hbsz(2), 3); /* 3 live regs */
    *--hp = r[1];  
    *--hp = obj_from_size(BOX_BTAG); 
    r[3] = (hendblk(2)); }
    r[4+0] = r[2];  
    pc = objptr_from_obj(r[4+0])[0];
    r[4+1] = obj_from_ktrap();
    r[4+2] = r[3];  
    r += 4; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 96: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(97);
    r[5] = (hendblk(3+1));
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[5];  
    r[7+2] = (cx__23677);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[4]) == (64))) {
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[6] = (mksymbol(internsym("unsyntax-splicing")));
  } else {
    r[6] = (mksymbol(internsym("unsyntax")));
  }
    r[7+0] = obj_from_ktrap();
    r[7+1] = r[6];  
    r[7+2] = r[3];  
    r[7+3] = r[2];  
    r[7+4] = r[0];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v2115;
  }

case 97: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_l_v2115: /* ek r sub-read-carefully port k */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(98);
    r[5] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 98: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 99: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(100);
    r[4] = (hendblk(1+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 100: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("quasisyntax")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 101: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(102);
    r[4] = (hendblk(1+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 102: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("syntax")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 103: /* clo k c port */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k c port */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[3] = obj_from_bool(1);
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 104: /* clo k c port */
    assert(rc == 4);
    r += 1; /* shift reg. wnd */
    /* k c port */
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[3] = obj_from_bool(0);
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 105: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port *sharp-macros* */
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[3];  
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = obj_from_case(106);
    r[5] = (hendblk(3+1));
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[5];  
    r[7+2] = (cx__23713);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[6+0] = obj_from_ktrap();
    r[6+1] = obj_from_char(tolower(char_from_obj(r[4])));
    r[6+2] = r[2];  
    r[6+3] = r[0];  
    r[6+4] = r[3];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v2047;
  }

case 106: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_l_v2047: /* ek r port k *sharp-macros* */
    r[5] = (objptr_from_obj(r[4])[0]);
    { /* assq */
    obj x = (r[1]), l = (r[5]), p = mknull();
    for (; l != mknull(); l = cdr(l)) { p = car(l); if (car(p) == x) break; }
    r[5] = (l == mknull() ? obj_from_bool(0) : p); }
  if (bool_from_obj(r[5])) {
    r[6+0] = (cdr((r[5])));
    pc = objptr_from_obj(r[6+0])[0];
    r[6+1] = r[3];  
    r[6+2] = r[1];  
    r[6+3] = r[2];  
    r += 6; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 7); /* 7 live regs */
    *--hp = r[6];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[3];  
    r[7+2] = (cx__23723);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 107: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c port *linefeed* sub-read */
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[4];  
    *--hp = obj_from_case(108);
    r[5] = (hendblk(3+1));
    r[0] = r[5];  
    r[1] = r[3];  
    /* r[2] */    
    goto s_loop_v2033;

s_loop_v2033: /* k *linefeed* port */
    { int c = fgetc(iportdata((r[2])));
    r[3] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[3])))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((char_from_obj(r[3]) == char_from_obj(r[1]))) {
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
    /* r[0] */    
    /* r[1] */    
    /* r[2] */    
    goto s_loop_v2033;
  }
  }

case 108: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek  sub-read port k */
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[4];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 109: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5]; }
    r += 1; /* shift reg. wnd */
    /* k c port reverse-list->string decode-hex-digits char-semicolon? char-unicode-whitespace? *linefeed* */
    r[8+0] = r[0];  
    r[8+1] = (mknull());
    r[8+2] = obj_from_fixnum(0);
    r[8+3] = r[3];  
    r[8+4] = r[4];  
    r[8+5] = r[5];  
    r[8+6] = r[6];  
    r[8+7] = r[7];  
    r[8+8] = r[2];  
    r += 8; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_loop_v1983;

case 110: /* clo k l i */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2];
    r[1+5] = p[3];
    r[1+6] = p[4];
    r[1+7] = p[5];
    r[1+8] = p[6]; }
    r += 1; /* shift reg. wnd */
s_loop_v1983: /* k l i reverse-list->string decode-hex-digits char-semicolon? char-unicode-whitespace? *linefeed* port */
    hreserve(hbsz(6+1), 9); /* 9 live regs */
    *--hp = r[8];  
    *--hp = r[7];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_case(110);
    r[9] = (hendblk(6+1));
    { int c = fgetc(iportdata((r[8])));
    r[10] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[10])))) {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    r[12+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[12+0])[0];
    r[12+1] = r[0];  
    r[12+2] = (cx__23334);
    r[12+3] = (r[11]);
    r += 12; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[10]) == (92))) {
    { int c = fgetc(iportdata((r[8])));
    r[11] = (c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(10+1), 12); /* 12 live regs */
    *--hp = r[0];  
    *--hp = r[1];  
    *--hp = r[2];  
    *--hp = r[9];  
    *--hp = (r[11]);
    *--hp = r[7];  
    *--hp = r[8];  
    *--hp = r[6];  
    *--hp = r[5];  
    *--hp = r[4];  
    *--hp = obj_from_case(111);
    r[12] = (hendblk(10+1));
  if ((iseof((r[11])))) {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[8];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = (cx__23334);
    r[3] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[13+0] = obj_from_ktrap();
    r[13+1] = obj_from_void(0);
    r[13+2] = r[4];  
    r[13+3] = r[5];  
    r[13+4] = r[6];  
    r[13+5] = r[8];  
    r[13+6] = r[7];  
    r[13+7] = (r[11]);
    r[13+8] = r[9];  
    r[13+9] = r[2];  
    r[13+10] = r[1];  
    r[13+11] = r[0];  
    r += 13; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v1985;
  }
  } else {
  if ((char_from_obj(r[10]) == (34))) {
    r[11+0] = r[3];  
    pc = objptr_from_obj(r[11+0])[0];
    r[11+1] = r[0];  
    r[11+2] = r[1];  
    r[11+3] = r[2];  
    r += 11; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 11); /* 11 live regs */
    *--hp = r[1];  
    *--hp = (r[10]);
    *--hp = obj_from_size(PAIR_BTAG); 
    r[11] = (hendblk(3)); }
    /* r[0] */    
    r[1] = (r[11]);
    r[2] = obj_from_fixnum(fixnum_from_obj(r[2]) + (1));
    /* r[3] */    
    /* r[4] */    
    /* r[5] */    
    /* r[6] */    
    /* r[7] */    
    /* r[8] */    
    goto s_loop_v1983;
  }
  }
  }

case 111: /* clo ek  */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4];
    r[1+6] = p[5];
    r[1+7] = p[6];
    r[1+8] = p[7];
    r[1+9] = p[8];
    r[1+10] = p[9];
    r[1+11] = p[10]; }
    r += 1; /* shift reg. wnd */
s_l_v1985: /* ek  decode-hex-digits char-semicolon? char-unicode-whitespace? port *linefeed* c loop i l k */
    hreserve(hbsz(4+1), 12); /* 12 live regs */
    *--hp = (r[11]);
    *--hp = (r[10]);
    *--hp = r[9];  
    *--hp = r[8];  
    *--hp = obj_from_case(112);
    r[12] = (hendblk(4+1));
  if (((char_from_obj(r[7]) == (92)) || (char_from_obj(r[7]) == (34)))) {
    r[0] = obj_from_ktrap();
    r[1] = r[7];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == char_from_obj(r[6]))) {
    r[0] = (r[12]);
    r[1] = r[4];  
    r[2] = r[5];  
    goto s_loop_v1992;
  } else {
  if ((char_from_obj(r[7]) == (97))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(7));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (98))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(8));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (116))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(9));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (110))) {
    r[0] = obj_from_ktrap();
    r[1] = r[6];  
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (118))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(11));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (102))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(12));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (114))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(13));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (101))) {
    r[0] = obj_from_ktrap();
    r[1] = obj_from_char((char_t)(27));
    r[2] = r[8];  
    r[3] = r[9];  
    r[4] = (r[10]);
    r[5] = (r[11]);
    goto s_l_v2002;
  } else {
  if ((char_from_obj(r[7]) == (120))) {
    hreserve(hbsz(2+1), 13); /* 13 live regs */
    *--hp = r[5];  
    *--hp = (r[12]);
    *--hp = obj_from_case(115);
    r[13] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[13]);
    r[2] = r[5];  
    /* r[3] */    
    r[4] = (cx__23308);
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;
  } else {
    { /* cons */ 
    hreserve(hbsz(3), 13); /* 13 live regs */
    *--hp = (mknull());
    *--hp = r[5];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 14); /* 14 live regs */
    *--hp = (r[13]);
    *--hp = r[7];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[13] = (hendblk(3)); }
    r[0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[0])[0];
    r[1] = (r[12]);
    r[2] = (cx__23307);
    r[3] = (r[13]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }
  }

case 112: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3];
    r[1+5] = p[4]; }
    r += 1; /* shift reg. wnd */
s_l_v2002: /* ek r loop i l k */
  if (bool_from_obj(r[1])) {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = r[4];  
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = r[2];  
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[5];  
    r[7+2] = r[6];  
    r[7+3] = obj_from_fixnum(fixnum_from_obj(r[3]) + (1));
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[4];  
    /* r[3] */    
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  }

case 113: /* clo k */
    assert(rc == 2);
    { obj* p = objptr_from_obj(r[0]);
    r[1+1] = p[1];
    r[1+2] = p[2]; }
    r += 1; /* shift reg. wnd */
s_loop_v1992: /* k char-unicode-whitespace? port */
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[3] = (c == EOF ? mkeof() : obj_from_char(c)); }
  if ((iseof((r[3])))) {
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[5+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = (cx__23334);
    r[5+3] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
    hreserve(hbsz(2+1), 4); /* 4 live regs */
    *--hp = r[2];  
    *--hp = r[1];  
    *--hp = obj_from_case(113);
    r[4] = (hendblk(2+1));
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[2];  
    *--hp = r[0];  
    *--hp = r[4];  
    *--hp = obj_from_case(114);
    r[4] = (hendblk(3+1));
    r[5+0] = r[1];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[3];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 114: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
    /* ek r loop k port */
  if (bool_from_obj(r[1])) {
    { int c = fgetc(iportdata((r[4])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 2);
    goto jump;
  } else {
    r[0] = r[3];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = obj_from_bool(0);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }

case 115: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k port */
    { int c = fgetc(iportdata((r[3])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[4] = r[1];  
    r[5+0] = r[2];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = obj_from_ktrap();
    r[5+2] = r[4];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 116: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    { FILE *p = iportdata((r[2])); int c = fgetc(p); ungetc(c, p);
    r[4] = (c == EOF ? mkeof() : obj_from_char(c)); }
    hreserve(hbsz(3+1), 5); /* 5 live regs */
    *--hp = r[0];  
    *--hp = r[2];  
    *--hp = r[3];  
    *--hp = obj_from_case(117);
    r[5] = (hendblk(3+1));
  if ((iseof((r[4])))) {
    { /* cons */ 
    hreserve(hbsz(3), 6); /* 6 live regs */
    *--hp = (mknull());
    *--hp = r[2];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[6] = (hendblk(3)); }
    r[7+0] = (cx_r_2Derror_2A);
    pc = objptr_from_obj(r[7+0])[0];
    r[7+1] = r[5];  
    r[7+2] = (cx__23677);
    r[7+3] = r[6];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 4);
    goto jump;
  } else {
  if ((char_from_obj(r[4]) == (64))) {
    { int c = fgetc(iportdata((r[2])));
    (void)(c == EOF ? mkeof() : obj_from_char(c)); }
    r[6] = (mksymbol(internsym("unquote-splicing")));
  } else {
    r[6] = (mksymbol(internsym("unquote")));
  }
    r[7+0] = obj_from_ktrap();
    r[7+1] = r[6];  
    r[7+2] = r[3];  
    r[7+3] = r[2];  
    r[7+4] = r[0];  
    r += 7; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    goto s_l_v1962;
  }

case 117: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2];
    r[1+4] = p[3]; }
    r += 1; /* shift reg. wnd */
s_l_v1962: /* ek r sub-read-carefully port k */
    hreserve(hbsz(2+1), 5); /* 5 live regs */
    *--hp = r[1];  
    *--hp = r[4];  
    *--hp = obj_from_case(118);
    r[5] = (hendblk(2+1));
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = r[5];  
    r[2] = r[3];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 118: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1];
    r[1+3] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* ek r k r */
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 5); /* 5 live regs */
    *--hp = r[4];  
    *--hp = r[3];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[5] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[5];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 119: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(120);
    r[4] = (hendblk(1+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 120: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("quasiquote")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 121: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-carefully */
    hreserve(hbsz(1+1), 4); /* 4 live regs */
    *--hp = r[0];  
    *--hp = obj_from_case(122);
    r[4] = (hendblk(1+1));
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[4];  
    r[5+2] = r[2];  
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 122: /* clo ek r */
    assert(rc == 3);
    { obj* p = objptr_from_obj(r[0]);
    r[1+2] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* ek r k */
    { /* cons */ 
    hreserve(hbsz(3), 3); /* 3 live regs */
    *--hp = (mknull());
    *--hp = r[1];  
    *--hp = obj_from_size(PAIR_BTAG); 
    r[3] = (hendblk(3)); }
    { /* cons */ 
    hreserve(hbsz(3), 4); /* 4 live regs */
    *--hp = r[3];  
    *--hp = (mksymbol(internsym("quote")));
    *--hp = obj_from_size(PAIR_BTAG); 
    r[4] = (hendblk(3)); }
    r[0] = r[2];  
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = r[4];  
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 123: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port close-bracket */
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 124: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1]; }
    r += 1; /* shift reg. wnd */
    /* k c port close-paren */
    /* r[0] */    
    pc = objptr_from_obj(r[0])[0];
    r[1] = obj_from_ktrap();
    r[2] = (objptr_from_obj(r[3])[0]);
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;

case 125: /* clo k c port */
    assert(rc == 4);
    { obj* p = objptr_from_obj(r[0]);
    r[1+3] = p[1];
    r[1+4] = p[2]; }
    r += 1; /* shift reg. wnd */
    /* k c port sub-read-list close-bracket */
    r[5+0] = r[3];  
    pc = objptr_from_obj(r[5+0])[0];
    r[5+1] = r[0];  
    r[5+2] = r[1];  
    r[5+3] = r[2];  
    r[5+4] = (objptr_from_obj(r[4])[0]);
    r += 5; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 5);
    goto jump;

case 126: /* clo k x */
    assert(rc == 3);
    r += 1; /* shift reg. wnd */
s_proper_2Dlist_3F: /* k x */
  if ((isnull((r[1])))) {
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = obj_from_bool(1);
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  } else {
  if ((ispair((r[1])))) {
    r[2] = (cdr((r[1])));
    /* r[0] */    
    r[1] = r[2];  
    goto s_proper_2Dlist_3F;
  } else {
    r[2+0] = r[0];  
    pc = objptr_from_obj(r[2+0])[0];
    r[2+1] = obj_from_ktrap();
    r[2+2] = obj_from_bool(0);
    r += 2; /* shift reg wnd */
    rreserve(MAX_LIVEREGS);
    assert(rc = 3);
    goto jump;
  }
  }

default: /* inter-host call */
    cxg_hp = hp;
    cxm_rgc(r, r + MAX_LIVEREGS);
#ifndef NDEBUG
    cxg_rc = rc;
#endif
    return pc;
  }
}

/* module load */
void MODULE(void)
{
  obj pc;
  if (!root.next) {
    root.next = cxg_rootp;
    cxg_rootp = &root;
    LOAD();
    pc = obj_from_case(0);
    assert((cxg_rc = 0, 1));
    while (pc) pc = (*(cxhost_t*)pc)(pc); 
    assert(cxg_rc == 2);
  }
}
